#include <time.h>
#include <sys/types.h>
#include <stdio.h>
#include <ctype.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <signal.h>
#include "haven.h"
    
int port;
int sock;
int signalmask;
void handler();
void prehandler();
extern void syncrestrict(), syncname(), syncmail();
extern void punt();
extern void onerror();
extern void syncscore();
extern int clearboard();
int maxconn;
int maxcap;
int hc_port;
long uptime;
char *utime;
char hc_name[80];
int reboot = 0;

int main(argc, argv)
     int argc;
     char **argv;
{
  struct timezone tmpz;
  struct timeval tmpv;
  time_t now = time(0);
  struct rlimit limits;
  
  if (argc == 1) {
    fprintf(stderr, "USAGE: %s [-d] portnum\n", *argv);
    exit(1);
  }
  
  prehandler();

  strcpy(hc_name, *argv);
  gettimeofday(&tmpv, &tmpz);
  uptime = tmpv.tv_sec;
  utime = ctime(&now);
  utime[16] = '\0';

  system("remwho");
  syncrestrict();
  printf("IllusionCORE:  Restriction file loaded.\r\n");
  syncban();
  printf("IllusionCORE:  Ban file loaded.\r\n");
  synclewd();
  printf("IllusionCORE:  Lewd name list loaded.\r\n");
  syncfriend();
  printf("IllusionCORE:  friend list loaded.\r\n");
  syncname();
  printf("IllusionCORE:  registry loaded.\r\n");
  syncmail();
  printf("IllusionCORE:  mail structure loaded.\r\n");
  syncroom();
  printf("IllusionCORE:  room descriptions loaded.\r\n");
  syncmess();
  syncmess2();
  syncmess3();
  syncmess4();
  printf("IllusionCORE:  bulletin board loaded.\r\n");
  syncscore();
  printf("IllusionCORE:  hi score file loaded.\r\n");
  syncobject();
  printf("IllusionCORE:  object file loaded.\r\n");
  syncaction();
  printf("IllusionCORE:  action file loaded.\r\n");
  syncverb();
  printf("IllusionCORE:  verb file loaded.\r\n");
  printf("IllusionCORE:  Make sure loop and hotup are active!!!\r\n");
  clearboard();

#ifndef RLIMIT_NOFILE
#define RLIMIT_NOFILE	6
#endif
  getrlimit(RLIMIT_NOFILE, &limits);
  limits.rlim_cur = limits.rlim_max;
  setrlimit(RLIMIT_NOFILE, &limits);
  getrlimit(RLIMIT_NOFILE, &limits);
  maxconn = limits.rlim_cur;
  if (maxconn == 0) maxconn = 64;  /* oh shit... pray for the best here */
  printf("Max connections %d.\r\nAccepting %d.\r\n", maxconn,MAXCONN-4);
  maxcap = MAXCONN - 4;
  if(MAXCONN > maxconn) {
    printf("WARNING: accepting more connections than are allowed!\r\n");
  }
  if(maxcap > LINEMAX) {
    printf("WARNING: accepts more connections than datastruct can handle!\r\n");
  }

  handleargs(argc, argv+1);

  /* this is more of a safety precaution */
   if(reboot) maxcap = MAXCONN-4;
  
  handler();
  
  if(!reboot) {
    fclose(stdin);
    fclose(stdout);
    fclose(stderr);
  }

  doit(port);
  exit(0);
}


handleargs(argc, argv)
     int argc;
     char **argv;
{
  int fdaemon = 0;
  int childid;
  char *logfile = (char *)0;
  char stemp[100]; 
  
  while (--argc) {
    if (**argv == '-') {
      switch ((*argv)[1]) {
      case 'r':
	reboot = 1;
        sock = atoi((*argv)+2);
printf("SOCK: %d\r\n", sock);
        break;
      case 'd':
	fdaemon = 1;
	break;
      case 'l':
	if ((*argv)[2] != '\000') {
	  logfile = (*argv)+2;
	} else {
	  if (argc < 1) {
	    fprintf(stderr, USAGE);
	    fprintf(stderr, "-l requires a file name.\n");
	    exit(1);
	  }
	  argc--, argv++;
	  logfile = *argv;
	}
	break;
      default:
	fprintf(stderr, "hermithaven: %s <%s> %s.\n",
		"Unrecognized option", *argv, "on command line"); 
	exit(3);
      }
    } else if (isdigit(**argv)) {
      port = atoi(*argv);
      hc_port = port;
    } else {
      fprintf(stderr, "hermithaven: %s <%s> %s .\n",
	      "Unrecognized option", *argv, "on command line");
      exit(3);
    }
    
    argv++;
  }
  if (logfile != (char *)0)
    if (freopen(logfile, "w", stderr) == NULL) {
      printf("haven: unable to open logfile, %s, on stderr.\n",
	     logfile);
      exit(4);
    }
  if (fdaemon)  {
    switch(childid = fork()) {
    case -1:
      fprintf(stdout, "ERROR starting daemon. exitting.\n");
      perror("haven: fork");
      exit(2);
      break;
    case 0:
      if(!reboot) {
	fclose(stdin);
	if (logfile == (char *)0)
	  fclose(stderr);
      }
      break;
    default:
      printf("Daemon succesfully started on port %d.\n", port);
      printf("Daemon's pid is %d.\n", childid);
      printf("This is the parent process signing off.\n");
      hc_port = port;
      system("rm h.pid");
      sprintf(stemp, "echo \"%d\" > h.pid", childid);
      system(stemp); 
      exit(0);
    }
  }
}

die(exitstat)
    int exitstat;
{
    exit(exitstat);
}

void handler()
{
    signal(SIGBUS, onerror);   
    signal(SIGPIPE, SIG_IGN);
    signal(SIGILL, onerror);
    signal(SIGSEGV, onerror); 
    signal(SIGHUP, SIG_IGN);
    signal(SIGALRM, SIG_IGN);
    signal(SIGTERM, SIG_IGN);
    signal(SIGUSR1, punt);
    return;
}

void prehandler()
{
    signal(SIGBUS, SIG_IGN);   
    signal(SIGPIPE, SIG_IGN);
    signal(SIGILL, SIG_IGN);
    signal(SIGSEGV, SIG_IGN); 
    signal(SIGHUP, SIG_IGN);
    signal(SIGALRM, SIG_IGN);
    signal(SIGTERM, SIG_IGN);
    signal(SIGUSR1, SIG_IGN);
    signal(SIGUSR2, SIG_IGN);
    return;
}

