#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <strings.h>
#include <string.h>
#include <ctype.h>

#ifndef INADDR_NONE
#define  INADDR_NONE  (u_short)-1
#endif

    
    extern int die(); /* we had an error now what do we do? */
extern int errno;
/*
  extern unsigned short htons();
  */

int
    getsock(address, port)
char *address;
int port;
{
    int s;
    int size;
    int one = 1;
    struct in_addr tmpaddr;
    struct hostent *tmphost;
    struct sockaddr_in saddr;
    
    /* get a fresh socket */
    if ((s = socket(AF_INET, SOCK_STREAM, 0)) == -1) {

#ifdef DEBUG
	perror("haven: Unable to get a new socket");
#endif /* DEBUG */

	die(errno);
    }
    
    /* decode address */
    if (isdigit(*address)) {
	if ((tmpaddr.s_addr = inet_addr(address)) == (u_short)INADDR_NONE) {

#ifdef DEBUG
	    perror("haven: Unable to figure out numeric address");
#endif /* DEBUG */

	    die(errno);
	}
    } else {
	if ((tmphost = gethostbyname(address)) == (struct hostent *)0) {

#ifdef DEBUG
	    perror("haven: unable to get host adress:");
#endif /* DEBUG */

	    die(9);
	}
	bcopy(tmphost->h_addr, (char *) &tmpaddr, sizeof(struct in_addr));
    }
    
    /* set up socket address */
    bcopy((char *) &tmpaddr, (char *) &(saddr.sin_addr),
	  sizeof(struct in_addr));
    saddr.sin_addr.s_addr = INADDR_ANY;
    saddr.sin_family = AF_INET;
    saddr.sin_port = (unsigned short) htons((unsigned short) port);
    setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *)&one, sizeof(one));
    
    /* attempt to bind the socket to our address */
    if (bind(s, (struct sockaddr *) &saddr, sizeof(struct sockaddr_in)) == -1)
	{

#ifdef DEBUG
	    perror("haven: Error attempting to bind");
#endif /* DEBUG */

	    die(errno);
	}
    
    /* set our backlog of waiting connections to 5(max the system allows) */
    if (listen(s, 5) == -1) {

#ifdef DEBUG
	perror("haven: Error listening");
#endif /* DEBUG */

	die(errno);
    }
    
    return s;
}

int
    acceptcon(s, from, port)
int s;
char *from;
int *port;
{
    int ns;
    int length = sizeof(struct sockaddr_in);
    char *buf;
    struct hostent *tmphost;
    struct sockaddr_in saddr;
    
    if ((ns = accept(s, (struct sockaddr *) &saddr, &length)) == -1) {

#ifdef DEBUG
	perror("haven: Error trying to accept connections");
#endif /* DEBUG */

	return -1;
	/*die(errno);*/
    }
    
    fcntl(ns, F_SETFL, O_NDELAY);
    
    tmphost = gethostbyaddr((char *) &(saddr.sin_addr), 
  			    sizeof(struct in_addr), AF_INET); 
    if (tmphost == (struct hostent *)0) { 
   
   #ifdef DEBUG 
  	perror("haven: unable to get host adress"); 
   #endif  
   
  	(void) strcpy(from, "UNKNOWN"); 
 	(void) strcpy(from, inet_ntoa(saddr.sin_addr));
	/*die(9);*/
    } else { 
  	buf = (char *) tmphost->h_name; 
  	if (buf != (char *)0) { 
  	    (void) strcpy(from, buf); 
   	} else 
   	    (void) strcpy(from, inet_ntoa(saddr.sin_addr)); 
    } 
    *port = ntohs(saddr.sin_port);
    
    return ns;
}

int
  infromsock(s, buffer, size)
int s;
char *buffer;
int size;
{
  int numchars;
  
  if ((numchars = recv(s, buffer, size-1, 0x0)) <= 0 ) { /* panic for now */

#ifdef DEBUG
    perror("haven: receive failed");
#endif /* DEBUG */

    if( errno == EWOULDBLOCK )
	return 0;
    else
	return -1;
  }
  
  if (numchars == 0) { /* foreign end closed the connection be graceful */
    return -1; /* tell the calling proc to deal with it. */
  }
  buffer[numchars] = '\000';
  
  return 0;
}

int
  outtosock(s, buffer)
int s;
char *buffer;
{
  int length, numsent;
  
  length = strlen(buffer);
  if ((numsent = send(s, buffer, length, 0x0)) == -1) {

#ifdef DEBUG
    perror("haven: send");
    fprintf(stderr, "Atempted send to socket %d with message \"%s\"\n",
	    s, buffer);
#endif /* DEBUG */

    return -1;
  } else if (numsent < length) {

#ifdef DEBUG
    fprintf(stderr, "haven: send garbled lost characters.\n");
#endif

  }
  
  return 0;
}
