#include <math.h>
#include <signal.h>
#include <sys/file.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include "haven.h"
#include "config.h"


/* IF YOU HAVE ERRORS IN COMPILATION, TRY COMMENTING/UNCOMMENTING AS NEEDED */
extern char *index(); 
/* extern char *malloc(); */
/* extern char *strcpy(), *strncpy(); */

unsigned long int iocount = 0;

extern int maxconn;
void zapname(), syncname(), syncmess2(), syncmess3(), syncmess4(), syncmess(), syncscore();
void zapmail(), syncmail();
void zaproom(), syncroom();
void zapfriend(), syncfriend();
void zapverb(), syncverb();
void zapobject(), syncobject();
void zapaction(), makeaction();
void unsecure(), zap(), syncrestrict();
void zapban(), syncban(), synclewd(), zaplewd();
extern void checkidle();

#ifndef errno
extern int errno;
#endif

#ifndef FD_SET
#define fd_set  int
#define FD_SET(n,p)     (*(p) |= 1 << (n))
#define FD_CLR(n,p)     (*(p) &= ~(1 << (n)))
#define FD_ISSET(n,p)   (*(p) & 1 << (n))
#define FD_ZERO(p)      (*(p) = 0)
#endif

#undef CTRL
#define CTRL(x) ('x' & 037)  /* I got tired of playing guess the ascii */

extern int getsock(), infromsock(), outtosock(), acceptcon(), atoi();

struct splayer *players;  /* the linked list of players records */
struct smail *zmail = NULL;
struct sverb *pverb = NULL;
struct sroom *proom = NULL;
struct slink *plink = NULL; 
struct sobject *pobject = NULL;
struct rnames *regname = NULL;
struct sfriend *pfriend = NULL;
int fpe;   /* floating point exception marker */
char newverb[BUFSIZE];
char recvbuf[BUFSIZE], sendbuf[BUFSIZE], sendbuf2[BUFSIZE], tempbuf[BUFSIZE];
struct channel *secured;   /* list of secure channel names */
int numconnect;    /* number of people connected */
int connectcount = 0;
int connectlasthr = 0;
int connectthishr = 0;
int numhours = 0;
/*
char votingchan[15];
char *voting = &votingchan[0];
*/

int bail_out = 0;
struct hostlist *rlist = NULL;                 /* Restricted hostnames */
struct banlist *blist = NULL;
struct lewdlist *nlist = NULL;
char *targroom;
int color = 31;
int vlc = 0;
int high = 1;
extern int maxcap;
int bg = 40;
int i, ok;
char lastcheckhour[5];
long maxidle = 3600000;                    /* Idle timeout */
char bboard[105][BUFSIZE];
char bboard2[25][BUFSIZE];
char bboard3[25][BUFSIZE];
char bboard4[25][BUFSIZE];
char nullstr[1];
int mflag = 0;


/* HotelGAME variables */
int equus[6][6];
char player1name[30];
char player2name[30];
char winnername[30];
int player1num;
int player2num;
int win;
int turn;
int hiscore[150];
char hiname[105][BUFSIZE];
int lastmove;

initplayerstuct()
{
    /* get a place to put our players */
    if ((players = (struct splayer *) malloc(sizeof (struct splayer)))
	== (struct splayer *)0) {
	fprintf(stderr, "haven: Unable to allocate memory for players!\n");
	exit(1);
    }
    players->next = (struct splayer *)0;
    /* voting[0] = '\0'; */
}


int onerror()
{
  sendall("[SYSLOG:  Internal Error, rebooting]\r\n","*",SYSLOG2,0);
  sendall("COMMAND:  ","*",SYSLOG,0);
  sendall(recvbuf, "*", SYSLOG, 0);
  sendall("\r\n", "*",SYSLOG,0);
  sendall("ATTEMPTING REBOOT\r\n", "*",SYSLOG2,0);
  rebootstart();
  exit(1);
}


int
    newplayer(s)
int s;
{
    struct splayer *buf;
    struct timeval tmptime;
    struct timezone tmpzone;
    int port;
    int count;
    
    /* find the tail of the linked list of players */
    buf = players;
    while (buf->next != (struct splayer *)0)
	buf = buf->next;
    
    /* create a new player struct(record) */
    buf->next = (struct splayer *) malloc(sizeof (struct splayer));
    if (buf->next == (struct splayer *)0) { /* you may now panic! */
	int sock;
	
	/*
	 * use the dummy record  at the beginning of the list to accept and
	 * dump the incomming call because we're out of memory with a nice
	 * warning we hope.
	 */
	sock = acceptcon(s, players->onfrom, &port);
	sprintf(sendbuf,"Sorry unable to allocate memory for your %s\r\n",
		"record. Please try again later");
	(void) outtosock(sock, sendbuf);
	(void) close(sock);
	
	fprintf(stderr,
	    "seek: Error unable to allocate memory for new player record.\n");
	/* not fatal should let others continue to play */
	return -1;
    }
    
    gettimeofday(&tmptime, &tmpzone);
    buf = buf->next;
    buf->flags = 9;
    buf->flag2 = 8;
    buf->seclevel = BABYCO;
    buf->channel[0] = ' ';
    buf->channel[1] = '\000';
    buf->s = acceptcon(s, buf->onfrom, &port);
    buf->ln = buf->s;
    for (count = 0; count < RECALL_SIZE; count++)
      buf->pagebuffer[count][0] = '\0';
    for (count = 0; count < LINEMAX; count++) {
      buf->gag[count] = 0;
      buf->hilite[count] = 0;
    }
    buf->col = (rand() % 6)+31;
    buf->lastp = -1;
    buf->invline = -1;
    buf->lastans = 0.0;
    buf->object[0] = '\0';
    buf->arrmesg = allocmem(1);
    strcpy(buf->arrmesg, "\0");
    buf->desc = allocmem(1);
    strcpy(buf->desc, "\0");
    buf->wandmesg = allocmem(1);
    strcpy(buf->wandmesg, "\0");
    buf->joinmesg = allocmem(1);
    strcpy(buf->joinmesg, "\0");
    buf->exitmesg = allocmem(1);
    strcpy(buf->exitmesg, "\0");
    buf->useraddr = allocmem(strlen(buf->onfrom));
    strcpy(buf->useraddr, buf->onfrom);
    setuseraddr(buf);
    buf->linemodebuf[0] = '\000';
    buf->exitmesg[0] = '\000';
    buf->lastpage[0] = '\000';
    buf->onfrom[28] = '\000';
    strcpy(buf->realonfrom, buf->onfrom); /* NEW LINE */
    buf->changedonfrom = 0;               /* NEW LINE */
    strcpy(buf->name, NEWCONN);
    buf->invchan[0] = ' ';
    buf->invchan[1] = '\0';
    buf->moretype = none;
    buf->moreline = 0; 
    buf->morearg[0] = '\0';
    buf->morearg[28] = '\0';
    buf->morearg[29] = '\0';
    buf->wrap = 2048;
    buf->gender = 'n';
    buf->idlemesg[0] = '\000';
    buf->linemodebuf[0] = '\000';
    buf->lineindex = 0;
    buf->query = -1;
    buf->contime = tmptime.tv_sec;
    buf->idle = tmptime.tv_sec;
    buf->next = (struct splayer *)0;
    buf->lps = 0;
    cleargags(buf);  /* make sure this record isn't gagging anyone */

    /* welcome our new arrival */

    numconnect++;
    connectcount++;
    connectthishr++;
    if ((numconnect >= (maxcap + 1)) || (buf->s > (maxcap + 1))) {
	sprintf(sendbuf, "%s\r\n",FULL1);
	sendtoplayer(buf, sendbuf);
        sprintf(sendbuf, "%s\r\n",FULL2);
	sendtoplayer(buf,sendbuf);
        sprintf(sendbuf, "%s\r\n",FULL3);
	sendtoplayer(buf,sendbuf);
        sprintf(sendbuf, "%s\r\n",FULL4);
	sendtoplayer(buf,sendbuf);
	removeplayer(buf);
	return -1;
    } else if(restricted(buf->onfrom)) {
	sprintf(sendbuf, "Remote machine %s, You've been DENIED access!\r\n", buf->onfrom);
	sendtoplayer(buf, sendbuf);
        sprintf(sendbuf, "Email %s %s if you feel this ban is unjust.\r\n",EMAIL,EMAIL2);
	sendtoplayer(buf, sendbuf);
	removeplayer(buf);
	return -1;
    }

     welcomeplayer(buf);
     return buf->s;
}
 
int isvowel(c)
char c;
{
  c = toupper(c);
  if ((c == 'A') || (c == 'E') || (c == 'I') || (c == 'O') || (c == 'U'))
    return 1;
  return 0;
}

int isy(c)
char c;
{
  if (c == 'y' || c == 'Y')
    return 1;
  return 0;
}

iscon(c)
char c;
{
  if (isalpha(c) && !isvowel(c) && !isy(c))
    return 1;
  return 0;
}


int
    sendall(message, channel, allow, restrict)
char *message;
char *channel;
int allow, restrict;
{
    char *messtmp;

    struct splayer *buf;
    buf = players;
    while (buf->next != (struct splayer *)0) {
	buf = buf->next;
	if(((allow == 0) && (restrict == 0)) || 
		((isplayer(buf, allow)) && (restrict == 0)) ||
		((notplayer(buf, restrict)) && (allow == 0)) ||
		((notplayer(buf, restrict)) && (isplayer (buf, allow))))
	    if ((*channel == ALL) || !strcmp(buf->channel, channel))
		   sendtoplayer(buf,message);
    }
}

setfds(needread)
    fd_set *needread;
{
    struct splayer *pplayer;
    
    pplayer = players;
    while (pplayer->next != (struct splayer *)0) {
	pplayer = pplayer->next;
	FD_SET(pplayer->ln, needread);
    }
}

struct splayer
    *lookup(linenum)
int linenum;
{
    struct splayer *tmp=players;
    
    while (tmp->next != (struct splayer *)0) {
	tmp = tmp->next;
	if (tmp->s == linenum)
	    return tmp;
    }
    
    return (struct splayer *)0;
}

handleinput(needread)
     fd_set needread;
{
  int tempnum;
  char string[BUFSIZE];
  char string2[BUFSIZE];
  struct splayer *who;
  static long lastcheck = 0;
  struct splayer *pplayer;
  struct timeval tmptime;
  struct timezone tmpzone;
  char *workbuf, *nextbuf, *buf;
  int didit = 0;
  
  pplayer = players;
  while (pplayer->next != (struct splayer *)0) {
    if(bail_out) { bail_out = 0; return 0; }

    pplayer = pplayer->next;
    if (FD_ISSET(pplayer->ln, &needread)) {
      /* check to see if they disconnected */
      if (recvfromplayer(pplayer, recvbuf, BUFSIZE) == -1) {
	/* they logged off */
	removeplayer(pplayer);
	bail_out = 0;
        return 0;
      }
      if(strlen(recvbuf) > 600) { removeplayer(pplayer); bail_out=0;
                                   return 0; }
      didit = 0;
      checkhour();
      gettimeofday(&tmptime, &tmpzone);
      if (tmptime.tv_sec - lastcheck >= 60) {
	lastcheck = tmptime.tv_sec;
	checkidle();
	if(bail_out) { bail_out=0; return 0; }
	saveremwho();
      }
      
      if(authuser(pplayer) == 0) {
	continue;
      }
      
      nextbuf = recvbuf;
      
/************************************************************************8
 Okay this is the section here that determined if stuff needed to be
 buffered... using linemodebuf[].  I'm taking this out so I can re-write
 it. 

      if((!strcasestr(nextbuf, "\n")) && (!strcasestr(nextbuf, "\r"))) {
	while((*nextbuf != '\0') && (pplayer->lineindex < 600)) {
	  pplayer->linemodebuf[pplayer->lineindex] = *nextbuf;
	  pplayer->lineindex++;
	  nextbuf++;
	}
	if(isplayer2(pplayer, LOCALECHO))
	  sendtoplayer(pplayer, recvbuf);
	continue;
      } else if (pplayer->lineindex > 0) {
	pplayer->linemodebuf[pplayer->lineindex] = '\r';
	pplayer->linemodebuf[pplayer->lineindex+1] = '\n';
	pplayer->linemodebuf[pplayer->lineindex+2] = '\0';
	pplayer->lineindex = 0;
	if(isplayer2(pplayer, LOCALECHO))
	  sendtoplayer(pplayer, "\r\n");
	nextbuf = pplayer->linemodebuf;
      }
******************************************************************/

      
      while( *nextbuf != '\0') {
	workbuf = nextbuf;
	if ((buf = index(workbuf, '\r')) != (char *)0) {
	  *buf = '\000';
	  nextbuf = buf + 1;
	} else if ((buf = index(workbuf, '\n')) != (char *)0) {
	  *buf = '\000';
	  nextbuf = buf+1;
	} else {
	  nextbuf = index(workbuf, '\0');
	}
	if ((buf = index(workbuf, '\r')) != (char *)0) {
	  *buf = '\000';
	  nextbuf = buf + 1;
	}
	if ((buf = index(workbuf, '\n')) != (char *)0) {
	  *buf = '\000';
	  nextbuf = buf+1;
	}
	if ((tmptime.tv_sec - pplayer->idle) <= 2) {
          if(!strlen(pplayer->linemodebuf))
	  if((++(pplayer->lps) > MAXLINES) && 
	     (pplayer->seclevel < COSYSOP)) {
	    removeplayer(pplayer);
            bail_out = 0;
	    return 0;
	  }
	} else {
	  pplayer->idle = tmptime.tv_sec;
	  pplayer->lps = 0;
	}
	pplayer->idle = tmptime.tv_sec;
        if ( !(*workbuf))
	  continue;
	didit = 1;
	while (*workbuf == '\n') workbuf++;
	if (*workbuf == '$') {
	  vlc = 0;
	  if(doaction(pplayer,workbuf+1)) {
	    workbuf = newverb;
	    breakline(pplayer, workbuf);
	    continue; 
	  } else continue;
	}
	if (*workbuf == '@') {
	  vlc = 0;
	  if(parseverb(pplayer,workbuf+1)) {
	    workbuf = newverb;
	    breakline(pplayer, workbuf);
	    continue; 
	  } else continue;
	}
	if (*workbuf == '/' || *workbuf == '.' || *workbuf == ',') {
	  if ((pplayer->moretype != none) && 
	      (pplayer->moretype != login1) && 
	      (pplayer->moretype != login2) && 
	      (pplayer->moretype != login3)) {
	    pplayer->moretype = none;
	    sendtoplayer(pplayer, "[MORE cancelled]\r\n");
	  }
	  handlecommand(pplayer, workbuf);
	} else if ((pplayer->query >= 0) && (*workbuf != '\\')) {
	  query(pplayer, workbuf);
	} else if ((isplayer2(pplayer,YELL)) && (*workbuf != '\\')) {
	  strcpy(string2, ".y");
	  strcat(string2, workbuf);
	  handlecommand(pplayer, string2);
	} else if (!(isplayer(pplayer, NEWBIE))) {
	  if (pplayer->query >= 0 )
	    workbuf++;
	  if (isplayer2(pplayer, YELL)) workbuf++;
	  color = pplayer->col;
	  bg = 40;
	  high = 1;
	  if (isplayer2(pplayer, FUCKWIT)) makelower(workbuf);
          if ((*workbuf == '`') || (*workbuf == '~')) {
            workbuf++;
            if(isdigit(*(workbuf))){
              tempnum = atoi(workbuf);
              who = lookup(tempnum);
              if (who==(struct splayer *)0) {
                sendtoplayer(pplayer, ">> You try to pose to nobody!\r\n");
              } else {
                while(isdigit(*(workbuf))) workbuf++;
                if (*workbuf == ':' || *workbuf == ';') {
                  workbuf++;
                  if (*workbuf == '\'')
                    sprintf(sendbuf, 
			    "(%d) [to %s]: %s%s\r\n", 
			    pplayer->s, who->name, pplayer->name, workbuf);
                  else
                    sprintf(sendbuf, 
			    "(%d) [to %s]: %s %s\r\n", 
			    pplayer->s, who->name, pplayer->name, workbuf);
                } else
                  sprintf(sendbuf, 
			  "(%d) %s [to %s]: %s\r\n",
			  pplayer->s,pplayer->name,who->name,workbuf);
                sendallg(sendbuf, pplayer, pplayer->channel, 0,0);
              }
             
	    } else {
              sprintf(sendbuf, "(%d) %s: %s\r\n",
		      pplayer->s,pplayer->name,workbuf);
              sendallg(sendbuf, pplayer, pplayer->channel, 0,0);
            }

	  } else if( *workbuf == ':' || *workbuf == ';') {
	    workbuf++;
	    if ((*workbuf == '\'') && (*(workbuf+1) == 's') 
		&& (*(workbuf+2) == ' '))
	      sprintf(sendbuf,
		      "(%d) %s%s\r\n",pplayer->s, pplayer->name, workbuf);
	    else if((*workbuf == '\'') && (*(workbuf+1) =='d') 
		    && (*(workbuf+2)==' '))
	      sprintf(sendbuf,
		      "(%d) %s%s\r\n",pplayer->s, pplayer->name, workbuf);
	    else if((*workbuf == '\'') && (*(workbuf+2) =='l') 
		    && (*(workbuf+1)=='l') && (*(workbuf+3) == ' '))
	      sprintf(sendbuf,
		      "(%d) %s%s\r\n",pplayer->s, pplayer->name, workbuf);
	    else
	      sprintf(sendbuf, "%c%d%c %s %s\r\n",
		      lindic[pplayer->seclevel],pplayer->s,
		      rindic[pplayer->seclevel], pplayer->name,
		      workbuf);
	    if (!(isplayer(pplayer, GAGGED))) 
	      sendallg(sendbuf, pplayer, pplayer->channel, 0, 0);
	    else 
	      sendtoplayer(pplayer, sendbuf);
	  } else {
	    sprintf(sendbuf,"%c%d%c %s says \"%s\"\r\n", 
		    lindic[pplayer->seclevel],pplayer->s,
		    rindic[pplayer->seclevel],pplayer->name,
		    workbuf+(*workbuf == '"'));
	    if (!(isplayer(pplayer, GAGGED))) 
	      sendallg(sendbuf,pplayer,pplayer->channel,0, TRAD);
	    else if (!isplayer(pplayer, TRAD))
	      sendtoplayer(pplayer, sendbuf);
	    sprintf(sendbuf, "%c%d, %s%c %s\r\n", 
		    lindic[pplayer->seclevel], pplayer->s,
		    pplayer->name, rindic[pplayer->seclevel],
		    workbuf+(*workbuf == '"'));
	    if(!(isplayer(pplayer, GAGGED)))
	      sendallg(sendbuf,pplayer,pplayer->channel,TRAD, 0);
	    else if (isplayer(pplayer, TRAD))
	      sendtoplayer(pplayer, sendbuf);
	  }
	}
      }
      if((*nextbuf == '\0') && !didit)
	domore(pplayer);
    }

    if(bail_out) { bail_out = 0; return 0; }
  }
}




removeplayer(player)
    struct splayer *player;  /* a pointer to the player to be nuked */
{
    struct splayer *tmp;
    int count;

    bail_out = 1;
    tmp = players;
    while ((tmp->next != (struct splayer *)0) && (tmp->next != player))
	tmp = tmp->next;
    if (tmp->next == (struct splayer *)0)
	return;
    tmp->next = player->next;
    if ((player->s < LINEMAX) && (notplayer(player, NEWBIE))) {
	sprintf(sendbuf2, ">> (%d) %s%s%s%s %s\r\n", player->s,
		player->name,(player->desc[0] != '\0') ? " - " : "", player->desc,(player->desc[0] != '\0') ? " -" : "",DIED);
	sendall(sendbuf2, "*", 0, MESS|NEWBIE);
        sprintf(sendbuf2, ">> (%d) %s lost link.\r\n",player->s,player->name);
        if(strcmp(player->channel, " "))
           sendall(sendbuf2, player->channel, 0, 0);
        notifyfriendexit(player->name, player->s);
	color = 31; bg = 40;
    }
#ifdef DEBUG
#else
#endif
    close(player->ln);
    free(player->arrmesg);
    free(player->desc);
    free(player->wandmesg);
    free(player->joinmesg);
    free(player->exitmesg);
    free(player->useraddr);
    free((char *)player);
    numconnect--;
    bail_out = 1;
}

quitplayer(player)
    struct splayer *player;
{

    struct splayer *tmp;
    int count;

    bail_out = 1;
    tmp = players;
    while ((tmp->next != (struct splayer *)0) && (tmp->next != player))
	 tmp = tmp->next;

    if (tmp->next == (struct splayer *)0)
	 return;

    tmp->next = player->next;
    (void) close(player->ln);
    free(player->arrmesg);
    free(player->desc);
    free(player->wandmesg);
    free(player->joinmesg);
    free(player->exitmesg);
    free(player->useraddr);
    free((char *) player);
    numconnect--;
}

char *
    idlet(idle)
long idle;
{
    static char buf[11];
    long timenoc;
    struct timeval tmptime;
    struct timezone tmpzone;
    long hrs,mins,secs;
    
    gettimeofday(&tmptime, &tmpzone);
    timenoc = tmptime.tv_sec - idle;
    secs = timenoc % 60;
    mins = (timenoc / 60) % 60;
    hrs = timenoc / 3600;
    
    if (hrs) {
	if (mins)
	    sprintf(buf, "%dh%dm", hrs, mins);
	else
	    sprintf(buf, "%dh", hrs);
    } else if (mins) {
	if (secs)
	    sprintf(buf, "%dm%ds", mins, secs);
	else
	    sprintf(buf, "%dm", mins);
    } else
	sprintf(buf, "%ds", secs);
    return buf;
}

int validemail(pplayer)
     struct splayer *pplayer;
{
  int count = 0;
  int isat = 0;
  int isnospaces = 1;
  char address[BUFSIZE];

  unsetuseraddr(pplayer);
  strcpy(address, pplayer->useraddr);
  setuseraddr(pplayer);
  if(strcasestr(address, "|")) return 0;
  if(strcasestr(address, "`")) return 0;
  if(strcasestr(address, ";")) return 0;
  if(strcasestr(address, "\"")) return 0;
  while (address[count] != '\0') {
    if (address[count] == '@') isat++;
    else if (address[count] == ' ') isnospaces = 0;
    count++;
  }
  if((isat == 1) && isnospaces) return 1;
  return 0;
}

int validemailbuf(address)
     char *address;
{
  int count = 0;
  int isat = 0;
  int isnospaces = 1;

  if(strcasestr(address, "|")) return 0;
  if(strcasestr(address, "`")) return 0;
  if(strcasestr(address, ";")) return 0;
  if(strcasestr(address, "\"")) return 0;
  while (address[count] != '\0') {
    if (address[count] == '@') isat++;
    else if (address[count] == ' ') isnospaces = 0;
    count++;
  }
  if((isat == 1) && isnospaces) return 1;
  return 0;
}

int breakline(pplayer,buf)
     struct splayer *pplayer;
     char *buf;
{
  char *loc;

  while(strcasestr(buf, ";")) {
    vlc++;
    loc = buf;
    while(*loc != ';') loc++;
    loc[0] = '\0';
    if(vlc < 6) commandline(pplayer,buf);
    buf = loc+1;
  }
  vlc++;
  if(vlc < 6) commandline(pplayer,buf);
}

  


int commandline(pplayer,buf)
     struct splayer *pplayer;
     char *buf;
{
  struct splayer *who;
  int tempnum;
  char string[BUFSIZE];

  if (*buf == '<') {
    vlc--;
    strcpy(string, buf+1);
    strcat(string, "\r\n");
    sendtoplayer(pplayer,string);
    return 0;
  }
  if (*buf == '/' || *buf == '.' || *buf == ',') {
    if((*(buf+1) != 'q') && (*(buf+1) != 'R') && (*(buf+1) != 'Z') && (*(buf+1) != 'B'))
       handlecommand(pplayer, buf);
  } else if ((pplayer->query >= 0) && (*buf != '\\')) {
    query(pplayer, buf);
  } else if ((isplayer2(pplayer,YELL)) && (*buf != '\\')) {
    strcpy(string, ".y");
    strcat(string, buf);
    handlecommand(pplayer, string);
  } else if (!(isplayer(pplayer, NEWBIE))) {
    if (pplayer->query >= 0 )
      buf++;
    if (isplayer2(pplayer, YELL)) buf++;
    color = pplayer->col;
    bg = 40;
    high = 1;
    if (*buf == '`') {
      buf++;
      if(isdigit(*(buf))){
	tempnum = atoi(buf);
	who = lookup(tempnum);
	if (who==(struct splayer *)0) {
	  sendtoplayer(pplayer, ">> You try to pose to nobody!\r\n");
	} else {
	  while(isdigit(*(buf))) buf++; 
	  sprintf(sendbuf, "(%d) %s [to %s]: %s\r\n",pplayer->s,pplayer->name,who->name,buf);
	  sendallg(sendbuf, pplayer, pplayer->channel, 0,0);
	}
      } else {
	sprintf(sendbuf, "(%d) %s: %s\r\n",pplayer->s,pplayer->name,buf);
	sendallg(sendbuf, pplayer, pplayer->channel, 0,0);
      }
    } else if( *buf == ':' || *buf == ';') {
      buf++;
      if ((*buf == '\'') && (*(buf+1) == 's') && (*(buf+2) == ' '))
	sprintf(sendbuf,"(%d) %s%s\r\n",pplayer->s, pplayer->name, buf);
      else if((*buf == '\'') && (*(buf+1) =='d') && (*(buf+2)==' '))
	sprintf(sendbuf,"(%d) %s%s\r\n",pplayer->s, pplayer->name, buf);
      else if((*buf == '\'') && (*(buf+2) =='l') && (*(buf+1)=='l') && (*(buf+3) == ' '))
	sprintf(sendbuf,"(%d) %s%s\r\n",pplayer->s, pplayer->name, buf);
      
      else
	sprintf(sendbuf, "%c%d%c %s %s\r\n",
		lindic[pplayer->seclevel],pplayer->s,
		rindic[pplayer->seclevel], pplayer->name,
		buf);
      if (!(isplayer(pplayer, GAGGED))) 
	sendallg(sendbuf, pplayer, pplayer->channel, 0, 0);
      else 
	sendtoplayer(pplayer, sendbuf);
    } else {
      sprintf(sendbuf,"%c%d%c %s says \"%s\"\r\n", 
	      lindic[pplayer->seclevel],pplayer->s,
	      rindic[pplayer->seclevel],pplayer->name,
	      buf+(*buf == '"'));
      if (!(isplayer(pplayer, GAGGED))) 
	sendallg(sendbuf,pplayer,pplayer->channel,0, TRAD);
      else if (!isplayer(pplayer, TRAD))
	sendtoplayer(pplayer, sendbuf);
      sprintf(sendbuf, "%c%d, %s%c %s\r\n", 
	      lindic[pplayer->seclevel], pplayer->s,
	      pplayer->name, rindic[pplayer->seclevel],
	      buf+(*buf == '"'));
      if(!(isplayer(pplayer, GAGGED)))
	sendallg(sendbuf,pplayer,pplayer->channel,TRAD, 0);
      else if (isplayer(pplayer, TRAD))
	sendtoplayer(pplayer, sendbuf);
    }
  }
}


int whofinger(pplayer,who)
    struct splayer *who;
    struct splayer *pplayer;
{
    color = 35;
    bg = 44;
    high = 1;
    sprintf(sendbuf,">> Name: %s      %s\r\n",who->name,registered(who->name) ? "[REGISTERED]" : " ");
    sendtoplayer(pplayer,sendbuf);
    bg = 40; 
    sprintf(sendbuf,">> On for %s from %s.\r\n",idlet(who->contime),who->onfrom);
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf,">> Idle: %s\r\n",idlet(who->idle));
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf,">> Channel: %s       %s\r\n",who->channel, isplayer(who, CHANOP) ? "[CHANNELOP]" : " ");
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf,">> SYSTEM FLAGS: %s%s%s\r\n",(isplayer(who,TECHNO)) ? "Technocolor on  |  " : "", (isplayer(who, NEWBIE)) ? "NAME UNSET  |  " : "", (isplayer2(who, TIME)) ? "Timestamps on  |  " : "");
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf,">> /p FLAGS: %s%s%s\r\n",(isplayer(who,BEEP)) ? "beep on   |  " : "",(isplayer(who,HILITE)) ? "hilite on  |  " : "",(isplayer(who, ECHO)) ? "echo on  |  ":"");
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf,">> COMM FLAGS: %s%s\r\n",(isplayer2(who,YELL)) ? "Yell Mode on  |  " : "",(isplayer(who, TRAD)) ? "Traditional Mode" : "Say Mode");
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf,">> SUPRESSION FLAGS: %s%s%s%s%s\r\n",(isplayer(who,MESS)) ? "System Messages  |  " : "", (isplayer(who,NOMESG)) ? "Custom Messages  |  " : "", (isplayer(who, PSUP)) ? "Private Messages (/p's)  |  " : "", (isplayer2(who, ZSUP)) ? "Zmail |  " : "", (isplayer(who, HUSHED)) ? "Hushed (yells)" : "");
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf, ">> Gender: %c\r\n", who->gender);
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf, ">> (a) Arrival mesg: %s\r\n",who->arrmesg);
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf, ">> (w) Exit channel mesg: %s\r\n",who->wandmesg);
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf, ">> (j) Join channel mesg: %s\r\n",who->joinmesg);
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf, ">> (e) Exit mesg: %s\r\n",who->exitmesg);
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf, ">> (m) Published email: %s\r\n",who->useraddr);
    sendtoplayer(pplayer,sendbuf);
    sprintf(sendbuf,">> desc:  %s - %s\r\n",who->name,who->desc);
    sendtoplayer(pplayer,sendbuf);
    color = 31; bg = 40;
}





void finger(pplayer)
    struct splayer *pplayer;
{
    int lines =0;
    int stopat;
    struct splayer *buf;
    register int numcons = 0;

    if(pplayer->moretype == finglist)
      stopat = pplayer->moreline + 20;
    else {
      stopat = 20;
      pplayer->moreline = 0;
      color = 31;
      high = 1;
      sprintf(sendbuf, "----------------------------- %s ----------------------------\r\n",NAME);
      sendtoplayer(pplayer,sendbuf);
    }

    buf = players;
    color = 35;
    while(buf->next != NULL) {
	buf = buf->next;
	sprintf(sendbuf, "%3d) %-21s%s", buf->s, buf->name, ((++numcons) % 3) ? "" : "\r\n");
        if (lines <= stopat) {
          if (lines >= pplayer->moreline)
            sendtoplayer(pplayer, sendbuf);
          if (!(numcons % 3))
            lines++;
        } else {
          break;
        }
    }
  if (!buf->next) {
    if (numcons % 3)
      sendtoplayer(pplayer, "\r\n");
    sprintf(sendbuf, "\t%d connections.\r\n", numcons);
    sendtoplayer(pplayer, sendbuf);
    pplayer->moretype = none;
    pplayer->moreline = 0;
    color=31;
    sprintf(sendbuf, "----------------------------- %s ----------------------------\r\n",NAME);
    sendtoplayer(pplayer,sendbuf);
  } else {
    pplayer->moretype = finglist;
    pplayer->moreline = lines;
    sendtoplayer(pplayer, "--- MORE --- Press return to continue:\r\n");
  }
  color = 31;
}

int fingerverb(pplayer)
    struct splayer *pplayer;
{
  int lines = 0;
  int stopat;
  struct sverb *buf;
  register int numcons = 0;

  if(pplayer->moretype == verblist)
    stopat = pplayer->moreline + 20;
  else {
    stopat = 20;
    pplayer->moreline = 0;
  }

  color = 31;
  high = 1;
  buf = pverb;
  color = 35;
  while(buf != NULL) {
    if (strcmp(buf->verbname, "dummy") && (!strcasecmp(pplayer->name, buf->owner) || (buf->perm == 'g'))) {
      sprintf(sendbuf, "@%-24s %s", buf->verbname,
	      ((++numcons) % 3) ? "" : "\r\n");
      if (lines <= stopat) {
	if (lines >= pplayer->moreline)
	  sendtoplayer(pplayer, sendbuf);
	if (!(numcons % 3))
	  lines++;
      } else {
	break;
      }
    }
    buf = buf->next;
  }
  if (!buf) {
    if (numcons % 3)
      sendtoplayer(pplayer, "\r\n");
    sprintf(sendbuf, "\t%d total verbs.\r\n", numcons);
    sendtoplayer(pplayer, sendbuf);
    pplayer->moretype = none;
    pplayer->moreline = 0;
  } else {
    pplayer->moretype = verblist;
    pplayer->moreline = lines;
    sendtoplayer(pplayer, "--- MORE --- Press return to continue:\r\n");
  }
  color = 31;
}


int whosqueried(pplayer)
    struct splayer *pplayer;
{
    struct splayer *buf;
    struct splayer *whoc;
    register int numcons = 0;

    buf=players;
    color = 31; bg = 40; high = 1;
    sendtoplayer(pplayer, ">> Current Query connections:\r\n");
    while(buf->next != (struct splayer *)0) {
	  buf = buf->next;
	  if (buf->query >= 0) {
	     whoc = lookup(buf->query);
	     if (whoc == (struct splayer *)0) {
		sprintf(sendbuf, "%3d %-21s ----------> <<DEAD CONNECT>>\r\n",buf->s,buf->name);
		sendtoplayer(pplayer,sendbuf);
		numcons++;
	     } else {
		sprintf(sendbuf, "%3d %-21s ---------->%3d %-21s\r\n",buf->s,buf->name,whoc->s,whoc->name);
		sendtoplayer(pplayer,sendbuf);
		numcons++;
	     }
	  }
     }
     sprintf(sendbuf, "     %d record%s displayed.\r\n",numcons, numcons == 1 ? "" : "s");
     sendtoplayer(pplayer,sendbuf);
}

int whoson2(pplayer, limit, channel, type)
    struct splayer *pplayer;
    int limit;
    char *channel;
    char type;
{
    int hold;
    int stopat;
    int lines = 0;
    struct splayer *buf;
    register int numcons = 0;
    
    color = 31;
    switch(pplayer->seclevel) {
      case JOEUSER:
	sprintf(sendbuf, "%-5s%-21s%-9s%-28s\r\n", "Line", "Name", "On For", "On From");
	break;
	
      case BABYCO:
      case COSYSOP:
      case SYSOP:
      case SUPREME:
   color = 35; bg = 41; high = 1;
    sendtoplayer(pplayer, "h-hush e-echo Y-yell s-say H-hilite T-Color b-beep P-/p sup. m-sup-mess. \r\n");
    color = 31; bg = 40; high = 1;
	sprintf(sendbuf, "%-5s%-21s%-9s%-11s%-28s%-5s\r\n", "Line", "Name",
		"On For", "Flags", "On From", "");
	break;
      default:
	fprintf(stderr, "mikihaven:  player: %d(%s), Bad %s(%d)\r\n",
		pplayer->s, pplayer->name, "security level in who",
		pplayer->seclevel);
	pplayer->seclevel = JOEUSER;
	color =31; bg = 30; high =1;
	sprintf(sendbuf, "%-5s%-21s%-9s%-28s%-5s\r\n", "Line", "Name",
		"On For", "On From", "");
	break;
    }
    sendtoplayer(pplayer, sendbuf);
 
    if(pplayer->moretype == who2)
        stopat = pplayer->moreline+20;
    else if (isplayer2(pplayer, PAGE)) {
        stopat = 20;
        pplayer->moreline = 0;
    } else {
        stopat = 3000;  /* nice safe figure */
    }

    buf = players;
    while (buf->next != (struct splayer *)0) {
	buf = buf->next;
	color = buf->col;
	if(type != ALL) {
	    if ((type == CHANNEL) && ((!strcasestr(buf->name, channel)) && (!strcasestr(buf->channel, channel)) && (!strcasestr(buf->realonfrom, channel))))
		continue;
	    else if ((type == LINE) && (buf->s !=limit))
		continue;
	}
	switch(pplayer->seclevel) {
	  case JOEUSER:
	    sprintf(sendbuf, "%3d  %-20s %-7s\r\n", buf->s, buf->name,
		    idlet(buf->contime));
	    break;
	  case BABYCO:
	  case COSYSOP:
	  case SYSOP:
	  case SUPREME:
        sprintf(sendbuf, "%3d  %-20s %-7s  %s%s%s%s%s%s%s%s%s %-28s\r\n", buf->s, buf->name, idlet(buf->contime), (isplayer(buf,HUSHED)) ? "h" : "-", (isplayer(buf,ECHO)) ? "e" : "-", (isplayer2(buf,YELL)) ? "Y" : "-", (isplayer(buf,TRAD)) ? "-" : "s",(isplayer(buf,HILITE)) ? "H" : "-",(isplayer(buf,TECHNO)) ? "T" : "-", (isplayer(buf, BEEP)) ? "b" : "-",(isplayer(buf, PSUP)) ? "P" : "-", (isplayer(buf, MESS)) ? "m" : "-", buf->realonfrom);
	    break;
	  default:
	    fprintf(stderr, "mikihaven:  player: %d(%s), Bad %s(%d)\r\n", 
		    pplayer->s, pplayer->name, "security level in who2",
		    pplayer->seclevel);
	    pplayer->seclevel = JOEUSER;
	    sprintf(sendbuf, "%3d  %-20s %-7s\r\n", buf->s, buf->name,
		    idlet(buf->contime));
	    break;
	}
	if (isplayer(buf,HIDDEN)) {
	  if (pplayer->seclevel >= SYSOP) {
	    sendbuf[0] = 'H';
	    sendtoplayer(pplayer,sendbuf);
	    numcons++;
	  }
	} else {
	    numcons++;
            if (lines <= stopat) {
               if (lines >= pplayer->moreline)
                 sendtoplayer(pplayer, sendbuf);
               lines++;
            } else {
               break;
            }
	}
    }
    color = 31; bg = 40;
    if(!buf->next) {
       sprintf(sendbuf, "    %d record%s displayed.\r\n", numcons, numcons == 1 ? "" : "s");
       sendtoplayer(pplayer, sendbuf);
       pplayer->moretype = none;
       pplayer->moreline = 0;
    } else {
       pplayer->moretype = who2;
       pplayer->moreline = lines;
       if (channel != (char *)0)
         strncpy(pplayer->morearg, channel, 28);
       else
         strcpy(pplayer->morearg, "\0");
         if (type==TIDLE) { 
           pplayer->moretype = tilde;
           sprintf(pplayer->morearg, "%d", limit); 
         }
       sendtoplayer(pplayer, "--- MORE --- Press return to continue:\r\n");
     }
}

int whoson(pplayer,limit, channel, type)
     struct splayer *pplayer;
     int limit;
     char channel[];
     char type;
{
  int hold;
  int stopat;
  int lines = 0;
  struct splayer *buf;
  register int numcons=0;
  
  color = 31;
  switch(pplayer->seclevel) {
  case JOEUSER:
    sprintf(sendbuf, "%-7s%-21s%-10s%-9s\r\n", "Line", "Name", "Channel",
	    "Idle");
    break;
    
  case BABYCO:
    sprintf(sendbuf, "%-7s%-21s%-10s%-9s%-28s\r\n", "Line", "Name",
	    "Channel", "Idle", "Fnord" );
    break;
    
  case COSYSOP:
  case SYSOP:
  case SUPREME:
    sprintf(sendbuf, "%-7s%-21s%-10s%-9s%-27s%-5s\r\n", "Line", "Name",
	    "Channel", "Idle", "Fnord", "Lev");
    break;
  default:
    fprintf(stderr, "mikihaven:  player: %d(%s), Bad %s(%d)\r\n",
	    pplayer->s, pplayer->name, "security level in who",
	    pplayer->seclevel);
    pplayer->seclevel = JOEUSER;
    sprintf(sendbuf, "%-7s%-21s%-10s%-9s\r\n", "Line", "Name", "Channel",
	    "Idle");
    break;
  }
  sendtoplayer(pplayer, sendbuf);
  
  if((pplayer->moretype == who) || (pplayer->moretype == tidle))
    stopat = pplayer->moreline+20;
  else if (isplayer2(pplayer, PAGE)) {
    stopat = 20;
    pplayer->moreline = 0;
  } else {
    stopat = 3000; /* nice safe figure */
  }
  
  buf = players;
  while (buf->next != (struct splayer *)0) {
    buf = buf->next;
    color= buf->col;
    if (type != ALL) {
      if ((type == CHANNEL) && ((!strcasestr(buf->channel, channel)) && (!strcasestr(buf->name, channel)) && (!strcasestr(buf->onfrom, channel))))
	continue;
      else if ((type == LINE) && (buf->s != limit))
	continue;
      else if ((type == TIDLE) && (limit <= (time(NULL)-(buf->idle))))
        continue;
    }
    switch(pplayer->seclevel) {
    case JOEUSER:
      sprintf(sendbuf, "%5d  %-20s %-9s %-7s\r\n", buf->s,
	      buf->name, buf->channel, idlet(buf->idle));
      break;
      
    case BABYCO:
      sprintf(sendbuf, "%5d  %-20s %-9s %-7s  %-28s  \r\n",
	      buf->s, buf->name, buf->channel,
	      idlet(buf->idle), buf->onfrom );
      break;
      
    case COSYSOP:
    case SYSOP:
    case SUPREME:
      sprintf(sendbuf, "%5d  %-20s %-9s %-7s %-28s %-2d\r\n",
	      buf->s, buf->name, buf->channel,
	      idlet(buf->idle), buf->onfrom, buf->seclevel);
      break;
    default:
      fprintf(stderr, "mikihaven:  player: %d(%s), %s(%d)\r\n",
	      pplayer->s, pplayer->name, "security level in who2",
	      pplayer->seclevel);
      pplayer->seclevel = JOEUSER;
      sprintf(sendbuf, " %4d  %-20s %-9s %-7s\r\n", buf->s,
	      buf->name, buf->channel, idlet(buf->idle));
      break;
    }
    if ((isplayer(buf, HUSHED)) && (notplayer(buf, PSUP)) && (notplayer(buf, ZSUP)))
      sendbuf[5] = 'H';
    if ((isplayer(buf, PSUP)) && (notplayer(buf, HUSHED)) && (notplayer(buf, ZSUP)))
      sendbuf[5] = 'P';
    if ((isplayer2(buf, ZSUP)) && (notplayer(buf, HUSHED)) && (notplayer(buf, PSUP)))
      sendbuf[5] = 'Z';
    if ((isplayer(buf, HUSHED)) && (isplayer(buf, PSUP)) && (notplayer(buf, ZSUP)))
      sendbuf[5] = 'X';
    if ((isplayer(buf, HUSHED)) && (isplayer2(buf, ZSUP)) && (notplayer(buf, PSUP)))
      sendbuf[5] = '^';
    if ((isplayer(buf, PSUP)) && (isplayer2(buf, ZSUP)) && (notplayer(buf, HUSHED)))
      sendbuf[5] = '%';
    if ((isplayer(buf, HUSHED)) && (isplayer2(buf, ZSUP)) && (isplayer(buf, PSUP)))
      sendbuf[5] = '#';
    if (issecure(buf->channel))
      sendbuf[1] = 'S';
    if ((isplayer(buf, CHANOP)))
      sendbuf[0] = '*';
/*
 *   if ((buf->seclevel == SYSOP))
 *     sendbuf[0] = '@';
 *   if ((buf->seclevel == SUPREME))
 *     sendbuf[0] = '@';
 */
    if ((isplayer(buf, NEWBIE)))
      sendbuf[0] = 'N';
    if (isplayer2(buf, FUCKWIT))
      sendbuf[0] = 'F';
    if (buf->idlemesg[0] != '\000')
      sendbuf[0] = 'I';
    if (isplayer2(buf,REGISTERED)) sendbuf[45] = '+';
    if ((buf->changedonfrom) && (buf->seclevel < SYSOP))     /* NEW LINE */
      sendbuf[45]='+';                                       /* NEW LINE */
    if (isplayer(buf, HIDDEN)) {
      if (pplayer->seclevel >= SYSOP) {
	sendtoplayer(pplayer, sendbuf);
	numcons++;
      }
    } else {
      numcons++;
      if(lines <= stopat) {
	if(lines >= pplayer->moreline)
	  sendtoplayer(pplayer, sendbuf);
	lines++;
      } else {
	break;
      }
    }
  }
  color = 31;
  if(!buf->next) {
    sprintf(sendbuf, "    %d record%s displayed.\r\n", numcons, numcons == 1 ? "" : "s");
    sendtoplayer(pplayer, sendbuf);
    pplayer->moretype = none;
    pplayer->moreline = 0;
  } else {
    pplayer->moretype = who;
    pplayer->moreline = lines;
    if (channel != (char*)0)
       strncpy(pplayer->morearg, channel, 28);
    else
       strcpy(pplayer->morearg, "\0");
         if (type==TIDLE) {
           pplayer->moretype = tidle;
           sprintf(pplayer->morearg, "%d", limit);
         }
    sendtoplayer(pplayer, "--- MORE --- Press return to continue:\r\n");
  }
}


int
    showmess(pplayer)
struct splayer *pplayer;
{
    FILE *fpMESB;
    color = 30;
    if ((fpMESB = fopen(LOGFILE, "r")) == (FILE *)0) {
	(void) sendtoplayer(pplayer, ">> There are no messages.\r\n");
	fprintf(stderr, "No Message file.\r\n");
	return;
    }
    while (fgets(sendbuf, BUFSIZE, fpMESB) != NULL) { 
	color++; if ( color == 37) color = 31;
	(void) sendtoplayer(pplayer, sendbuf);
	(void) sendtoplayer(pplayer, "\r"); }

    fclose(fpMESB);
}

int
    showann(pplayer)
struct splayer *pplayer;
{
    FILE *fpANN;
    color = 37; bg = 44; high = 1;
    if ((fpANN = fopen(ANNFILE, "r")) == (FILE *)0) {
	(void) sendtoplayer(pplayer, "Unable to open announcement file.\r\n");
	fprintf(stderr, "Unable to open announcement file.\r\n");
	return;
     }

     while (fgets(sendbuf, BUFSIZE, fpANN) != NULL) {
	(void) sendtoplayer(pplayer, sendbuf);
	(void) sendtoplayer(pplayer, "\r"); }

     fclose(fpANN);
     color =31; bg = 40; 
}

int
    showanntwo(pplayer)
struct splayer *pplayer;
{
    FILE *fpANN;
    color = 37; bg = 44; high = 1;
    if ((fpANN = fopen(ANNFILETWO, "r")) == (FILE *)0) {
	(void) sendtoplayer(pplayer, "Unable to open announcement file.\r\n");
	return;
     }

     while (fgets(sendbuf, BUFSIZE, fpANN) != NULL) {
	(void) sendtoplayer(pplayer, sendbuf);
	(void) sendtoplayer(pplayer, "\r"); }

     fclose(fpANN);
     color =31; bg = 40; 
}

int
    showdict(pplayer, word)
struct splayer *pplayer;
char *word;
{
  FILE *fpANN;
  color = 37; bg = 44; high = 1;
  if ((fpANN = fopen(DICTFILE, "r")) == (FILE *)0) {
    sendtoplayer(pplayer, "Unable to open dictionary.\r\n");
    return;
  }
  
  sendtoplayer(pplayer, ">> Found words:\r\n");
  while (fgets(sendbuf, BUFSIZE, fpANN) != NULL) {
    if(strstr(sendbuf, word)) {
      sendtoplayer(pplayer, sendbuf);
      sendtoplayer(pplayer, "\r"); 
    }
  }
  sendtoplayer(pplayer, ">> End search.\r\n");
  
  fclose(fpANN);
  color =31; bg = 40; 
}

int
cleanupbuf(pplayer)
   struct splayer *pplayer;
{
  char tmpbuf[BUFSIZE];
  char *new, *old;
  int tempvar;
  
  old = recvbuf;
  while (*old != '\000') {  /* for each character in the input */

    /* If the inpuut is a backspace, wipe off the last character of
       linemodebuf[] and ignore it */
    if (((*old == '') || (*old == 8))&&(strlen(pplayer->linemodebuf) > 0)) {
        if(isplayer2(pplayer, LOCALECHO))
        	sendtoplayer(pplayer, "\b \b");
        pplayer->linemodebuf[strlen(pplayer->linemodebuf)-1] = '\0';
    }
  
    /* if its not a control character, then append it to the end of
       linemodebuf[] */
    else if ((*old > 0) && ((!iscntrl(*old)) || (*old == '\r') || 
		       (*old == '\n'))) {

      if(strlen(pplayer->linemodebuf)<(BUFSIZE-5)) {
        pplayer->linemodebuf[strlen(pplayer->linemodebuf)+1]='\0';
        pplayer->linemodebuf[strlen(pplayer->linemodebuf)]=*old;
  
        if(isplayer2(pplayer, LOCALECHO))
           sendtoplayer(pplayer,
             &pplayer->linemodebuf[strlen(pplayer->linemodebuf)-1]);
        
      }  else  {  /* buffer is FULL!  put a CR on the end dump the fucker */
        pplayer->linemodebuf[(BUFSIZE-5)]='\n';
        pplayer->linemodebuf[(BUFSIZE-4)]='\r';
        pplayer->linemodebuf[(BUFSIZE-4)]='\0';
      }

      
    }
    old++;
  }


  /* okay... now that we should have a clean linemodebuf, find the last
     instance of a \r or \n and dump it into recvbuf.  Put the excess, if
     any, back into linemodebuf */

  old=pplayer->linemodebuf;
  new= NULL;
  tempvar=0;

  while(*old != '\0') {
    if((*old == '\n') || (*old == '\r')) new=old;
    old++;
  }
 
  tempvar = new-pplayer->linemodebuf;
 
  if(new==NULL) {  /* NO CR'S anywhere in the buffer! */
    strcpy(recvbuf,"");  /* put something there and send it on */
  } else {
    /* put everything up and including the last \r\n in recv and the
       excess back into linemodebuf */
    strncpy(recvbuf, pplayer->linemodebuf, tempvar+1);
    recvbuf[tempvar] = '\0';
    strcpy(tmpbuf, (pplayer->linemodebuf)+tempvar+1);
    strcpy(pplayer->linemodebuf, tmpbuf);

  }

}

int
    recvfromplayer(who, data, howmuch)
struct splayer *who;
char *data;
int howmuch;
{
    int error;
    
    error = infromsock(who->ln, data, howmuch);
    /* remove nasty chars */
    (void) cleanupbuf(who);
    return error;
}

int
    sendtoplayer(who, message)
struct splayer *who;
char *message;
{   char dummy[BUFSIZE];
    char sendbuf[BUFSIZE];
    long hold;
    int goforit = 0;
    char *ttime;
    time_t now = time(0);
    char wrapbuf[3200];
    int count = 0;
    int count2 = 0;
    int count3 = 1;
    char *buf;

/*
    if ((buf = index(message, '\r')) != (char *)0) {
      *buf = '\000';
    }
    if ((buf = index(message, '\n')) != (char *)0) {
      *buf = '\000';
    }
*/

    if ( ok == 1 ) {
      sprintf(sendbuf, "%s", (isplayer(who,TECHNO)) ? message : "\0"); }
    else {
      sprintf(dummy,"[%d;%dm",high,color);

      sprintf(sendbuf,"%s%s%s", (isplayer(who,TECHNO)) ? dummy : "", message, (isplayer(who,TECHNO)) ? "[0m" : "");
    }
    while (sendbuf[count] != '\000') {
      wrapbuf[count2] = sendbuf[count];
      if(count3 == who->wrap) {
	count3 = 0;
	count2++;
	wrapbuf[count2] = '\r';
	count2++;
	wrapbuf[count2] = '\n';
      }
      count2++;
      if((sendbuf[count] != '\r') && (sendbuf[count] != '\n') && (sendbuf[count] != '\000'))
	count3++;
      count++;
    }
    wrapbuf[count2] = '\000';

    if (outtosock(who->ln, wrapbuf) == -1) { 
      removeplayer(who);
    } else {
      iocount += strlen(wrapbuf);
    }
  }


int
    welcomeplayer(pplayer)
struct splayer *pplayer;
{
    FILE *fpWELCOME;

    
    if ((fpWELCOME = fopen(WELCOMEFILE, "r")) == (FILE *)0) {
	(void) sendtoplayer(pplayer, "Unable to open welcome file.\r\n");
	return;
    }
    
    while (fgets(sendbuf, BUFSIZE, fpWELCOME) != NULL) {
	(void) sendtoplayer(pplayer, sendbuf);
	(void) sendtoplayer(pplayer, "\r");  }
    
    fclose(fpWELCOME);
}

int
    showboss(pplayer)
struct splayer *pplayer;
{
    FILE *fpWELCOME;

    
    if ((fpWELCOME = fopen("hotel.boss", "r")) == (FILE *)0) {
	(void) sendtoplayer(pplayer, "Unable to open welcome file.\r\n");
	return;
    }
    
    while (fgets(sendbuf, BUFSIZE, fpWELCOME) != NULL) {
	(void) sendtoplayer(pplayer, sendbuf);
	(void) sendtoplayer(pplayer, "\r");  }
    
    fclose(fpWELCOME);
}

int    welcomeplayer2(pplayer)
struct splayer *pplayer;
{
    FILE *fpWELCOME;

    
    if ((fpWELCOME = fopen("hotel.bulletin", "r")) == (FILE *)0) {
	(void) sendtoplayer(pplayer, "Unable to open welcome file.\r\n");
	return;
    }
    
    while (fgets(sendbuf, BUFSIZE, fpWELCOME) != NULL) {
	(void) sendtoplayer(pplayer, sendbuf);
	(void) sendtoplayer(pplayer, "\r");  }
    
    fclose(fpWELCOME);
}

int  showwarning1(pplayer)
struct splayer *pplayer;
{
    FILE *fpWELCOME;

    
    if ((fpWELCOME = fopen("hotel.firstlogin", "r")) == (FILE *)0) {
	(void) sendtoplayer(pplayer, "Unable to open welcome file.\r\n");
	return;
    }
    
    while (fgets(sendbuf, BUFSIZE, fpWELCOME) != NULL) {
	(void) sendtoplayer(pplayer, sendbuf);
	(void) sendtoplayer(pplayer, "\r");  }
    
    fclose(fpWELCOME);
}


int changetime(pplayer)
     struct splayer *pplayer;
{
  struct rnames *temp;
  char *ltime;
  time_t now = time(0);

  setuseraddr(pplayer);
  ltime = ctime(&now);
  for(temp=regname;temp;temp=temp->next)
    if(!(strcasecmp(pplayer->name, temp->name))) {
      strncpy(temp->login, ltime, 25);
	temp->login[19] = '\0'; 
      free(temp->useraddr);
      temp->useraddr = allocmem(strlen(pplayer->useraddr));
      strcpy(temp->useraddr, pplayer->useraddr);
    }
  return 1;
}

int isloggedin(name)
     char *name;
{
  struct splayer *temp;
  for (temp=players; temp; temp=temp->next) {
    if(!strcasecmp(name, temp->name))
      return 1;
  }
  return 0;
}


int checklastlog(pplayer, name)
     char *name;
     struct splayer *pplayer;
{
  struct rnames *temp;
  if(!(registered(name))) {
    sprintf(sendbuf, ">> %s:  %s is not registered in %s\r\n",CORE,name,CORE);
    sendtoplayer(pplayer,sendbuf);
  } else {
    for (temp=regname; temp; temp=temp->next) {
      if(!(strcasecmp(name,temp->name))) {
	if(!isloggedin(temp->name)) {
	  sprintf(sendbuf, ">> %s:  %s last logged in %s\r\n",CORE,temp->name,temp->login);
	  sendtoplayer(pplayer,sendbuf);
	} else {
	  sprintf(sendbuf, ">> %s:  %s is currently logged in.\r\n",CORE,temp->name);
	  sendtoplayer(pplayer,sendbuf);
	}
	if(temp->useraddr[0] != '\0') {
	  sprintf(sendbuf, ">> %s:  %s's published e-mail address:  %s\r\n",CORE,temp->name,temp->useraddr);
	  sendtoplayer(pplayer,sendbuf);
	}
      }
    }
  }
  return 0;
}   

int dig(pplayer, buf)
     struct splayer *pplayer;
     char *buf;
{
  struct sroom *temp;
  char *dir;
  if(isroomowner(pplayer->channel, pplayer->name)) {
    if(*buf != '\000') {
      dir = buf;
      while(!isspace(*buf) && (*buf != '\000')) buf++;
      while(isspace(*buf)) buf++;
      if(isroom(buf) && (*buf != '\000')) {
	for(temp=proom; temp; temp=temp->next)
	  if(!strcmp(temp->name,pplayer->channel)) {
	    switch(*dir) {
	    case 'n':
	      strcpy(temp->north,buf);
	      sprintf(sendbuf,">> %s:  Passage dug north to %s.\r\n",CORE,buf);
	      sendtoplayer(pplayer,sendbuf);
	      break;
	    case 's':
	      strcpy(temp->south,buf);
	      sprintf(sendbuf,">> %s:  Passage dug south to %s.\r\n",CORE,buf);
	      sendtoplayer(pplayer,sendbuf);
	      break;
	    case 'e':
	      strcpy(temp->east,buf);
	      sprintf(sendbuf,">> %s:  Passage dug east to %s.\r\n",CORE,buf);
	      sendtoplayer(pplayer,sendbuf);
	      break;
	    case 'w':
	      strcpy(temp->west,buf);
	      sprintf(sendbuf,">> %s:  Passage dug west to %s.\r\n",CORE,buf);
	      sendtoplayer(pplayer,sendbuf);
	      break;
	    case 'u':
	      strcpy(temp->up,buf);
	      sprintf(sendbuf,">> %s:  Passage dug up to %s.\r\n",CORE,buf);
	      sendtoplayer(pplayer,sendbuf);
	      break;
	    case 'd':
	      strcpy(temp->down,buf);
	      sprintf(sendbuf,">> %s:  Passage dug down to %s.\r\n",CORE,buf);
	      sendtoplayer(pplayer,sendbuf);
	      break;
	   
	    default:
	      sendtoplayer(pplayer, ">> SYNTAX:  .|d <n,s,e,w,u,d> <room>\r\n");
	    }
	  }
      } else if (*buf == '\000') {
	for(temp=proom;temp;temp=temp->next)
	  if(!strcmp(pplayer->channel,temp->name))
	    switch(*dir) {
	    case 'n':  strcpy(temp->north, "\0");  sendtoplayer(pplayer, ">> North pointer erased.\r\n"); break;
	    case 's':  strcpy(temp->south, "\0");  sendtoplayer(pplayer, ">> South pointer erased.\r\n"); break;
	    case 'e':  strcpy(temp->east, "\0");  sendtoplayer(pplayer, ">> East pointer erased.\r\n");   break;
	    case 'w':  strcpy(temp->west, "\0");  sendtoplayer(pplayer, ">> West pointer erased.\r\n");   break;
	    case 'u':  strcpy(temp->up, "\0");  sendtoplayer(pplayer, ">> Up pointer erased.\r\n");   break;
	    case 'd':  strcpy(temp->down, "\0");  sendtoplayer(pplayer, ">> Down pointer erased.\r\n");   break;
	    default: sendtoplayer(pplayer, ">> SYNTAX: .|d <n,s,e,w,u,d> [<room>]\r\n"); break;
	    }
      } else {
	sprintf(sendbuf, ">> %s:  %s is not a valid room.\r\n",CORE, buf);
	sendtoplayer(pplayer, sendbuf);
      }
    } else {
      sendtoplayer(pplayer, ">> SYNTAX:  .|d <dir> <room>\r\n");
    }
  } else {
    sprintf(sendbuf, ">> %s:  You do not own this room\r\n",CORE);
    sendtoplayer(pplayer,sendbuf);
  }
  return 0;
}
    

int isnorth(room)
     char *room;
{
  struct sroom *temp;
  for(temp = proom; temp; temp=temp->next)
    if(!strcmp(temp->name, room)) {
      targroom = temp->north;
      if (*targroom != '\000') return 1;
      else return 0;
    }
  return 0;
}

int issouth(room)
     char *room;
{
  struct sroom *temp;
  for(temp = proom; temp; temp=temp->next)
    if(!strcmp(temp->name, room)) {
      targroom = temp->south;
      if (*targroom != '\000') return 1;
      else return 0;
    }
  return 0;
}

int iswest(room)
     char *room;
{
  struct sroom *temp;
  for(temp = proom; temp; temp=temp->next)
    if(!strcmp(temp->name, room)) {
      targroom = temp->west;
      if (*targroom != '\000') return 1;
      else return 0;
    }
  return 0;
}

int iseast(room)
     char *room;
{
  struct sroom *temp;
  for(temp = proom; temp; temp=temp->next)
    if(!strcmp(temp->name, room)) {
      targroom = temp->east;
      if (*targroom != '\000') return 1;
      else return 0;
    }
  return 0;
}

int isup(room)
     char *room;
{
  struct sroom *temp;
  for(temp = proom; temp; temp=temp->next)
    if(!strcmp(temp->name, room)) {
      targroom = temp->up;
      if (*targroom != '\000') return 1;
      else return 0;
    }
  return 0;
}

int isdown(room)
     char *room;
{
  struct sroom *temp;
  for(temp = proom; temp; temp=temp->next)
    if(!strcmp(temp->name, room)) {
      targroom = temp->down;
      if (*targroom != '\000') return 1;
      else return 0;
    }
  return 0;
}

int gonorth(pplayer)
     struct splayer *pplayer;
{
  if(isnorth(pplayer->channel))
    goroom(pplayer, "north");
  else {
    sprintf(sendbuf, ">> %s:  You can't go north!\r\n",CORE);
  }
}

int gosouth(pplayer)
     struct splayer *pplayer;
{
  if(issouth(pplayer->channel))
    goroom(pplayer, "south");
  else {
    sprintf(sendbuf, ">> %s:  You can't go south!\r\n",CORE);
    sendtoplayer(pplayer,sendbuf);
  }
}

int gowest(pplayer)
     struct splayer *pplayer;
{
  if(iswest(pplayer->channel))
    goroom(pplayer, "west");
  else {
    sprintf(sendbuf, ">> %s:  You can't go west!\r\n",CORE);
    sendtoplayer(pplayer,sendbuf);
  }
}

int goeast(pplayer)
     struct splayer *pplayer;
{
  if(iseast(pplayer->channel))
    goroom(pplayer, "east");
  else {
    sprintf(sendbuf, ">> %s:  You can't go east!\r\n",CORE);
    sendtoplayer(pplayer,sendbuf);
  }
}

int goup(pplayer)
     struct splayer *pplayer;
{
  if(isup(pplayer->channel))
    goroom(pplayer, "up");
  else {
    sprintf(sendbuf, ">> %s:  You can't go up!\r\n",CORE);
    sendtoplayer(pplayer,sendbuf);
  }
}

int godown(pplayer)
     struct splayer *pplayer;
{
  if(isdown(pplayer->channel))
    goroom(pplayer, "down");
  else {
    sprintf(sendbuf, ">> %s:  You can't go down!\r\n",CORE);
    sendtoplayer(pplayer,sendbuf);
  }
}

int goroom(pplayer, dir)
     struct splayer *pplayer;
     char *dir;
{
  char oldchan[15];
  if(issecure(targroom)) {
    sprintf(sendbuf, ">> %s is secure.  You hit the locked door with a resounding THUD!\r\n",targroom);
    sendtoplayer(pplayer,sendbuf);
  } else if(issanct(pplayer, targroom)) {
    sprintf(sendbuf, ">> %s is a sanctuary.  You hit the locked door with a resounding THUD!\r\n",targroom);
    sendtoplayer(pplayer,sendbuf);
  } else {
    sprintf(sendbuf, ">> (%d) %s walked %s to %s\r\n",pplayer->s,pplayer->name,dir,targroom);
    sendall(sendbuf, pplayer->channel, 0, 0);
    strcpy(oldchan, pplayer->channel);
    setchannel(pplayer->s, targroom);
    sprintf(sendbuf, ">> (%d) %s has walked in from %s\r\n", pplayer->s, pplayer->name, oldchan);
    sendall(sendbuf, pplayer->channel, 0,0);
    doroom(pplayer);
  }
}

int showexits(pplayer)
     struct splayer *pplayer;
{
  int c = 0;
  struct sroom *temp;
  for(temp=proom; temp; temp=temp->next)
    if(!strcmp(temp->name, pplayer->channel)) {
      sprintf(sendbuf, ">> You can go: ");
      if(*temp->north != '\0') { c=1; strcat(sendbuf, " north"); }
      if(*temp->south != '\0') { c=1; strcat(sendbuf, " south"); }
      if(*temp->east != '\0') { c=1; strcat(sendbuf, " east"); }
      if(*temp->west != '\0') { c=1; strcat(sendbuf, " west"); }
      if(*temp->up != '\0') { c=1; strcat(sendbuf, " up"); }
      if(*temp->down != '\0') { c=1; strcat(sendbuf, " down"); }
      if(c == 0) strcat(sendbuf, " nowhere");
      strcat(sendbuf, "\r\n");
      sendtoplayer(pplayer,sendbuf);
    }
  return 0;
}

int listexits(pplayer)
     struct splayer *pplayer;
{
  int c = 0;
  struct sroom *temp;
  for(temp=proom;temp;temp=temp->next)
    if(!strcmp(temp->name, pplayer->channel)) {
      if((temp->north[0] != '\000')) {
	sprintf(sendbuf, ">> North -> %s\r\n",temp->north);
	sendtoplayer(pplayer,sendbuf);
	c = 1;
      }
      if((temp->south[0] != '\000')) {
	sprintf(sendbuf, ">> South -> %s\r\n",temp->south);
	sendtoplayer(pplayer,sendbuf);
	c = 1;
      }
      if((temp->east[0] != '\000')) {
	sprintf(sendbuf, ">> East -> %s\r\n",temp->east);
	sendtoplayer(pplayer,sendbuf);
	c = 1;
      }
      if((temp->west[0] != '\000')) {
	sprintf(sendbuf, ">> West -> %s\r\n",temp->west);
	sendtoplayer(pplayer,sendbuf);
	c = 1;
      }
      if((temp->up[0] != '\000')) {
	sprintf(sendbuf, ">> Up -> %s\r\n",temp->up);
	sendtoplayer(pplayer,sendbuf);
	c = 1;
      }
      if((temp->down[0] != '\000')) {
	sprintf(sendbuf, ">> Down -> %s\r\n",temp->down);
	sendtoplayer(pplayer,sendbuf);
	c = 1;
      }
      if(c == 0) sendtoplayer(pplayer, ">> No exits from this room/channel.\r\n");
    }
}


int parsemesg(pplayer,mesg)
     char *mesg;
     struct splayer *pplayer;
{
    char *buf=mesg;
    char *btmp;
    char *ctmp;
    int count;
    char *user;
    char *message;

       	if ((buf = index(mesg, '\r')) != (char *)0) {
	    *buf = '\000';
	}
	if ((buf = index(mesg, '\n')) != (char *)0) {
	    *buf = '\000';
	}
	
	buf= mesg;
	while (isspace(*buf) && (*buf != '\000'))
	    buf++;
	
	count = strlen(buf)-1;
	while (isspace(buf[count])) {
	  buf[count] = '\000';
	  count--;
          }   
	if (*buf != '\000') {
	    ctmp = buf;
	    if ((ctmp = index(buf, '=')) == (char *)0) {
	      sendtoplayer(pplayer, ">> SYNTAX:  .Z user = message\r\n");
	      return 0;
	    } else {
	      count = 1;
              while((buf[count] != '=') && (count < strlen(buf)))
		count++;
              buf[count] = '\000';
              user = buf;
	      buf = buf + count + 1;
              message = buf;
	      count = strlen(user)-1;
	      while(isspace(user[count])){
		user[count] = '\000';
		count--;
	      }
	      while(isspace(*message) && (*message != '\000'))
		message++;
              if (isoverquota(user)) {
                  sprintf(sendbuf, ">> %s: %s is over quota\r\n",CORE,user);
                  sendtoplayer(pplayer,sendbuf);
              } else if (iszsup(user)) { 
                  sprintf(sendbuf, ">> %s has suppressed Zmail.\r\n",user);       
                  sendtoplayer(pplayer,sendbuf);
              } else if (isgagged(pplayer, user)) {
                  sprintf(sendbuf, ">> %s has you gagged, Zmail unsent!\r\n",user);
                  sendtoplayer(pplayer,sendbuf);
     	      } else if ((registered(user)) && (!(isoverquota(user))) && (!(isgagged(pplayer, user))) && (!(iszsup(user)))) {
		  sendmail(pplayer->name, user, message);
		    sprintf(sendbuf, ">> You suddenly feel a cool mist surround you\r\n>> A mystical hand reaches out from the sky and takes your letter to %s.\r\n",user);
                 if (isplayer(pplayer, ECHO)) {
                    sprintf(sendbuf, ">> You suddenly feel a cool mist surround you\r\n>> A mystical hand reaches out from the sky and takes your letter reading \"%s\" to %s.\r\n",message,user);
                 }
                  sendtoplayer(pplayer,sendbuf);
		    return 0;
	      } else if (!(registered(user))) {
		sprintf(sendbuf, ">> %s:  %s is not registered in the %s database.\r\n",CORE,user,CORE);
		sendtoplayer(pplayer, sendbuf);
		return 0;
	      }
	    }
	} else {
	    sprintf(sendbuf, ">> SYNTAX:  .Z user = message\r\n");
	    sendtoplayer(pplayer, sendbuf);
	}
    return 0;
  }

int parseverb(pplayer, verb)
     char *verb;
     struct splayer *pplayer;
{
  struct sverb *temp;
  char *buf=verb;
  char *ctmp;
  int count;
  int newptr = 0;
  int verbptr = 0;
  int subptr = 0;
  int linenum = -1;
  char *name;
  struct splayer *who;
  char *subst;
  
  if ((buf = index(verb, '\r')) != (char *)0) {
    *buf = '\000';
  }
  if ((buf = index(verb, '\n')) != (char *)0) {
    *buf = '\000';
  }
  
  buf= verb;
  while (isspace(*buf) && (*buf != '\000'))
    buf++;
  
  count = strlen(buf)-1;
  while (isspace(buf[count])) {
    buf[count] = '\000';
    count--;
  }
  if (*buf != '\000') {
    ctmp=buf;
    if((ctmp = index(buf, ' ')) == (char *)0) {
      linenum = -1;
      name = buf;
      subst = nullstr;
      nullstr[0] = '\0';
    } else {
      count = 0;
      while(buf[count] != ' ' && buf[count] != '\000') count++;
      buf[count] = '\000';
      name = buf;
      buf = buf+count+1;
      subst = buf;
      while(isspace(*subst) && (*subst != '\000'))
	subst++;
      if (isdigit(*subst)) linenum = atoi(subst); else linenum = -1;
      if (linenum != -1) {
	who = lookup(linenum);
	if (who == (struct splayer *)0) {
	  verberror(pplayer);
	  return 0;
	}
      }
    }
    if (isverb(name)) {
      if (mayuse(pplayer->name,name)) {
	for(temp = pverb; temp; temp=temp->next) {
	  if (!(strcasecmp(temp->verbname, name))) {
	    while ((temp->verb[verbptr] != '\000') && (newptr < BUFSIZE)) {
              if (newptr > 600) return -1;
	      if(temp->verb[verbptr] == '%') {
		verbptr++;
		if (temp->verb[verbptr] == 't') {
		  subptr = 0;
		  while ((subst[subptr] != '\000') && (newptr < BUFSIZE)) {
		    newverb[newptr] = subst[subptr];
		    newptr++;
		    subptr++;
		  }
		  verbptr++;
		}
                else if (temp->verb[verbptr] == 'g') {
                  if (linenum == -1) {
                    verberror(pplayer);
                    return 0;
                  }
                  if(who->gender == 'm') {
                    newverb[newptr] = 'h';
                    newptr++;
                    newverb[newptr] = 'e';
                    newptr++;
		  } else if(pplayer->gender == 'p') {
		    newverb[newptr] = 't';
		    newptr++;
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'e';
		    newptr++;
		    newverb[newptr] = 'i';
		    newptr++;
		    newverb[newptr] = 'r';
		    newptr++;
                  } else if(who->gender == 'f') {
                    newverb[newptr] = 's';
                    newptr++;
                    newverb[newptr] = 'h';
                    newptr++;
                    newverb[newptr] = 'e';
                    newptr++;
                  } else {
                    newverb[newptr] = 'i';
                    newptr++;
                    newverb[newptr] = 't';
                    newptr++;
                  }
                  verbptr++;
                }
                else if (temp->verb[verbptr] == 'G') {
                  if (linenum == -1) {
                    verberror(pplayer);
                    return 0;
                  }
                  if(who->gender == 'm') {
                    newverb[newptr] = 'h';
                    newptr++;
                    newverb[newptr] = 'i';
                    newptr++;
                    newverb[newptr] = 'm';
                    newptr++;
		  } else if(who->gender == 'p') {
		    newverb[newptr] = 't';
		    newptr++;
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'e';
		    newptr++;
		    newverb[newptr] = 'm';
		    newptr++;
                  } else if(who->gender == 'f') {
                    newverb[newptr] = 'h';
                    newptr++;
                    newverb[newptr] = 'e';
                    newptr++;
                    newverb[newptr] = 'r';
                    newptr++;
                  } else {
                    newverb[newptr] = 'i';
                    newptr++;
                    newverb[newptr] = 't';
                    newptr++;
                  }
                  verbptr++;
                }
                else if (temp->verb[verbptr] == 'p') {
                  if (linenum == -1) {
                    verberror(pplayer);
                    return 0;
                  }
                  if(who->gender == 'm') {
                    newverb[newptr] = 'h';
                    newptr++;
                    newverb[newptr] = 'i';
                    newptr++;
                    newverb[newptr] = 's';
                    newptr++;
		  } else if(who->gender == 'p') {
		    newverb[newptr] = 't';
		    newptr++;
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'e';
		    newptr++;
		    newverb[newptr] = 'y';
		    newptr++;
                  } else if(who->gender == 'f') {
                    newverb[newptr] = 'h';
                    newptr++;
                    newverb[newptr] = 'e';
                    newptr++;
                    newverb[newptr] = 'r';
                    newptr++;
                  } else {
                    newverb[newptr] = 'i';
                    newptr++;
                    newverb[newptr] = 't';
                    newptr++;
                    newverb[newptr] = 's';
                    newptr++;
                  }
                  verbptr++;
                }
		else if (temp->verb[verbptr] == 'n') {
		  if (linenum == -1) {
		    verberror(pplayer);
		    return 0;
		  }
		  subptr = 0;
		  while ((who->name[subptr] != '\000') && (newptr < BUFSIZE)) {
		    newverb[newptr] = who->name[subptr];
		    newptr++;
		    subptr++;
		  }
		  verbptr++;
		}
		else if (temp->verb[verbptr] == 's') {
		  if (linenum == -1) {
		    verberror(pplayer);
		    return 0;
		  }
		  subptr = 0;
		  while ((who->onfrom[subptr] != '\000') && (newptr < BUFSIZE)) {
		    newverb[newptr] = who->onfrom[subptr];
		    newptr++;
		    subptr++;
		  }
		  verbptr++;
		}
		else if (temp->verb[verbptr] == 'c') {
		  if (linenum == -1) {
		    verberror(pplayer);
		    return 0;
		  }
		  subptr = 0;
		  while ((who->channel[subptr] != '\000') && (newptr < BUFSIZE)) {
		    newverb[newptr] = who->channel[subptr];
		    newptr++;
		    subptr++;
		  }
		  verbptr++;
		}
		else if (temp->verb[verbptr] == 'i') {
		  if (linenum == -1) {
		    verberror(pplayer);
		    return 0;
		  }
		  subptr = 0;
		  while ((idlet(who->idle)[subptr] != '\000') && (newptr < BUFSIZE)) {
		    newverb[newptr] = idlet(who->idle)[subptr];
		    newptr++;
		    subptr++;
		  }
		  verbptr++;
		}
		else if (temp->verb[verbptr] == '%') {
		  newverb[newptr] = '%';
		  newptr++;
		  verbptr++;
		}
		else if (temp->verb[verbptr] == '\000') ;
		else {
		  newverb[newptr] = '%';
		  newptr++;
		}
	      } else if(temp->verb[verbptr] == '$') {
		verbptr++;
		if (temp->verb[verbptr] == 'p') {
		  if(pplayer->gender == 'm') {
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'i';
		    newptr++;
		    newverb[newptr] = 's';
		    newptr++;
		  } else if(pplayer->gender == 'p') {
		    newverb[newptr] = 't';
		    newptr++;
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'e';
		    newptr++;
		    newverb[newptr] = 'i';
		    newptr++;
		    newverb[newptr] = 'r';
		    newptr++;
		  } else if(pplayer->gender == 'f') {
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'e';
		    newptr++;
		    newverb[newptr] = 'r';
		    newptr++;
		  } else {
		    newverb[newptr] = 'i';
		    newptr++;
		    newverb[newptr] = 't';
		    newptr++;
		    newverb[newptr] = 's';
		    newptr++;
		  }
		  verbptr++;
		}
		else if (temp->verb[verbptr] == 'G') {
		  if(pplayer->gender == 'm') {
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'i';
		    newptr++;
		    newverb[newptr] = 'm';
		    newptr++;
		  } else if(pplayer->gender == 'p') {
		    newverb[newptr] = 't';
		    newptr++;
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'e';
		    newptr++;
		    newverb[newptr] = 'm';
		    newptr++;
		  } else if(pplayer->gender == 'f') {
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'e';
		    newptr++;
		    newverb[newptr] = 'r';
		    newptr++;
		  } else {
		    newverb[newptr] = 'i';
		    newptr++;
		    newverb[newptr] = 't';
		    newptr++;
		  }
		  verbptr++;
		}
		else if (temp->verb[verbptr] == 'g') {
		  if(pplayer->gender == 'm') {
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'e';
		    newptr++;
		  } else if(pplayer->gender == 'p') {
		    newverb[newptr] = 't';
		    newptr++;
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'e';
		    newptr++;
		    newverb[newptr] = 'y';
		    newptr++;
		  } else if(pplayer->gender == 'f') {
		    newverb[newptr] = 's';
		    newptr++;
		    newverb[newptr] = 'h';
		    newptr++;
		    newverb[newptr] = 'e';
		    newptr++;
		  } else {
		    newverb[newptr] = 'i';
		    newptr++;
		    newverb[newptr] = 't';
		    newptr++;
		  }
		  verbptr++;
		}
		else if (temp->verb[verbptr] == 'n') {
		  subptr = 0;
		  while ((pplayer->name[subptr] != '\000') && (newptr < BUFSIZE)) {
		    newverb[newptr] = pplayer->name[subptr];
		    newptr++;
		    subptr++;
		  }
		  verbptr++;
		}
		else if (temp->verb[verbptr] == 's') {
		  subptr = 0;
		  while ((pplayer->onfrom[subptr] != '\000') && (newptr < BUFSIZE)) {
		    newverb[newptr] = pplayer->onfrom[subptr];
		    newptr++;
		    subptr++;
		  }
		  verbptr++;
		}
		else if (temp->verb[verbptr] == 'c') {
		  subptr = 0;
		  while ((pplayer->channel[subptr] != '\000') && (newptr < BUFSIZE)) {
		    newverb[newptr] = pplayer->channel[subptr];
		    newptr++;
		    subptr++;
		  }
		  verbptr++;
		}
		else if (temp->verb[verbptr] == 'i') {
		  subptr = 0;
		  while ((idlet(pplayer->idle)[subptr] != '\000') && (newptr < BUFSIZE)) {
		    newverb[newptr] = idlet(pplayer->idle)[subptr];
		    newptr++;
		    subptr++;
		  }
		  verbptr++;
		}
		else if (temp->verb[verbptr] == '$') {
		  newverb[newptr] = '$';
		  newptr++;
		  verbptr++;
		}
		else if (temp->verb[verbptr] == '\000') ;
		else {
		  newverb[newptr] = '$';
		  newptr++;
		}
	      } else {
		newverb[newptr] = temp->verb[verbptr];
		newptr++;
		verbptr++;
	      } /* end if */
	    }	    
	    newverb[newptr] = '\000';
	  }
	}
      } else {
	sprintf(sendbuf, ">> %s:  @%s is a private verb.  You may not use it.\r\n",CORE,name);
	sendtoplayer(pplayer,sendbuf);
	return 0; }
    } else {
      sprintf(sendbuf, ">> %s:  @%s is not a legal verb.\r\n",CORE, name);
      sendtoplayer(pplayer,sendbuf);
      return 0;
    }
  } else {
    sprintf(sendbuf, ">> %s:  @ is not a legal verb.\r\n",CORE);
    sendtoplayer(pplayer,sendbuf);
    return 0;
  }
  return 1;
}

int canact(pplayer,actn)
     struct splayer *pplayer;
     char *actn;
{
  struct slink *temp;
  for(temp=plink;temp;temp=temp->next) {
    if(!strcasecmp(temp->name, actn)) {
      if(isobjonsamelevelp(pplayer, temp->object))
	return 1;
      return (isobjinroom(temp->object,pplayer->channel) || isobjonuser(temp->object, pplayer->name)); 
    }
  }
  return 0;
}

int doaction(pplayer, verb)
     char *verb;
     struct splayer *pplayer;{

  struct slink *temp;
  char *buf=verb;
  char *ctmp;
  int count;
  int newptr = 0;
  int verbptr = 0;
  int subptr = 0;
  int linenum = -1;
  char *name;
  struct splayer *who;
  char *subst;
  
       	if ((buf = index(verb, '\r')) != (char *)0) {
	    *buf = '\000';
	}
	if ((buf = index(verb, '\n')) != (char *)0) {
	    *buf = '\000';
	}
	
	buf= verb;
	while (isspace(*buf) && (*buf != '\000'))
	    buf++;
	
	count = strlen(buf)-1;
	while (isspace(buf[count])) {
	  buf[count] = '\000';
	  count--;
	}
  if (*buf != '\000') {
    ctmp=buf;
    if((ctmp = index(buf, ' ')) == (char *)0) {
      linenum = -1;
	name = buf;
	subst = nullstr;
	nullstr[0] = '\0';
    } else {
      count = 0;
      while(buf[count] != ' ' && buf[count] != '\000') count++;
      buf[count] = '\000';
      name = buf;
      buf = buf+count+1;
      subst = buf;
      while(isspace(*subst) && (*subst != '\000'))
	subst++;
      if (isdigit(*subst)) linenum = atoi(subst); else linenum = -1;
      if (linenum != -1) {
	who = lookup(linenum);
	if (who == (struct splayer *)0) {
	  verberror(pplayer);
	  return 0;
	}
      }
    }
    if (isaction(name) && canact(pplayer,name)) {
      for(temp = plink; temp; temp=temp->next) {
	if (!(strcasecmp(temp->name, name))) {
	  while ((temp->verb[verbptr] != '\000') && (newptr < BUFSIZE)) {
            if(newptr > 600) return -1;
	    if(temp->verb[verbptr] == '%') {
	      verbptr++;
	      if (temp->verb[verbptr] == 't') {
		subptr = 0;
		while ((subst[subptr] != '\000') && (newptr < BUFSIZE)) {
		  newverb[newptr] = subst[subptr];
		  newptr++;
		  subptr++;
		}
		verbptr++;
	      }
              else if (temp->verb[verbptr] == 'p') {
                if (linenum == -1) {
                  verberror(pplayer);
                  return 0;
                }
                if(who->gender == 'm') {
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'i';
                  newptr++;
                  newverb[newptr] = 's';
                  newptr++;
		} else if(who->gender == 'p') {
		  newverb[newptr] = 't';
		  newptr++;
		  newverb[newptr] = 'h';
		  newptr++;
		  newverb[newptr] = 'e';
		  newptr++;
		  newverb[newptr] = 'i';
		  newptr++;
		  newverb[newptr] = 'r';
		  newptr++;
                } else if(who->gender == 'f') {
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'e';
                  newptr++;
                  newverb[newptr] = 'r';
                  newptr++;
                } else {
                  newverb[newptr] = 'i';
                  newptr++;
                  newverb[newptr] = 't';
                  newptr++;
                  newverb[newptr] = 's';
                  newptr++;
                }
                verbptr++;
              }
              else if (temp->verb[verbptr] == 'G') {
                if (linenum == -1) {
                  verberror(pplayer);
                  return 0;
                }
                if(who->gender == 'm') {
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'i';
                  newptr++;
                  newverb[newptr] = 'm';
                  newptr++;
		} else if(who->gender == 'p') {
		  newverb[newptr] = 't';
		  newptr++;
		  newverb[newptr] = 'h';
		  newptr++;
		  newverb[newptr] = 'e';
		  newptr++;
		  newverb[newptr] = 'm';
		  newptr++;
                } else if(who->gender == 'f') {
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'e';
                  newptr++;
                  newverb[newptr] = 'r';
                  newptr++;
                } else {
                  newverb[newptr] = 'i';
                  newptr++;
                  newverb[newptr] = 't';
                  newptr++;
                }
                verbptr++;
              }
              else if (temp->verb[verbptr] == 'g') {
                if (linenum == -1) {
                  verberror(pplayer);
                  return 0;
                }
                if(who->gender == 'm') {
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'e';
                  newptr++;
		} else if(who->gender == 'p') {
		  newverb[newptr] = 't';
		  newptr++;
		  newverb[newptr] = 'h';
		  newptr++;
		  newverb[newptr] = 'e';
		  newptr++;
		  newverb[newptr] = 'y';
		  newptr++;
                } else if(who->gender == 'f') {
                  newverb[newptr] = 's';
                  newptr++;
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'e';
                  newptr++;
                } else {
                  newverb[newptr] = 'i';
                  newptr++;
                  newverb[newptr] = 't';
                  newptr++;
                }
                verbptr++;
              }
	      else if (temp->verb[verbptr] == 'n') {
		if (linenum == -1){
		  verberror(pplayer);
		  return 0;
		}
		subptr = 0;
		while ((who->name[subptr] != '\000') && (newptr < BUFSIZE)) {
		  newverb[newptr] = who->name[subptr];
		  newptr++;
		  subptr++;
		}
		verbptr++;
	      }
	      else if (temp->verb[verbptr] == 's') {
		if (linenum == -1) {
		  verberror(pplayer);
		  return 0;
		}
		subptr = 0;
		while ((who->onfrom[subptr] != '\000') && (newptr < BUFSIZE)) {
		  newverb[newptr] = who->onfrom[subptr];
		  newptr++;
		  subptr++;
		}
		verbptr++;
	      }
	      else if (temp->verb[verbptr] == 'c') {
		if (linenum == -1) {
		  verberror(pplayer);
		  return 0;
		}
		subptr = 0;
		while ((who->channel[subptr] != '\000') && (newptr < BUFSIZE)) {
		  newverb[newptr] = who->channel[subptr];
		  newptr++;
		  subptr++;
		}
		verbptr++;
	      }
	      else if (temp->verb[verbptr] == 'i') {
		if (linenum == -1) {
		  verberror(pplayer);
		  return 0;
		}
		subptr = 0;
		while ((idlet(who->idle)[subptr] != '\000') && (newptr < BUFSIZE)) {
		  newverb[newptr] = idlet(who->idle)[subptr];
		  newptr++;
		  subptr++;
		}
		verbptr++;
	      }
	      else if (temp->verb[verbptr] == '%') {
		newverb[newptr] = '%';
		newptr++;
		verbptr++;
	      }
	      else if (temp->verb[verbptr] == '\000') ;
	      else {
		newverb[newptr] = '%';
		newptr++;
	      }
	    } else if(temp->verb[verbptr] == '$') {
	      verbptr++;
              if (temp->verb[verbptr] == 'p') {
                if(pplayer->gender == 'm') {
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'i';
                  newptr++;
                  newverb[newptr] = 's';
                  newptr++;
		} else if(pplayer->gender == 'p') {
		  newverb[newptr] = 't';
		  newptr++;
		  newverb[newptr] = 'h';
		  newptr++;
		  newverb[newptr] = 'e';
		  newptr++;
		  newverb[newptr] = 'i';
		  newptr++;
		  newverb[newptr] = 'r';
		  newptr++;
                } else if(pplayer->gender == 'f') {
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'e';
                  newptr++;
                  newverb[newptr] = 'r';
                  newptr++;
                } else {
                  newverb[newptr] = 'i';
                  newptr++;
                  newverb[newptr] = 't';
                  newptr++;
                  newverb[newptr] = 's';
                  newptr++;
                }
                verbptr++;
              }
              else if (temp->verb[verbptr] == 'G') {
                if(pplayer->gender == 'm') {
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'i';
                  newptr++;
                  newverb[newptr] = 'm';
                  newptr++;
		} else if(pplayer->gender == 'p') {
		  newverb[newptr] = 't';
		  newptr++;
		  newverb[newptr] = 'h';
		  newptr++;
		  newverb[newptr] = 'e';
		  newptr++;
		  newverb[newptr] = 'm';
		  newptr++;
                } else if(pplayer->gender == 'f') {
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'e';
                  newptr++;
                  newverb[newptr] = 'r';
                  newptr++;
                } else {
                  newverb[newptr] = 'i';
                  newptr++;
                  newverb[newptr] = 't';
                  newptr++;
                }
                verbptr++;
              }
              else if (temp->verb[verbptr] == 'g') {
                if(pplayer->gender == 'm') {
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'e';
                  newptr++;
		} else if(pplayer->gender == 'p') {
		  newverb[newptr] = 't';
		  newptr++;
		  newverb[newptr] = 'h';
		  newptr++;
		  newverb[newptr] = 'e';
		  newptr++;
		  newverb[newptr] = 'y';
		  newptr++;
                } else if(pplayer->gender == 'f') {
                  newverb[newptr] = 's';
                  newptr++;
                  newverb[newptr] = 'h';
                  newptr++;
                  newverb[newptr] = 'e';
                  newptr++;
                } else {
                  newverb[newptr] = 'i';
                  newptr++;
                  newverb[newptr] = 't';
                  newptr++;
                }
                verbptr++;
              }
	      else if (temp->verb[verbptr] == 'n') {
		subptr = 0;
		while ((pplayer->name[subptr] != '\000') && (newptr < BUFSIZE)) {
		  newverb[newptr] = pplayer->name[subptr];
		  newptr++;
		  subptr++;
		}
		verbptr++;
	      }
	      else if (temp->verb[verbptr] == 's') {
		subptr = 0;
		while ((pplayer->onfrom[subptr] != '\000') && (newptr < BUFSIZE)) {
		  newverb[newptr] = pplayer->onfrom[subptr];
		  newptr++;
		  subptr++;
		}
		verbptr++;
	      }
	      else if (temp->verb[verbptr] == 'c') {
		subptr = 0;
		while ((pplayer->channel[subptr] != '\000') && (newptr < BUFSIZE)) {
		  newverb[newptr] = pplayer->channel[subptr];
		  newptr++;
		  subptr++;
		}
		verbptr++;
	      }
	      else if (temp->verb[verbptr] == 'i') {
		subptr = 0;
		while ((idlet(pplayer->idle)[subptr] != '\000') && (newptr < BUFSIZE)) {
		  newverb[newptr] = idlet(pplayer->idle)[subptr];
		  newptr++;
		  subptr++;
		}
		verbptr++;
	      }
	      else if (temp->verb[verbptr] == '$') {
		newverb[newptr] = '$';
		newptr++;
		verbptr++;
	      }
	      else if (temp->verb[verbptr] == '\000') ;
	      else {
		newverb[newptr] = '$';
		newptr++;
	      }
	    } else {
	      newverb[newptr] = temp->verb[verbptr];
	      newptr++;
	      verbptr++;
	    } /* end if */
 	  }
	  newverb[newptr] = '\000';
	}
      }
    } else {
      sprintf(sendbuf, ">> %s:  $%s is not a legal action.\r\n", CORE,name);
      sendtoplayer(pplayer,sendbuf);
      return 0;
    }
  } else {
    sprintf(sendbuf, ">> %s:  $ is not a legal action.\r\n",CORE);
    sendtoplayer(pplayer,sendbuf);
    return 0;
  }
  return 1;
}

int verberror(pplayer)
     struct splayer *pplayer;
{
  sprintf(sendbuf, ">> %s:  Error- incompatiable data types.  Try using a valid linenumber after the verb/action name.\r\n",CORE);
  sendtoplayer(pplayer,sendbuf);
  return 0;
}


int makeverb(pplayer,mesg)
     char *mesg;
     struct splayer *pplayer;
{
    char *buf=mesg;
    char *btmp;
    char *ctmp;
    int count;
    char *name;
    char *message;

       	if ((buf = index(mesg, '\r')) != (char *)0) {
	    *buf = '\000';
	}
	if ((buf = index(mesg, '\n')) != (char *)0) {
	    *buf = '\000';
	}
	
	buf= mesg;
	while (isspace(*buf) && (*buf != '\000'))
	    buf++;
        	
	count = strlen(buf)-1;
	while (isspace(buf[count])) {
	  buf[count] = '\000';
	  count--;
          }   
	if (*buf != '\000') {
	    ctmp = buf;
	    if ((ctmp = index(buf, '=')) == (char *)0) {
	      sendtoplayer(pplayer, ">> SYNTAX:  .@m verbname = action\r\n");
	      return 0;
	    } else {
	      count = 1;
              while((buf[count] != '=') && (count < strlen(buf)))
		count++;
              buf[count] = '\000';
              name = buf;
	      buf = buf + count + 1;
              message = buf;
	      count = strlen(name)-1;
	      while(isspace(name[count])){
		name[count] = '\000';
		count--;
	      }
	      if(strlen(name) >= 23)
	         name[23] = '\0';
	      while(isspace(*message) && (*message != '\000'))
		message++;
	      if ((*message == '\0') || (*name == '\0')) {
		sprintf(sendbuf, ">> %s:  Null verb or action.\r\n",CORE);
		sendtoplayer(pplayer,sendbuf);
		return -1;
	      }
	      if ((ctmp = index(name, ' ')) == (char *)0) {
		  if (!isverb(name)) {
                    if(isoverquota(pplayer->name) && (pplayer->seclevel != SUPREME)) {
			sprintf(sendbuf, ">> %s:  You are at or over quota.  Please delete one of your objects, rooms, or verbs before you build any more.\r\n",CORE);
			sendtoplayer(pplayer,sendbuf);
			return -1;
		    } else
		       if(addverb(pplayer, name, message) == -1) return -1;
		  } else {
		    if(changeverb(pplayer, name, message) == -1) return -1;
       
		  }
                  sprintf(sendbuf, "[SYSLOG:  Verb %s created/altered by %s]\r\n", name, pplayer->name);
                  sendall(sendbuf, "*", SYSLOG, 0);

		  if(1 == -1) {
		    sprintf(sendbuf, ">> %s:  Verb creation failed.  It exists but temporarily.\r\n",CORE);
		    sendtoplayer(pplayer,sendbuf);
		    return -1;
		  } else {
		    sprintf(sendbuf, ">> %s:  Verb @%s created.\r\n",CORE, name);
		    sendtoplayer(pplayer,sendbuf);
		    return 0;
		  }
	      } else {
		sprintf(sendbuf, ">> %s:  You can not put spaces in the names of verbs.\r\n",CORE);
		sendtoplayer(pplayer, sendbuf);
		return 0;
	      }
	    }
	} else {
	    sprintf(sendbuf, ">> SYNTAX:  .@m verbname = action\r\n");
	    sendtoplayer(pplayer, sendbuf);
	}
    return 0;
  }

int parseobject(pplayer,mesg)
     char *mesg;
     struct splayer *pplayer;
{
    char *buf=mesg;
    char *btmp;
    char *ctmp;
    int count;
    char *name;
    char *message;

       	if ((buf = index(mesg, '\r')) != (char *)0) {
	    *buf = '\000';
	}
	if ((buf = index(mesg, '\n')) != (char *)0) {
	    *buf = '\000';
	}
	
	buf= mesg;
	while (isspace(*buf) && (*buf != '\000'))
	    buf++;
	
	count = strlen(buf)-1;
	while (isspace(buf[count])) {
	  buf[count] = '\000';
	  count--;
          }   
	if (*buf != '\000') {
	    ctmp = buf;
	    if ((ctmp = index(buf, '=')) == (char *)0) {
	      sendtoplayer(pplayer, ">> SYNTAX:  .$c objectname = description\r\n");
	      return 0;
	    } else {
	      count = strlen(buf)-1;
              while((buf[count] != '=') && (count > -1))
		count--;
              buf[count] = '\000';
              name = buf;
	      buf = buf + count + 1;
              message = buf;
	      count = strlen(name)-1;
	      while(isspace(name[count])){
		name[count] = '\000';
		count--;
	      }
	      if(strlen(name) >= 23)
	         name[23] = '\0';
	      while(isspace(*message) && (*message != '\000'))
		message++;
	      if ((*message == '\0') || (*name == '\0')) {
		sprintf(sendbuf, ">> %s:  Null objectname or description.\r\n",CORE);
		sendtoplayer(pplayer,sendbuf);
		return -1;
	      }
	      if ((ctmp = index(name, ' ')) == (char *)0) {
		  if (!isobject(name)) {
		    if(isoverquota(pplayer->name) && (pplayer->seclevel != SUPREME)) {
			sprintf(sendbuf, ">> %s:  You are at or over quota.  Please delete one of your objects, rooms, or verbs before you build any more.\r\n",CORE);
			sendtoplayer(pplayer,sendbuf);
                        return -1;
                    } else 	
		      if(makeobject(pplayer, name, message) == -1) return -1;
		  } else {
		    if(changeobject(pplayer, name, message) == -1) return -1;
       
		  }
                  sprintf(sendbuf, "[SYSLOG:  Object %s created/altered by %s]\r\n", name, pplayer->name);
                  sendall(sendbuf, "*", SYSLOG, 0);

		  if(1 == -1) {
		    sprintf(sendbuf, ">> %s:  Object creation failed.  It exists but temporarily.\r\n",CORE);
		    sendtoplayer(pplayer,sendbuf);
		    return -1;
		  } else {
		    sprintf(sendbuf, ">> %s:  Object %s created.\r\n", CORE,name);
		    sendtoplayer(pplayer,sendbuf);
		    return 0;
		  }
	      } else {
		sprintf(sendbuf, ">> %s:  You can not put spaces in the names of objects.\r\n",CORE);
		sendtoplayer(pplayer, sendbuf);
		return 0;
	      }
	    }
	} else {
	    sprintf(sendbuf, ">> SYNTAX:  .$c objectname = description\r\n");
	    sendtoplayer(pplayer, sendbuf);
	}
    return 0;
  }

int isoverquota(name)
     char *name;
{
  struct rnames *temp;
  
  for (temp = regname; temp; temp=temp->next)
    if(!(strcasecmp(name, temp->name)))
      if((nummail(temp->name)+numobject(temp->name)+(2*numroom(temp->name))+(0.25*numaction(temp->name))+numverb(temp->name)) >= 60)
	return 1;
  return 0;
}
      	
int parselink(pplayer,mesg)
     char *mesg;
     struct splayer *pplayer;
{
    char *buf=mesg;
    char *btmp;
    char *ctmp;
    int count;
    char *name;
    char *message;

       	if ((buf = index(mesg, '\r')) != (char *)0) {
	    *buf = '\000';
	}
	if ((buf = index(mesg, '\n')) != (char *)0) {
	    *buf = '\000';
	}
	
	buf= mesg;
	while (isspace(*buf) && (*buf != '\000'))
	    buf++;
	
	count = strlen(buf)-1;
	while (isspace(buf[count])) {
	  buf[count] = '\000';
	  count--;
          }   
	if (*buf != '\000') {
	    ctmp = buf;
	    if ((ctmp = index(buf, '=')) == (char *)0) {
	      sendtoplayer(pplayer, ">> SYNTAX:  .$l actionname = object\r\n");
	      return 0;
	    } else {
	      count = strlen(buf)-1;
              while((buf[count] != '=') && (count > -1))
		count--;
              buf[count] = '\000';
              name = buf;
	      buf = buf + count + 1;
              message = buf;
	      count = strlen(name)-1;
	      while(isspace(name[count])){
		name[count] = '\000';
		count--;
	      }
	      if(strlen(name) >= 23)
	         name[23] = '\0';
	      while(isspace(*message) && (*message != '\000'))
		message++;
	      if ((*message == '\0') || (*name == '\0')) {
		sprintf(sendbuf, ">> %s:  Null objectname or actionname.\r\n",CORE);
		sendtoplayer(pplayer,sendbuf);
		return -1;
	      }
	      if ((ctmp = index(name, ' ')) == (char *)0) {
		  if (!isaction(name)) {
		    if (!isobject(message)) {
		      sprintf(sendbuf, ">> %s: %s is not an object.  To create an object, use .$c <object> = <desc>\r\n", CORE,message);
		      sendtoplayer(pplayer,sendbuf);
		      return -1;
		    } else if (!isobjectowner(message, pplayer->name)) {
		      sprintf(sendbuf, ">> %s: You are not the owner of object %s.\r\n",CORE,message);
		      sendtoplayer(pplayer,sendbuf);
		      return -1;
		    } else
		      if(makelink(pplayer, name, message) == -1) return -1;
		  } else {
		    sprintf(sendbuf, ">> %s: %s is already an action.\r\n",CORE,name);
		    sendtoplayer(pplayer,sendbuf);
		    return -1;
       
		  }
                  sprintf(sendbuf, "[SYSLOG:  Action %s created on %s by %s]\r\n", name, message, pplayer->name);
                  sendall(sendbuf, "*", SYSLOG, 0);

		  if(1 == -1) {
		    sprintf(sendbuf, ">> %s:  Action creation failed.  It exists but temporarily.\r\n",CORE);
		    sendtoplayer(pplayer,sendbuf);
		    return -1;
		  } else {
		    sprintf(sendbuf, ">> %s:  Action %s created and linked to object %s.\r\n", CORE,name, message);
		    sendtoplayer(pplayer,sendbuf);
		    return 0;
		  }
	      } else {
		sprintf(sendbuf, ">> %s:  You can not put spaces in the names of actions.\r\n",CORE);
		sendtoplayer(pplayer, sendbuf);
		return 0;
	      }
	    }
	} else {
	    sprintf(sendbuf, ">> SYNTAX:  .$l actionname = object\r\n");
	    sendtoplayer(pplayer, sendbuf);
	}
    return 0;
  }

int parseaction(pplayer,mesg)
     char *mesg;
     struct splayer *pplayer;
{
    char *buf=mesg;
    char *btmp;
    char *ctmp;
    int count;
    char *name;
    char *message;

       	if ((buf = index(mesg, '\r')) != (char *)0) {
	    *buf = '\000';
	}
	if ((buf = index(mesg, '\n')) != (char *)0) {
	    *buf = '\000';
	}
	
	buf= mesg;
	while (isspace(*buf) && (*buf != '\000'))
	    buf++;
	
	count = strlen(buf)-1;
	while (isspace(buf[count])) {
	  buf[count] = '\000';
	  count--;
          }   
	if (*buf != '\000') {
	    ctmp = buf;
	    if ((ctmp = index(buf, '=')) == (char *)0) {
	      sendtoplayer(pplayer, ">> SYNTAX:  .$a actionname = verb\r\n");
	      return 0;
	    } else {
	      count = 1;
              while((buf[count] != '=') && (count < strlen(buf)))
		count++;
              buf[count] = '\000';
              name = buf;
	      buf = buf + count + 1;
              message = buf;
	      count = strlen(name)-1;
	      while(isspace(name[count])){
		name[count] = '\000';
		count--;
	      }
	      if(strlen(name) >= 23)
	         name[23] = '\0';
	      while(isspace(*message) && (*message != '\000'))
		message++;
	      if ((*message == '\0') || (*name == '\0')) {
		sprintf(sendbuf, ">> %s:  Null actionname or verb.\r\n",CORE);
		sendtoplayer(pplayer,sendbuf);
		return -1;
	      }
	      if ((ctmp = index(name, ' ')) == (char *)0) {
		  if (!isaction(name)) {
		    sprintf(sendbuf, ">> %s:  Action %s does not exist.  Use .$l <action> = <object> to create one.\r\n",CORE,name);
		    sendtoplayer(pplayer,sendbuf);
                    return -1;
		  } else {
		    if(!isactionowner(name, pplayer->name)) {
		      sprintf(sendbuf, ">> %s:  You do not own that action and can not change it.\r\n",CORE);
		      sendtoplayer(pplayer,sendbuf);
		      return -1;
		    } else
		      if(changeaction(pplayer, name, message) == -1) return -1;
       
		  }
		  if(1 == -1) {
		    sprintf(sendbuf, ">> %s:  Action/verb creation failed.  It exists but temporarily.\r\n",CORE);
		    sendtoplayer(pplayer,sendbuf);
		    return -1;
		  } else {
		    sprintf(sendbuf, ">> %s:  Verb defined on action %s.\r\n",CORE, name);
		    sendtoplayer(pplayer,sendbuf);
		    return 0;
		  }
	      } else {
		sprintf(sendbuf, ">> %s:  You can not put spaces in the names of actions.\r\n",CORE);
		sendtoplayer(pplayer, sendbuf);
		return 0;
	      }
	    }
	} else {
	    sprintf(sendbuf, ">> SYNTAX:  .$a actionname = verb\r\n");
	    sendtoplayer(pplayer, sendbuf);
	}
    return 0;
  }




int parsechanmesg(pplayer,mesg)
     char *mesg;
     struct splayer *pplayer;
{
    char *buf=mesg;
    char *btmp;
    char *ctmp;
    int count;
    char *user;
    char *message;

       	if ((buf = index(mesg, '\r')) != (char *)0) {
	    *buf = '\000';
	}
	if ((buf = index(mesg, '\n')) != (char *)0) {
	    *buf = '\000';
	}
	
	buf= mesg;
	while (isspace(*buf) && (*buf != '\000'))
	    buf++;
	
	count = strlen(buf)-1;
	while (isspace(buf[count])) {
	  buf[count] = '\000';
	  count--;
          }   
	if (*buf != '\000') {
	    ctmp = buf;
	    if ((ctmp = index(buf, '=')) == (char *)0) {
	      sendtoplayer(pplayer, ">> SYNTAX:  .C channel = message\r\n");
	      return 0;
	    } else {
	      count = 1;
              while((buf[count] != '=') && (count < strlen(buf)))
		count++;
              buf[count] = '\000';
              user = buf;
	      buf = buf + count + 1;
              message = buf;
	      count = strlen(user)-1;
	      while(isspace(user[count])){
		user[count] = '\000';
		count--;
	      }
	      while(isspace(*message) && (*message != '\000'))
		message++;
	    }
	    if (*message == ':' || *message == ';') {
	      message++;
	      if((*message == '\'') && (*(message+1) == 's') && (*(message+2) == ' '))
		sprintf(sendbuf, "(+%d,C) %s%s\r\n",pplayer->s,pplayer->name,message);
	      else if((*message == '\'') && (*(message+1) == 'd') && (*(message+2) == ' '))
		sprintf(sendbuf, "(+%d,C) %s%s\r\n",pplayer->s,pplayer->name,message);
	      else if((*message == '\'') && (*(message+1) == 'l') && (*(message+2) == 'l') && (*(message+3) == ' '))
		sprintf(sendbuf, "(+%d,C) %s%s\r\n",pplayer->s,pplayer->name,message);
	      else
		sprintf(sendbuf, "(+%d,C) %s %s\r\n",pplayer->s,pplayer->name,message);
	    } else {
	      sprintf(sendbuf, "(+%d,C %s) %s\r\n",pplayer->s,pplayer->name,message);
	    }
	    if(isplayer(pplayer, PSUP)) {
	      sendtoplayer(pplayer, ">> You can not use this feature while suppressing private messages.\r\n");
	    } else {
              if(isplayer(pplayer, ECHO)) {
                if(*user != '*')
                  sendallg(sendbuf, pplayer, user, 0, PSUP);
                sprintf(sendbuf, ">> Message sent to channel %s (%d users): %s.\r\n",user,onchannel(user),buf);
              } else {
	      if(*user != '*')
		sendallg(sendbuf, pplayer, user, 0, PSUP);
	      sprintf(sendbuf, ">> Message sent to channel %s (%d users).\r\n",user,onchannel(user));
              }
	      sendtoplayer(pplayer,sendbuf);
	    }
	  } else {
	    sprintf(sendbuf, ">> SYNTAX:  .C channel = message\r\n");
	    sendtoplayer(pplayer, sendbuf);
	}
    return 0;
  }


int parsechanimesg(pplayer,mesg)
     char *mesg;
     struct splayer *pplayer;
{
    char *buf=mesg;
    char *btmp;
    char *ctmp;
    int count;
    char *user;
    char *message;

        if ((buf = index(mesg, '\r')) != (char *)0) {
            *buf = '\000';
        }
        if ((buf = index(mesg, '\n')) != (char *)0) {
            *buf = '\000';
        }
 
        buf= mesg;
        while (isspace(*buf) && (*buf != '\000'))
            buf++;
 
        count = strlen(buf)-1;
        while (isspace(buf[count])) {
          buf[count] = '\000';
          count--;
          }
        if (*buf != '\000') {
            ctmp = buf;
            if ((ctmp = index(buf, '=')) == (char *)0) {
              sendtoplayer(pplayer, ">> SYNTAX:  ..C channel = invisible message\r\n");
              return 0;
            } else {
              count = 1;
              while((buf[count] != '=') && (count < strlen(buf)))
                count++;
              buf[count] = '\000';
              user = buf;
              buf = buf + count + 1;
              message = buf;
              count = strlen(user)-1;
              while(isspace(user[count])){
                user[count] = '\000';
                count--;
              }
              while(isspace(*message) && (*message != '\000'))
                message++;
            }
  if(isplayer(pplayer, NOMESG)) return 0;
            if (*message == ':' || *message == ';') {
              message++;
              if((*message == '\'') && (*(message+1) == 's') && (*(message+2) == ' '))
                sprintf(sendbuf, "+>> %s\r\n",message);
              else if((*message == '\'') && (*(message+1) == 'd') && (*(message+2) == ' ')
)
                sprintf(sendbuf, "+>> %s\r\n",message);
              else if((*message == '\'') && (*(message+1) == 'l') && (*(message+2) == 'l') && (*(message+3) == ' '))
                sprintf(sendbuf, "+>> %s\r\n",message);
              else
                sprintf(sendbuf, "+>> %s\r\n",message);
           } else {              
              sprintf(sendbuf, "+>> %s\r\n",message);
            }
            if(isplayer(pplayer, PSUP)) {
              sendtoplayer(pplayer, ">> You can not use this feature while suppressing private messages.\r\n");
            } else {
              if(isplayer(pplayer, ECHO)) {
                if(*user != '*')
                  sendallg(sendbuf, pplayer, user, 0, PSUP);
                sprintf(sendbuf, ">> Invisible Message sent to channel %s (%d users): %s.\r\n",user,onchannel(user),buf);
              } else {
              if(*user != '*')
                sendallg(sendbuf, pplayer, user, 0, PSUP);
              sprintf(sendbuf, ">> Invisible message sent to channel %s (%d users).\r\n",user,onchannel(user));
              }
              sendtoplayer(pplayer,sendbuf);
            }
          } else {
            sprintf(sendbuf, ">> SYNTAX:  ..C channel = invisible message\r\n");
            sendtoplayer(pplayer, sendbuf);
        }
    return 0;
  }
 
 


int setname(linenum, name)
     int linenum;
     char *name;
{
  char *buf=name;
  char *btmp;
  char *ctmp;
  int count;
  char *realonfrom;
  char tmpchan[20];
  char *seppasswd;
  char *sepname;
  struct splayer *tmp;
  
  tmp = lookup(linenum);
  if (tmp == (struct splayer *)0) {
    return -1;
  } else {
    if ((buf = index(name, '\r')) != (char *)0) {
      *buf = '\000';
    }
    if ((buf = index(name, '\n')) != (char *)0) {
      *buf = '\000';
    }
    
    buf= name;
    while (isspace(*buf) && (*buf != '\000'))
      buf++;
    
    color = 34; bg = 40; high = 1;
    
    count = strlen(buf)-1;
    while (isspace(buf[count])) {
      buf[count] = '\000';
      count--;
    }   
    if (*buf != '\000') {
      if(registered(buf)) {
	sprintf(sendbuf, ">> %s:  %s is a reserved name.  Use /n name = password.\r\n",CORE,buf);
	sendtoplayer(tmp, sendbuf);
      } else if (isloggedin(buf)) {
	sprintf(sendbuf, ">> %s:  The name %s is currently in use.  Please choose another name.\r\n", CORE, buf);
	sendtoplayer(tmp, sendbuf);
  /*   } else if (buf[20]) {
        sprintf(sendbuf,">> The name you have chosen is too long.\r\n");
        sendtoplayer(tmp, sendbuf);
      } 
*/
      } else {
	ctmp = buf;
	if ((ctmp = index(buf, '\"')) != (char *)0) {
	  sendtoplayer(tmp, ">> The \" key is not allowed in a login name\r\n");
	  return -1;
	}
	if ((ctmp = index(buf, '`')) != (char *)0) {
	  sendtoplayer(tmp, ">> The ` key is not allowed in a login name\r\n");
	  return -1;
	}
	if ((ctmp = index(buf, '|')) != (char *)0) {
	  sendtoplayer(tmp, ">> The | key is not allowed in a login name\r\n");
	  return -1;
	}
	if ((ctmp = index(buf, '=')) == (char *)0) {
	  strncpy(tempbuf, buf, 21);
	  tempbuf[19] = '\000';
	  if(registered(tempbuf)) {
	    sprintf(sendbuf, ">> %s: %s is a reserved name.  Use /n name = password.\r\n",CORE,tempbuf);
	    sendtoplayer(tmp,sendbuf);
	    return -1;
	  } else {
	    strncpy(tmp->name, tempbuf, 20);
	  }
	  sprintf(sendbuf, ">> Name set to %s.\r\n", tmp->name);
	  sendtoplayer(tmp, sendbuf);
	  if (isplayer(tmp,NEWBIE)) {
	    if(banned(tmp->onfrom)) {
	      sprintf(sendbuf, ">> Your site \"%s\" has been restricted to unregistered users.\r\n>> Character \"%s\" is not registered.\r\n>> Email an Op for a character.\r\n>> %s\r\n>> %s\r\n", tmp->onfrom, tmp->name, EMAIL, EMAIL2);
	      sendtoplayer(tmp,sendbuf);
	      removeplayer(tmp);
	      return 0;
	    }
          if((lewd(buf)) && (!banned(tmp->onfrom))) {
            sprintf(sendbuf, ">> %s: Bummer dude, you just banned your own site!.\r\n",CORE);
            sendtoplayer(tmp,sendbuf);
            addbanned(tmp->realonfrom);
            sprintf(sendbuf, "[SYSLOG:  %s just tried to enter from site %s; banned]\r\n", buf, tmp->realonfrom);
            sendall(sendbuf, "*", SYSLOG2, 0);
            removeplayer(tmp);
            return 0;
          }
          if((lewd(buf)) && (banned(tmp->onfrom))) {
            sprintf(sendbuf, ">> %s: Bummer dude, you just locked out your own site!.\r\n",CORE);
	    sendtoplayer(tmp,sendbuf);
            addlockout(tmp->realonfrom);
            sprintf(sendbuf, "[SYSLOG:  %s just tried to enter from site %s; locked out]\r\n", buf, tmp->realonfrom);
            sendall(sendbuf, "*", SYSLOG2, 0);
            removeplayer(tmp);
            return 0;
          }
            
	    tmp->moretype = login1;
	    showwarning1(tmp);
	  }
	  checkregistry(tmp);
	  return 0;
	} else {
	  count = strlen(buf)-1;
	  while((buf[count] != '=') && (count > -1))
	    count--;
	  buf[count] = '\000';
	  sepname = buf;
	  if (strlen(sepname) >= 19) sepname[19] = '\000';
	  buf = buf + count + 1;
	  seppasswd = buf;
	  count = strlen(sepname)-1;
	  while(isspace(sepname[count])){
	    sepname[count] = '\000';
	    count--;
	  }
	  while(isspace(*seppasswd) && (*seppasswd != '\000'))
	    seppasswd++;
	  if (registered(sepname)) {
	    strcpy(tmpchan,tmp->channel);
	    if (checkpasswd(sepname,seppasswd,tmp)) {
	      strncpy(tmp->name, sepname, 20);
	      tmp->name[19] = '\000';
	      sprintf(sendbuf, ">> Name set.  Welcome to %s, %s!\r\n",NAME,
		      tmp->name);
	      sendtoplayer(tmp, sendbuf);
	      checkregistry(tmp);
	      if (isplayer(tmp,NEWBIE)) {
		usurpplayer(tmp->name, tmp->ln);
		sprintf(sendbuf, ">> Channel now: %s\r\n", tmp->channel);
		sendtoplayer(tmp, sendbuf);
		togplayer(tmp,NEWBIE);
		welcomeplayer2(tmp);
		if (tmp->arrmesg[0] != '\0') {
		  sprintf(sendbuf, "*> (%d) %s\r\n",tmp->s,tmp->arrmesg);
		  sendall(sendbuf, "*",0,NOMESG|MESS|NEWBIE);
		}
		sprintf(sendbuf, ">> %s %s from %s has connected on line %d (%s)\r\n",ARRIVAL,tmp->name,tmp->onfrom,tmp->s,tmp->channel);
		sendall(sendbuf, "*", 0, MESS|NEWBIE);
		sprintf(sendbuf, ">> (%d) %s has connected here.\r\n",tmp->s,tmp->name);
		sendall(sendbuf, tmp->channel, 0,0);
		notifyfriend(tmp->name, tmp->s);
		dochanop(tmp);
		doroom(tmp);
		/* wizardson(tmp); */
	      } else
		strcpy(tmp->channel, tmpchan); 
	      
	      changetime(tmp);
	      checkregistry(tmp);
	      if(checkmail(tmp->name)) {
		sprintf(sendbuf, ">> %s:  You have Zmail (%d).  Type .z to read.  .E to erase.\r\n",CORE,nummail(tmp->name)); 
		sendtoplayer(tmp,sendbuf);
	      }
	      return 0;
	    } else {
	      sprintf(sendbuf,">> %s:  Failed password for %s.\r\n",CORE,
		      sepname);
	      sendtoplayer(tmp,sendbuf);
	      return 0;
	    }
	  } else {
	    sprintf(sendbuf, ">> %s:  %s is not registered in the %s database.\r\n",CORE,sepname,CORE);
	    sendtoplayer(tmp, sendbuf);
	    return 0;
	  }
	}
      }
    } else {
      sprintf(sendbuf, ">> You are currently %s on line %d.\r\n",tmp->name, tmp->s);
      sendtoplayer(tmp, sendbuf);
      sprintf(sendbuf, ">> The fnords are saying \"%s\" to you.\r\n", tmp->onfrom);
      sendtoplayer(tmp, sendbuf);
    if (tmp->idlemesg[0] != '\000') {
      sprintf(sendbuf, ">> Your idle message says \"%s\".\r\n", tmp->idlemesg);
      sendtoplayer(tmp, sendbuf);
    } else {
      sprintf(sendbuf, ">> You have no idle message set.\r\n");
      sendtoplayer(tmp, sendbuf);
    }

    }
  }
  return 0;
}

int nummesg(pplayer)
     struct splayer *pplayer;
{
  int count;
  count = 1;
  while (bboard[count][0] != '\0') count++;
  sprintf(sendbuf, ">> %s:  There are %d messages on the bulletin board.\r\n",CORE, count-1);
  sendtoplayer(pplayer,sendbuf);
  return 0;
}

int setchannel(linenum, channel)
    int linenum;
    char channel[];
{
    struct splayer *tmp;
    
    /* find out who to set */
    color = 32; bg = 40; high = 1;
    tmp = lookup(linenum);
    if (tmp == (struct splayer *)0) {
	return -1;
    } else {
	if(onchannel(tmp->channel) <= 1) {
	    unsecure(tmp->channel);
	}
	if( *channel != '*' ) {
	    strncpy(tmp->channel, channel, 9);
	    tmp->channel[9]='\0';
	    dochanop(tmp);
            tmp->object[0] = '\0';
	    return 0;
	} else
	    return -1;
    }
}

int issecure(channel)
    char *channel;
{
    struct channel *temp;
    for(temp=secured; temp != NULL ;temp=temp->next) {
	if (!strcmp(channel, temp->name)) {
	    if(onchannel(temp->name)) {
		return 1;
	    } else {
		unsecure(channel);
		return 0;
	    }
	}
    }
    return 0;
}

int setobjentermesg(object, mesg)
     char *object;
     char *mesg;
{
  struct sobject *temp;
  
  for(temp=pobject; temp; temp=temp->next) {
    if(!strcasecmp(object, temp->name)) {
      free(temp->inmesg);
      temp->inmesg = allocmem(strlen(mesg));
      strcpy(temp->inmesg, mesg);
      return 0;
    }
  }
  return 0;
}

int setobjexitmesg(object, mesg)
     char *object;
     char *mesg;
{
  struct sobject *temp;
  
  for(temp=pobject; temp; temp=temp->next) {
    if(!strcasecmp(object, temp->name)) {
      free(temp->outmesg);
      temp->outmesg = allocmem(strlen(mesg));
      strcpy(temp->outmesg, mesg);
      return 0;
    }
  }
  return 0;
}

int informexitobj(pplayer)
   struct splayer *pplayer;
{
  struct sobject *temp;
  
  for(temp=pobject; temp; temp=temp->next) {
    if(!strcasecmp(pplayer->object, temp->name)) {
      if(temp->outmesg[0] != '\0')
        sprintf(sendbuf, ">> (%d) %s %s %s\r\n", pplayer->s, pplayer->name,
                temp->outmesg, temp->name);
      else
        sprintf(sendbuf, ">> (%d) %s %s %s\r\n", pplayer->s, pplayer->name,
                "walked out of the", temp->name);

       sendall(sendbuf, pplayer->channel, 0, NOMESG);
    }
  }
  return 0;
}

int informenterobj(pplayer,obj)
   struct splayer *pplayer;
   char *obj;
{
  struct sobject *temp;
  
  for(temp=pobject; temp; temp=temp->next) {
    if(!strcasecmp(obj, temp->name)) {
      if(temp->inmesg[0] != '\0')
        sprintf(sendbuf, ">> (%d) %s %s %s\r\n", pplayer->s, pplayer->name,
                temp->inmesg, temp->name);
      else
        sprintf(sendbuf, ">> (%d) %s %s %s\r\n", pplayer->s, pplayer->name,
                "walked into the", temp->name);
      sendall(sendbuf, pplayer->channel, 0, NOMESG);
    }
  }
  return 0;
}



int channelobjects(pplayer, channel)
     struct splayer *pplayer;
     char *channel;
{
  struct sobject *temp;
  int num = 0;
  int nomore = 0;

  sprintf(sendbuf, ">> You see:");
  for(temp=pobject; temp; temp=temp->next) {
    if(!strcmp(channel, temp->cont) && ((temp->c_type == 'r') || (temp->c_type == 'l'))) {
     if(strlen(sendbuf) < BUFSIZE-50 ) {
      strcat(sendbuf, "  ");
      strcat(sendbuf, temp->name);
      num ++;
     } else if (nomore==0){
      strcat(sendbuf, " and a bunch of other stuff.");
      nomore=1;
     }
    }
  }
  strcat(sendbuf, "  \r\n");
  if (num)
    sendtoplayer(pplayer,sendbuf);
  return 0;
}


int objectsinobj(pplayer, object)
     struct splayer *pplayer;
     char *object;
{
  struct sobject *temp;
  int num = 0;
  int nomore = 0;

  sprintf(sendbuf, ">> You see:");
  for(temp=pobject; temp; temp=temp->next) {
    if(!strcasecmp(object, temp->cont) && ((temp->c_type == 'o'))) {
     if(strlen(sendbuf) < BUFSIZE-50 ) {
      strcat(sendbuf, "  ");
      strcat(sendbuf, temp->name);
      num ++;
     } else if (nomore==0) {
      strcat(sendbuf, " and a bunch of other stuff.");
      nomore=1;
     }
    }
  }
  strcat(sendbuf, "  \r\n");
  if (num)
    sendtoplayer(pplayer,sendbuf);
  return 0;
}


int usersinchannel(pplayer, channel)
     struct splayer *pplayer;
     char *channel;
{
  struct splayer *temp;

  sprintf(sendbuf, ">> Players there: ");
  for(temp=players; temp; temp=temp->next) {
    if(!strcmp(channel, temp->channel)) {
      strcat(sendbuf, temp->name);
      if (temp->object[0] != '\0') {
        strcat(sendbuf, " (");
	strcat(sendbuf, temp->object);
        strcat(sendbuf, ")");
      }
      strcat(sendbuf, "   ");
    }
  }
  strcat(sendbuf,"\r\n");
  sendtoplayer(pplayer,sendbuf);
  return 0;
}

int wizardson(pplayer)
     struct splayer *pplayer;
{
  struct splayer *temp;
  int num = 0;

  sprintf(sendbuf, ">> Ops connected are");
  for(temp=players;temp;temp=temp->next) {
    if(temp->seclevel > COSYSOP) {
      strcat(sendbuf, " - ");
      strcat(sendbuf, temp->name);
      num++;
    }
  }
  if(num) {
    strcat(sendbuf, ".\r\n");
    sendtoplayer(pplayer,sendbuf);
  } else 
    sendtoplayer(pplayer, ">> There are no HavenOps connected, please ask a user for assistance.\r\n");

/*  num=0;
 *  sprintf(sendbuf, ">> SysOps on:");
 * for(temp=players;temp;temp=temp->next) {
 *   if(temp->seclevel == 2) {
 *     strcat(sendbuf, "  ");
 *     strcat(sendbuf, temp->name);
 *     num++;
 *   }
 * }
 * if(num) {
 *   strcat(sendbuf, "\r\n");
 *   sendtoplayer(pplayer,sendbuf);
 * }
 * num=0;
 * sprintf(sendbuf, ">> SysAides on:");
 * for(temp=players;temp;temp=temp->next) {
 *   if(temp->seclevel == 2) {
 *     strcat(sendbuf, "  ");
 *     strcat(sendbuf, temp->name);
 *     num++;
 *   }
 * }
 * if(num) {
 *   strcat(sendbuf, "\r\n");
 *   sendtoplayer(pplayer,sendbuf);
 * }
 */ 
return 0;
}
  

int sendwizardsmesg(pplayer, text)
     struct splayer *pplayer;
     char *text;
{
  struct splayer *temp;
  int num=0;
        if( *text == ':' || *text == ';') {                 
            text++;
            if ((*text == '\'') && (*(text+1) == 's') && (*(text+2) == ' '))
              sprintf(sendbuf,"[1m(@%d@) %s%s[0m\r\n",pplayer->s, pplayer->name, text);
            else if((*text == '\'') && (*(text+1) =='d') && (*(text+2)==' '))
              sprintf(sendbuf,"[1m(@%d@) %s%s[0m\r\n",pplayer->s, pplayer->name, text);
            else if((*text == '\'') && (*(text+2) =='l') && (*(text+1)=='l') && (*(text+3) == ' '))
              sprintf(sendbuf,"[1m(@%d@) %s%s[0m\r\n",pplayer->s, pplayer->name, text);
            else sprintf(sendbuf, "[1m(@%d@) %s %s[0m\r\n",pplayer->s,pplayer->name,text);
        } else
  sprintf(sendbuf, "[1m(@%d, %s@) %s[0m\r\n",pplayer->s, pplayer->name, text);
  for(temp=players;temp;temp=temp->next) {
    if(temp->seclevel >= COSYSOP) {
      sendtoplayer(temp, sendbuf);
      num++;
    }
  }
  if(pplayer->seclevel != SUPREME){

  if(num) sprintf(sendbuf, ">> Message sent to HavenOps (%d users): %s\r\n", num, text);
  else  sprintf(sendbuf, ">> There are no HavenOps connected, please ask a user for assistance.\r\n");
          sendtoplayer(pplayer,sendbuf);
  }
}


int channelusers(pplayer)
     struct splayer *pplayer;
{
  struct splayer *temp;

  if(onchannel(pplayer->channel) == 1) return 0;
  sprintf(sendbuf, ">> ");
  for(temp=players; temp; temp=temp->next) {
    if(!strcmp(pplayer->channel, temp->channel) && (pplayer->s != temp->s)) {
      strcat(sendbuf, temp->name);
      if (temp->object[0] != '\0') {
        strcat(sendbuf, " (");
	strcat(sendbuf, temp->object);
        strcat(sendbuf, ")");
      }
      if (onchannel(pplayer->channel) > 2)
	strcat(sendbuf, ", ");
      else
	strcat(sendbuf, " ");
    }
  }
  strcat(sendbuf, "and you are here.\r\n");
  sendtoplayer(pplayer,sendbuf);
  return 0;
}


int usersinremoteobj(pplayer, object)
     struct splayer *pplayer;
     char *object;
{
  struct splayer *temp;
  int counter = 0;

  sprintf(sendbuf, ">> Players: ");
  for(temp=players; temp; temp=temp->next) {
    if(!strcasecmp(object, temp->object)) {
      strcat(sendbuf, temp->name);
      strcat(sendbuf, "   ");
      counter++;
    }
  }
  strcat(sendbuf, "\r\n");
  if (counter)
    sendtoplayer(pplayer,sendbuf);
  return 0;
}


int usersinobj(pplayer)
     struct splayer *pplayer;
{
  struct splayer *temp;
  int counter = 0;

  if(onchannel(pplayer->channel) == 1) return 0;
  sprintf(sendbuf, ">> ");
  for(temp=players; temp; temp=temp->next) {
    if(!strcasecmp(pplayer->object, temp->object) && (pplayer->s != temp->s)) {
      strcat(sendbuf, temp->name);
      strcat(sendbuf, "   ");
      counter++;
    }
  }
  strcat(sendbuf, "and you are here.\r\n");
  if (counter)
    sendtoplayer(pplayer,sendbuf);
  return 0;
}



int onchannel(channel)
    char *channel;
{
    struct splayer *temp;
    int total = 0;
    
    temp = players;
    while (temp->next != NULL) {
	temp = temp->next;
	if (!strcmp(channel, temp->channel)) {
	    total++;
	}     
    }  
    return total;
}

int secure(channel)
    char *channel;
{
    struct channel *temp;

    if (!strcmp(channel, MAIN))
	return 0;
    if(secured == NULL)
	if((secured=(struct channel *)malloc(sizeof(struct channel)))==NULL) {
	    sprintf(sendbuf, "Error malloc'ing for char *\r\n");
	    return 0;
	} else {
	    strncpy(secured->name, channel, 10);
	    secured->next = NULL;
	    return 1;
	}
    for(temp=secured; temp->next != NULL;temp = temp->next);
    if((temp->next =
	       (struct channel *)malloc(sizeof(struct channel))) == NULL) {
	sprintf(sendbuf, "Error malloc'ing for char *\r\n");
	return 0;
    } else {
	temp = temp->next;
	strncpy(temp->name, channel, 10);
	temp->next = NULL;
	return 1;
    }
}

void unsecure(channel)
    char *channel;
{
    struct channel *temp;
    
    if (secured == NULL)
	return;
    if (!strcmp(secured->name, channel)) {
	secured = secured->next;
	return;
    }
    for(temp = secured;temp->next != NULL && strcmp(channel, temp->next->name);
	temp = temp->next); 
    if(temp->next == NULL )
	return;
    else {
	temp->next = temp->next->next;
	return;
    }
}

void listchan(pplayer)
    struct splayer *pplayer;
{
    struct splayer *tmp;
    register int chancnt=0;
    char chanlist[LINEMAX][10];
    int i, found, number[LINEMAX];
    
    for(i=0;i<62;i++) {
	bzero(chanlist[i], 9);
	number[i] = 0;
    }
    tmp = players;
    while (tmp->next != (struct splayer *)0) {
	tmp = tmp->next;
	found = 0;
	for(i=0; i <= chancnt ; i++)
	    if(!strcmp(chanlist[i], tmp->channel)) {
		found = 1;
	    }
	if(!found) {
	    strncpy(chanlist[chancnt], tmp->channel, 9);
	    chanlist[chancnt][strlen(tmp->channel)]='\0';
	    number[chancnt++]=1;
	} else {
	    number[chancnt]++;
	}
    }
    color = 35; bg = 40; high = 1;
    sprintf(sendbuf, " %-14s%-9s%-7s\r\n", "Channel", "Users", "Secure");
    sendtoplayer(pplayer, sendbuf);
    
    color = 30;
    for(i=0; i < chancnt;i++) {
        color++; if ( color == 37) color = 31;
	sprintf(sendbuf, " %-10s   %5d%9s\r\n", chanlist[i],
		onchannel(chanlist[i]),(issecure(chanlist[i]))? "Yes": "No");
	if(isroom(chanlist[i])) sendbuf[0] = '+';
	sendtoplayer(pplayer, sendbuf);
    }
    color =31;
    sprintf(sendbuf, ">> Current channel: %s\r\n",pplayer->channel);
    sendtoplayer(pplayer,sendbuf); 
}


int banned(host)
    char *host;
{
    struct banlist *temp;

    for(temp = blist; temp; temp = temp->next)
        if(strcasestr(host, temp->name))
            return 1;
    return 0;
}

int lewd(host)
    char *host;
{
    struct lewdlist *temp;

    for(temp = nlist; temp; temp = temp->next)
        if(strcasestr(host, temp->name))
            return 1;
    return 0;
}



int restricted(host)
    char *host;
{
    struct hostlist *temp;

    for(temp = rlist; temp; temp = temp->next)
	if(strcasestr(host, temp->name))
	    return 1;
    return 0;
}

void syncrestrict()
{
    int fp;
    FILE *file;
    char string[40];
    struct hostlist *new;

    zap();

    if((fp=open(".lockout", 0)) == -1)
	return;

    if((file=fdopen(fp, "r"))== NULL) {
	sprintf(sendbuf, "Error opening lockout file.");
	return;
    }

    while(fscanf(file, "%s", string) != EOF) {
	new = (struct hostlist *)malloc(sizeof(struct hostlist));
	new->next = rlist;
	strncpy(new->name, string, 40);
        new->name[39] ='\0';
	rlist = new;
    }
    close(fp);
    fclose(file);	

    return;
}

void syncban()
{
    int fp;
    FILE *file;
    char string[40];
    struct banlist *new;

    zapban();

    if((fp=open(".ban", 0)) == -1)
        return;

    if((file=fdopen(fp, "r"))== NULL) {
        sprintf(sendbuf, "Error opening lockout file.");
        return;
    }

    while(fscanf(file, "%s", string) != EOF) {
        new = (struct banlist *)malloc(sizeof(struct banlist));
        new->next = blist;
        strncpy(new->name, string, 40);
        new->name[39] = '\0';
        blist = new;
    }
    close(fp);
    fclose(file);

    return;
}

void synclewd()
{
    int fp;
    FILE *file;
    char string[40];
    struct lewdlist *new;

    zaplewd();

    if((fp=open(".lewd", 0)) == -1)
        return;

    if((file=fdopen(fp, "r"))== NULL) {
        sprintf(sendbuf, "Error opening .lewd file.");
        return;
    }

    while(fscanf(file, "%s", string) != EOF) {
        new = (struct lewdlist *)malloc(sizeof(struct lewdlist));
        new->next = nlist;
        strncpy(new->name, string, 40);
        new->name[39] = '\0';
        nlist = new;
    }
    close(fp);
    fclose(file);

    return;
}



void zap()
{
    struct hostlist *temp, *next;
    
    temp =rlist;
    while (temp != NULL) {
	next = temp->next;
	free((char *)temp);
	temp = next;
    }
    rlist = (struct hostlist *)0;
    return;
}


void zapban()
{
    struct banlist *temp, *next;

    temp =blist;
    while (temp != NULL) {
        next = temp->next;
        free((char *)temp);
        temp = next;
    }
    blist = NULL;
    return;
}

void zaplewd()
{
    struct lewdlist *temp, *next;

    temp =nlist;
    while (temp != NULL) {
        next = temp->next;
        free((char *)temp);
        temp = next;
    }
    nlist = NULL;
    return;
}



void checkidle()
{
    struct splayer *buf;
    struct timeval tmptime;

    gettimeofday(&tmptime, (struct timezone *)0);
    buf = players;
    while (buf->next != NULL) {
      buf = buf->next;
#define MAXMAINIDLE 600
      if((tmptime.tv_sec - buf->idle) > MAXMAINIDLE && (!strcmp(buf->channel, MAIN))) {
	sprintf(sendbuf, ">> Suddenly %s begins to float up into the \"Clouds\".\r\n", buf->name);
	sendall(sendbuf, MAIN, 0, 0);
	sendtoplayer(buf, ">> You've been sent to the \"Clouds\".\r\n");
	strcpy(buf->channel, "Clouds");
      } 
      if(((((tmptime.tv_sec - buf->idle) > maxidle) && (buf->seclevel < SUPREME)) || (((tmptime.tv_sec - buf->idle) > 150) && !strcmp(buf->name, NEWCONN)))) {
	color = 30; bg = 47; high = 1;
	sprintf(sendbuf, ">> logged out for inactivity.\r\n");
	sendtoplayer(buf, sendbuf);
	removeplayer(buf);
	color = 31; bg = 40;
        return;
      }
      if((buf->seclevel > 1) && ((time(NULL)-(buf->idle)) >= 14400)) { 
        buf->seclevel = 1;
        togplayer(buf,SYSLOG);
        togplayer(buf,SYSLOG2);
        sendtoplayer(buf, ">> You've idled with power too long, Power level now 1, SYSLOGS now off.\r\n");
        sprintf(sendbuf, "[SYSLOG:  %s has been autopowered down due to poweridlemax.]\r\n",buf->name);
        sendall(sendbuf, "*", SYSLOG2, 0);
      }
    }
  }

void punt()
{
    struct splayer *buf, *victim;

    buf = players;
    buf = buf->next;
    if(buf != NULL) {
	victim = buf;
	while(buf->next != NULL) {
	    buf = buf->next;
	    if(buf->idle < victim->idle)
		victim = buf;
	}
    }
    removeplayer(victim);
    sprintf(sendbuf, "%s logged out (most idle for SIGUSR)\r\n", victim->name);
    return;
}

int
showhelp(pplayer, what)
struct splayer *pplayer;
char *what;
{
    FILE *fphelp;
    int commlevel=0;
    char *command, *wbuf; 
    register char *buf;

    color = 31; bg = 40; high = 1; 
    if ((fphelp=fopen(HELPFILE, "r")) == (FILE *)0) {
	fprintf(stderr, "hotel: unable to open helpfile %s.\n", HELPFILE);
	sendtoplayer(pplayer, ">> unable to open help file.\r\n");
	return;
    }
    wbuf = what;

    if (*what == '\000') {
	rewind(fphelp);
	while (fgets(sendbuf, BUFSIZE, fphelp) != NULL) {
	    buf = index(sendbuf, '_');
	    if (buf != (char *)0) {
		command = sendbuf;
		*buf = '\000';
		buf++;
		commlevel = atoi(buf);
	    } else  {
		fprintf(stderr, "bad dataline in help file ->%s<-.\n", sendbuf);
		continue;
	    }
	    buf = index(buf, '|');
	    if (buf != (char *)0) {
		if ((commlevel <= pplayer->seclevel) && (!strcmp(command, what))) {
		    sendtoplayer(pplayer, buf+1);
		    sendtoplayer(pplayer, "\r"); }
	    } else  {
		fprintf(stderr, "bad dataline in help file ->%s<-.\n", buf);
		continue;
	    }
	}
    }
    while (*wbuf != '\000') {
	while ((*wbuf != '\000') && (isspace(*wbuf))) { /* find next command */
	    wbuf++;
	}
	what = wbuf;
	while ((*wbuf != '\000') && (!isspace(*wbuf))) { /* find command end */
	    wbuf++;
	}
	if (*wbuf != '\000') { /* end of line */
	    *wbuf='\000';
	    wbuf++;
	} else if (what == wbuf) { /* no more commands to lookup */
	    continue;
	}
	rewind(fphelp);
	while (fgets(sendbuf, BUFSIZE, fphelp) != NULL) {
	    buf = index(sendbuf, '_');
	    if (buf != (char *)0) {
		command = sendbuf;
		*buf = '\000';
		buf++;
		commlevel = atoi(buf);
	    } else  {
		fprintf(stderr, "bad dataline in help file ->%s<-.\n", sendbuf);
		continue;
	    }
	    buf = index(buf, '|');
	    if (buf != (char *)0) {
		if ((commlevel <= pplayer->seclevel) && (!strcmp(command, what))) {
		    sendtoplayer(pplayer, buf+1);
		    sendtoplayer(pplayer, "\r"); }
	    } else  {
		fprintf(stderr, "bad dataline in help file ->%s<-.\n", buf);
		continue;
	    }
	}
    }
    (void) fclose(fphelp);
}
int query(pplayer, workbuf)
    struct splayer *pplayer;
    char *workbuf;
{
    char *buf;
    struct splayer *who;
    int linenum;
    linenum = pplayer->query;
    buf = workbuf;
    who = lookup(linenum);
    color = 36; bg = 40; high = 1;
    if (who == (struct splayer *)0) {
	 sprintf(sendbuf,">> line %d does not exist!\r\n",pplayer->query);
	 sendtoplayer(pplayer,sendbuf);
	 sprintf(sendbuf,">> Query mode disabled...\r\n");
	 sendtoplayer(pplayer,sendbuf);
	 pplayer->query = -1;
    } else if (isplayer(who,PSUP)) {
	 sprintf(sendbuf,">> %s is not accepting private messages.\r\n",who->name);
	 sendtoplayer(pplayer,sendbuf);
	 sprintf(sendbuf,">> Query mode disabled...\r\n");
	 sendtoplayer(pplayer,sendbuf);
	 pplayer->query = -1;
    } else {
	 while (isspace(*buf) && (*buf != '\000'))
	     buf++;
	 if (*buf == ':' || *buf == ';') {
	   buf ++;
	   if ((*buf == '\'') && (*(buf+1) == 's') && (*(buf+2) == ' '))
	     sprintf(sendbuf, "(%d,q->%d) %s%s\r\n",pplayer->s,pplayer->query,pplayer->name, buf);
	   else if ((*buf == '\'') && (*(buf+1) == 'd') && (*(buf+2) == ' '))
	     sprintf(sendbuf, "(%d,q->%d) %s%s\r\n",pplayer->s,pplayer->query,pplayer->name, buf);
	   else if ((*buf == '\'') && (*(buf+1) == 'l') && (*(buf+2) == 'l') && (*(buf+3) == ' '))
	     sprintf(sendbuf, "(%d,q->%d) %s%s\r\n",pplayer->s,pplayer->query,pplayer->name, buf);
	   else
	     sprintf(sendbuf, "(%d,q->%d) %s %s\r\n",pplayer->s,pplayer->query,pplayer->name, buf);
	 } else if (isplayer(who,TRAD))
	     sprintf(sendbuf, "(%d,q->%d %s) %s\r\n",pplayer->s,pplayer->query,pplayer->name,buf);
	 else
	     sprintf(sendbuf, "(%d,q->%d) %s says \"%s\"\r\n",pplayer->s,pplayer->query,pplayer->name,buf);
	 sendtoplayer(pplayer,sendbuf);
	 sendtoplayerg(who,pplayer,sendbuf);
    }
    color =31;
}

int
    sendallg(message, from, channel, allow, restrict)
char *message;
struct splayer *from;
char *channel;
int allow, restrict;
{
    char *messtmp;

    struct splayer *buf;
    buf = players;
    while (buf->next != (struct splayer *)0) {
	buf = buf->next;
	if(((allow == 0) && (restrict == 0)) || 
		((isplayer(buf, allow)) && (restrict == 0)) ||
		((notplayer(buf, restrict)) && (allow == 0)) ||
		((notplayer(buf, restrict)) && (isplayer (buf, allow))))
	    if ((*channel == ALL) || !strcmp(buf->channel, channel))
           if(notplayer(buf, NEWBIE))
		   sendtoplayerg(buf, from, message);
    }
}

    sendtoplayerg(who, from, message)
struct splayer *who;
struct splayer *from;
char *message;
{  
  char dummy[BUFSIZE];
  char sendbuf[BUFSIZE];
  int hilite = 0;
  long hold;
  int goforit = 0;
  char *ttime;
  char *buf;
  time_t now = time(0);
  char wrapbuf[3200];
  int count = 0;
  int count2 = 0;
  int count3 = 1;
  
  if ((buf = index(message, '\r')) != (char *)0) {
    *buf = '\000';
  }
  if ((buf = index(message, '\n')) != (char *)0) {
    *buf = '\000';
  }
  
  goforit = 0;
  ttime = ctime(&now) + 11;
  ttime[5] = '\0';
  if(from->gag[who->s] == 0)
    goforit = 1;
  
  if(who->hilite[from->s])
    hilite = 1;
  
  if (goforit == 1) {
    if ( ok == 1 ) {
      sprintf(sendbuf, "%s", (isplayer(who,TECHNO)) ? message : "\0"); }
    else {
      sprintf(dummy,"[%d;%dm",high,color);
      
      sprintf(sendbuf,"%s%s%s%s%s%s%s\r\n", (hilite) ? "[1m" : "", (isplayer2(who, TIME)) ? "<" : "", (isplayer2(who, TIME)) ? ttime : "", (isplayer2(who, TIME)) ? "> " : "", (isplayer(who,TECHNO)) ? dummy : "", message, ((isplayer(who,TECHNO)) | (hilite)) ? "[0m" : "");
    }
    while (sendbuf[count] != '\000') {
      wrapbuf[count2] = sendbuf[count];
      if(count3 == who->wrap) {
	count3 = 0;
	count2++;
	wrapbuf[count2] = '\r';
	count2++;
	wrapbuf[count2] = '\n';
      }
      count2++;
      if((sendbuf[count] != '\r') && (sendbuf[count] != '\n') && (sendbuf[count] != '\000'))
	count3++;
      count++;
    }
    wrapbuf[count2] = '\000';
    if (isplayer(who, NEWBIE)) return 0;
      if (outtosock(who->ln, wrapbuf) == -1) { /* no one there */
	removeplayer(who);
      }     
  }
}


int whosgagged(pplayer)
     struct splayer *pplayer;
{
  struct splayer *buf;
  register int numcons = 0;
  color = 31; bg = 40; high = 1;
  buf = players;
  sendtoplayer(pplayer, ">> You have the following players gagged:\r\n");
  while(buf->next != (struct splayer *)0) {
    buf = buf->next;
    if(buf->gag[pplayer->s] == 1) {
      color=buf->col;
      sprintf(sendbuf, "  (%d) %s\r\n",buf->s,buf->name);
      sendtoplayer(pplayer,sendbuf);
      numcons++;
    }
  }
  color = 31;
  sprintf(sendbuf, "     %d record%s displayed.\r\n", numcons, numcons == 1 ? "" : "s");
  sendtoplayer(pplayer, sendbuf); 
}
  
int isgagged(Zsender, Zreciever)
 struct splayer *Zsender;
 char *Zreciever;
{
 struct splayer *buf;
 buf = players;
 while(buf->next != (struct splayer*)0) {
 buf = buf->next;
 if (!strcmpi(buf->name, Zreciever))
 return Zsender->gag[buf->s]; 
 }
 return 0;
}

int iszsup(Zreciever)
 char *Zreciever;
{
 struct splayer *buf;
 buf = players;
 while(buf->next != (struct splayer*)0) {
 buf = buf->next;
 if (!strcmpi(buf->name, Zreciever))
 return isplayer2(buf, ZSUP);
 }
 return 0;
}

int listdesc(pplayer)
     struct splayer *pplayer;
{
  struct splayer *buf;
  register int numcons = 0;
  color = 31; bg = 40; high = 1;
  buf = players;
  sendtoplayer(pplayer, ">> Current descriptions:\r\n");
  while(buf->next != (struct splayer *)0) {
    buf = buf->next;
    if (strcmp(buf->desc,"\0")) {
      color = buf->col;
      sprintf(sendbuf, ">> (%d) %s - %s\r\n", buf->s, buf->name, buf->desc);
      sendtoplayer(pplayer, sendbuf);
      numcons++;
    }
  }
    color = 31;
    sprintf(sendbuf, "     %d record%s displayed.\r\n", numcons, numcons == 1 ? "" : "s");
    sendtoplayer(pplayer, sendbuf);
}

int cleargags(pplayer)
     struct splayer *pplayer;
{
  struct splayer *buf;
  long hold, hold1;
  buf = players;
  while(buf->next != (struct splayer *)0) {
    buf = buf->next;
    buf->gag[pplayer->s] = 0;
    buf->hilite[pplayer->s] = 0;
    if(buf->query == pplayer->s) pplayer->query = -1;
  }
}

int nummail(name)
     char *name;
{
  struct smail *temp;
  int count = 0;
  for (temp = zmail; temp; temp=temp->next)
    if(!(strcasecmp(temp->name, name))) count ++;

  return count;
}

int numaction(name)
     char *name;
{
  struct slink *temp;
  int count = 0;
  for (temp= plink; temp; temp=temp->next) 
    if(!(strcasecmp(temp->owner, name))) count ++;
  return count;
}

int numroom(name)
     char *name;
{
  struct sroom *temp;
  int count = 0;
  for (temp = proom; temp; temp=temp->next)
    if(!(strcasecmp(temp->owner, name))) count ++;

  return count;
}

int numnames()
{
  struct rnames *temp;
  int count = 0;
  for (temp= regname;temp;temp=temp->next)
    count ++;
  return count;
}

int numrooms()
{
  struct sroom *temp;
  int count = 0;
  for (temp= proom;temp;temp=temp->next)
    count ++;
  return count;
}

int numverbs()
{
  struct sverb *temp;
  int count = 0;
  for (temp= pverb;temp;temp=temp->next)
    count ++;
  return count;
}

int nummails()
{
  struct smail *temp;
  int count = 0;
  for (temp= zmail;temp;temp=temp->next)
    count ++;
  return count;
}

int numactions()
{
  struct slink *temp;
  int count = 0;
  for (temp= plink;temp;temp=temp->next)
    count ++;
  return count;
}




int xtoy(one, two)
     int one;
     int two;
{
  int total = 1;
  int x;
  
  x=1;
  while(x<=two) {
    total = total * one;
    x++;
  }


  return total;
}

void syncmail()
{
     int fp;
     FILE *file;
     char string[BUFSIZE];
     struct smail *new;

     zapmail();

     if((fp=open("hotel.mail",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
	return;
     }

     while(fgets(string, 40, file) != NULL) {
	new=(struct smail *)malloc(sizeof(struct smail));
	new->next = zmail;
	if (string[strlen(string)-1] = '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->name, string, 40);

	fgets(string, 40, file);
	if (string[strlen(string)-1] = '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->from, string, 40);

	fgets(string, 25, file);
	if (string[strlen(string)-1] = '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->when, string, 25);

	fgets(string, BUFSIZE, file);
	if (string[strlen(string)-1] = '\n')
	  string[strlen(string)-1] = '\000';
        new->mess = allocmem(strlen(string));   
	strcpy(new->mess, string);
       	zmail=new;
     }
     close(fp);
     fclose(file);
}

void syncfriend()
{
     int fp;
     FILE *file;
     char string[BUFSIZE];
     struct sfriend *new;

     zapfriend();

     if((fp=open("hotel.friend",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
	return;
     }

     while(fgets(string, 40, file) != NULL) {
	new=(struct sfriend *)malloc(sizeof(struct sfriend));
	new->next = pfriend;
	if (string[strlen(string)-1] = '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->name, string, 40);

	fgets(string, 40, file);
	if (string[strlen(string)-1] = '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->friend, string, 40);

       	pfriend=new;
     }
     close(fp);
     fclose(file);
}

void syncverb()
{
     int fp;
     FILE *file;
     char string[BUFSIZE];
     struct sverb *new;

     zapverb();

     if((fp=open("hotel.verbs",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
	return;
     }

     while(fgets(string, 40, file) != NULL) {
	new=(struct sverb *)malloc(sizeof(struct sverb));
	new->next = pverb;
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->verbname, string, 40);

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->owner, string, 40);

	fgets(string, BUFSIZE, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
        new->verb = allocmem(strlen(string));
	strcpy(new->verb, string);

	fgets(string, 10, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
        new->perm = string[0];
       	pverb=new;
     }
     close(fp);
     fclose(file);
}


void syncroom()
{
     int fp;
     FILE *file;
     char string[BUFSIZE];
     struct sroom *new;
     char *buf;

     zaproom();

     if((fp=open("hotel.rooms",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
	return;
     }

     while(fgets(string, 40, file) != NULL) {
	new=(struct sroom *)malloc(sizeof(struct sroom));
	new->next = proom;
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
        buf = string; 
        if(*buf == '*') { new->sanct = 1; buf++; } else new->sanct = 0;
	strncpy(new->name, buf, 40);
	new->name[39] ='\0';

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->owner, string, 40);

	fgets(string, BUFSIZE, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
        new->desc = allocmem(strlen(string));
	strcpy(new->desc, string);

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->north, string, 40);

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->south, string, 40);

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->east, string, 40);

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->west, string, 40);

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->up, string, 40);

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->down, string, 40);

	proom = new;
     }
     close(fp);
     fclose(file);
}

void zapobject()
{
     struct sobject *temp, *next;

     temp = pobject;
     while (temp != NULL) {
	next = temp->next;
        free(temp->desc);
        free(temp->inmesg);
        free(temp->outmesg);
	free((char *) temp);
	temp = next;
     }
     pobject = NULL;
     return;
}

void zapaction()
{
     struct slink *temp, *next;

     temp = plink;
     while (temp != NULL) {
	next = temp->next;
        free(temp->verb);
	free((char *) temp);
	temp = next;
     }
     plink = NULL;
     return;
}


void syncobject()
{
     int fp;
     FILE *file;
     char string[BUFSIZE];
     struct sobject *new;

     zapobject();

     if((fp=open("hotel.objects",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
	return;
     }

     while(fgets(string, 40, file) != NULL) {
	new=(struct sobject *)malloc(sizeof(struct sobject));
	new->next = pobject;
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->name, string, 40);
        new->name[39] = '\0';

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->owner, string, 40);

	fgets(string, BUFSIZE, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
        new->desc = allocmem(strlen(string));
	strcpy(new->desc, string);

	fgets(string, 10, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	new->c_type = string[0];

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->cont, string, 40);

        fgets(string, 11, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
        new->cont_perm = string[0];

        fgets(string, BUFSIZE, file);
        if (string[strlen(string)-1] == '\n')
          string[strlen(string)-1] = '\000';
        if(!strcmp(string, "walked into the")) {
          new->inmesg = allocmem(1);
          new->inmesg[0] = '\0';
        } else {
          new->inmesg = allocmem(strlen(string));
          strcpy(new->inmesg, string);
        }

        fgets(string, BUFSIZE, file);
        if (string[strlen(string)-1] == '\n')
          string[strlen(string)-1] = '\000';
        if(!strcmp(string, "walked out of the")) {
          new->outmesg = allocmem(1);
          new->outmesg[0] = '\0';
        } else {
          new->outmesg = allocmem(strlen(string));
          strcpy(new->outmesg, string);
        }


	pobject = new;
     }
     close(fp);
     fclose(file);
}

void syncaction()
{
     int fp;
     FILE *file;
     char string[BUFSIZE];
     struct slink *new;

     zapaction();

     if((fp=open("hotel.actions",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
	return;
     }

     while(fgets(string, 40, file) != NULL) {
	new=(struct slink *)malloc(sizeof(struct slink));
	new->next = plink;
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->name, string, 40);
        new->name[39] = '\0';

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->owner, string, 40);

	fgets(string, BUFSIZE, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
        new->verb = allocmem(strlen(string));
	strcpy(new->verb, string);

	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->object, string, 40);

	plink = new;
     }
     close(fp);
     fclose(file);
}


void syncname()
{
     int fp;
     FILE *file;
     char string[40];
     char descrip[BUFSIZE];
     struct rnames *new;

     zapname();

     if((fp=open("hotel.registry",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
		return;
     }

     while(fgets(string, 40, file) != NULL) {
	new=(struct rnames *)malloc(sizeof(struct rnames));
	new->next = regname;
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->name, string, 40);
	fgets(string, 40, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->passwd, string, 40);
	new->passwd[39] = '\0';
	fgets(descrip, BUFSIZE, file);
	if (descrip[strlen(descrip)-1] == '\n')
	  descrip[strlen(descrip)-1] = '\000';
	new->desc = allocmem(strlen(descrip));
	strcpy(new->desc, descrip);
	fgets(descrip, BUFSIZE, file);
	if (descrip[strlen(descrip)-1] == '\n')
	  descrip[strlen(descrip)-1] = '\000';
	new->arrmesg = allocmem(strlen(descrip));
	strcpy(new->arrmesg, descrip);
	fgets(descrip, BUFSIZE, file);
	if (descrip[strlen(descrip)-1] == '\n')
	  descrip[strlen(descrip)-1] = '\000';
	new->wandmesg = allocmem(strlen(descrip));
	strcpy(new->wandmesg, descrip);
	fgets(descrip, BUFSIZE, file);
	if (descrip[strlen(descrip)-1] == '\n')
	  descrip[strlen(descrip)-1] = '\000';
	new->joinmesg = allocmem(strlen(descrip));
	strcpy(new->joinmesg, descrip);
	fgets(descrip, BUFSIZE, file);
	if (descrip[strlen(descrip)-1] == '\n')
	  descrip[strlen(descrip)-1] = '\000';
	new->useraddr = allocmem(strlen(descrip));
	strcpy(new->useraddr, descrip);
	fgets(descrip, BUFSIZE, file);
	if (descrip[strlen(descrip)-1] == '\n')
	  descrip[strlen(descrip)-1] = '\000';
	new->exitmesg = allocmem(strlen(descrip));
	strcpy(new->exitmesg, descrip);
        fgets(descrip, 50, file);
        if (descrip[strlen(descrip)-1] == '\n')
          descrip[strlen(descrip)-1] = '\000';
        new->gender = descrip[0];
	fgets(string, 25, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->login, string, 25);
	fgets(string, 13, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->channel, string, 13);
	fgets(string, 15, file);
	if (string[strlen(string)-1] == '\n')
	  string[strlen(string)-1] = '\000';
	strncpy(new->flag, string, 15);
       	regname=new;
     }
     close(fp);
     fclose(file);
}

void syncmess()
{
     int fp;
     FILE *file;
     char string[BUFSIZE];
     char descrip[200];
     int count = 0;

     while(count != 104) {
       bboard[count][0]= '\0';
       count++;
     }
     count = 0;

     if((fp=open("hotel.mess",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
	return;
     }

     while(fgets(string, BUFSIZE, file) != NULL) {
       count ++;
       if (string[strlen(string)-1] == '\n')
	 string[strlen(string)-1] = '\000';
       if (count < 101)
	 strncpy(bboard[count], string, BUFSIZE);
     }
     bboard[count+1][0] = '\0';
     close(fp);
     fclose(file);
}

int emailhelp(address)
     char *address;
{
  sprintf(sendbuf, "mail %s < haven.help", address);
  system(sendbuf);
  return 0;
}

int emailboard(address)
     char *address;
{
  sprintf(sendbuf, "mail %s < hotel.mess", address);
  system(sendbuf);
  return 0;
}

int emailzmail(name,address)
     char *name;
     char *address;
{
  FILE *file;
 struct smail *temp;
  if((file = fopen("hotel.temp" , "w")) == NULL) return -1;
  
  for (temp = zmail; temp; temp=temp->next)
    if(!strcasecmp(temp->name, name)) {
      sprintf(sendbuf, ">> From %s on %s:\n", temp->from, temp->when);
      fputs(sendbuf, file);
      sprintf(sendbuf, ">> %s\n", temp->mess);
      fputs(sendbuf, file);
      fputs("\n", file);
    }
  fclose(file);
  sprintf(sendbuf, "mail %s < hotel.temp",address);
  system(sendbuf);
}

int emailreg(address)
     char *address;
{
  FILE *file;
  struct rnames *temp;
  struct sroom *rtemp;
  if((file = fopen("hotel.temp" , "w")) == NULL) return -1;
  
  fputs("registry and rooms:  current as of time of mailing.\n",file);
  fputs("\n",file);
  fputs(">> NAMES:\n", file);
  for (temp = regname; temp; temp=temp->next) {
    sprintf(sendbuf, ">> %s (%s) %s\n",temp->name,temp->login,temp->useraddr);
    fputs(sendbuf,file);
  }
  fputs("\n",file);
  fputs(">> ROOMS:\n", file);
  for(rtemp = proom; rtemp; rtemp=rtemp->next) {
    sprintf(sendbuf, ">> %s (%s)\n",rtemp->name,rtemp->owner);
    fputs(sendbuf,file);
  } 
  fclose(file);
  sprintf(sendbuf, "mail %s < hotel.temp",address);
  system(sendbuf);
}

int emailposs(name,address)
     char *name;
     char *address;
{
  FILE *file;
  struct sverb *temp;
  struct sroom *rtemp;
  struct sobject *otemp;
  struct slink *ltemp;
  if((file = fopen("hotel.temp" , "w")) == NULL) return -1;
  
  sprintf(sendbuf,">> %s possessions of %s:  current as of time of mailing.\n", CORE,name);
  fputs(sendbuf,file);
  fputs("\n",file);
  fputs(">> VERBS:\n", file);
  for (temp = pverb; temp; temp=temp->next) {
    if(!strcasecmp(name, temp->owner)) {
      if(temp->perm == 'g') {
        sprintf(sendbuf, ">> %s (global) - %s\n",temp->verbname,temp->verb);
      } else {
        sprintf(sendbuf, ">> %s (private) - %s\n",temp->verbname,temp->verb);
      }
      fputs(sendbuf,file);
    }
  }
  fputs("\n",file);
  fputs(">> OBJECTS:\n", file);
  for (otemp = pobject; otemp; otemp=otemp->next) {
    if(!strcasecmp(name, otemp->owner)) {
      sprintf(sendbuf, ">> %s - %s\n",otemp->name,otemp->desc);
      fputs(sendbuf,file);
    }
  }
  fputs("\n",file);
  fputs(">> ACTIONS/LINKS:\n", file);
  for (ltemp = plink; ltemp; ltemp=ltemp->next) {
    if(!strcasecmp(name, ltemp->owner)) {
      sprintf(sendbuf, ">> %s (%s) - %s\n",ltemp->name,ltemp->object,ltemp->verb);
      fputs(sendbuf,file);
    }
  }
  fputs("\n",file);
  fputs(">> ROOMS:\n", file);
  for(rtemp = proom; rtemp; rtemp=rtemp->next) {
    if(!strcasecmp(name, rtemp->owner)) {
      sprintf(sendbuf, ">> %s - %s\n",rtemp->name,rtemp->desc);
      fputs(sendbuf,file);
      if (rtemp->north[0] != '\00') {
	sprintf(sendbuf, "   north - %s\n", rtemp->north);
	fputs(sendbuf, file);
      }
      if (rtemp->south[0] != '\00') {
	sprintf(sendbuf, "   south - %s\n", rtemp->south);
	fputs(sendbuf, file);
      }
      if (rtemp->east[0] != '\00') {
	sprintf(sendbuf, "   east - %s\n", rtemp->east);
	fputs(sendbuf, file);
      }
      if (rtemp->west[0] != '\00') {
	sprintf(sendbuf, "   west - %s\n", rtemp->west);
	fputs(sendbuf, file);
      }
      if (rtemp->up[0] != '\00') {
	sprintf(sendbuf, "   up - %s\n", rtemp->up);
	fputs(sendbuf, file);
      }
      if (rtemp->down[0] != '\00') {
	sprintf(sendbuf, "   down - %s\n", rtemp->down);
	fputs(sendbuf, file);
      }
    } 
  }
  fclose(file);
  sprintf(sendbuf, "mail %s < hotel.temp",address);
  system(sendbuf);
}

int emailcoreentry(name, address)
     char *name;
     char *address;
{
  FILE *file;
  struct rnames *temp;
  if((file = fopen("hotel.temp" , "w")) == NULL) return -1;
  
  for (temp = regname; temp; temp=temp->next)
    if(!strcasecmp(temp->name, name)) {
      sprintf(sendbuf, ">> Name: %s\n", temp->name);
      fputs(sendbuf, file);
      sprintf(sendbuf, ">> Password: %s\n", temp->passwd);
      fputs(sendbuf, file);
      sprintf(sendbuf, ">> Description: %s %s\n", temp->name, temp->desc);
      fputs(sendbuf, file);
      sprintf(sendbuf, ">> (a) arrival mesg: %s\n", temp->arrmesg);
      fputs(sendbuf, file);
      sprintf(sendbuf, ">> (w) exit channel mesg: %s\n", temp->wandmesg);
      fputs(sendbuf, file);
      sprintf(sendbuf, ">> (j) channel join mesg: %s\n", temp->joinmesg);
      fputs(sendbuf, file);
      sprintf(sendbuf, ">> (e) exit haven mesg: %s\n", temp->exitmesg);
      fputs(sendbuf, file);
      sprintf(sendbuf, ">> Last Login: %s\n", temp->login);
      fputs(sendbuf, file);
      sprintf(sendbuf, ">> Default Channel: %s\n", temp->channel);
      fputs(sendbuf, file);
      sprintf(sendbuf, ">> User Flags: %s\n", temp->flag);
      fputs(sendbuf, file);
      sprintf(sendbuf, "These are the current settings in the %s databases for %s.  These settings may be changed that the user's descretion by changing the field and reregistering.  If you need help type .?\n", CORE,temp->name);
      fputs(sendbuf, file);
    }
  fclose(file);
  sprintf(sendbuf, "mail %s < hotel.temp",address);
  system(sendbuf);
} 
 

void syncscore()
{
     int fp;
     FILE *file;
     char string[BUFSIZE];
     int count = 1;

     while(count != 101) {
       strcpy(hiname[count], "nobody");
       hiscore[count] = 0;
       count++;
     }
     hiname[count][0] = '\0';
     count = 0;

     if((fp=open("hotel.equus.scores",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
	return;
     }

     while(fgets(string, BUFSIZE, file) != NULL) {
       count ++;
       if (string[strlen(string)-1] == '\n')
	 string[strlen(string)-1] = '\000';
       if (count < 101)
	 strncpy(hiname[count], string, BUFSIZE);
       fgets(string,BUFSIZE,file);
       if (string[strlen(string)-1] == '\n')
	 string[strlen(string)-1] = '\000';
       if (count < 101)
	 hiscore[count] = atoi(string); 
     }
     close(fp);
     fclose(file);
}

int checkmail(name)
     char *name;
{
  struct smail *temp;
  for (temp = zmail; temp; temp=temp->next)
    if(!(strcasecmp(name, temp->name)))
      return 1;
  return 0;
}

int erasemail(name)
     char *name;
{
  struct smail *mark, *temp;
  temp = zmail;
  mark = zmail;

  while((mark !=(struct smail *)0) && ((strcasecmp(mark->name, name))))
    mark=mark->next;

  if (mark == (struct smail *)0) return -1;

  while((temp->next != (struct smail *)0) && (temp->next != mark))
    temp=temp->next;

  if(temp->next == (struct smail *)0)
    return -1;

  
  temp->next = mark->next;
  free(mark->mess);
  free((char *)mark);

  return 0;
}

int iscoremail()
{
  struct smail *temp;
  for(temp = zmail; temp; temp=temp->next) 
    if(!strcasecmp(temp->from, CORE))
      return 1;
  return 0;
}


int erasecoremail()
{
  struct smail *mark, *temp;
  temp = zmail;
  mark = zmail;

  while((mark !=(struct smail *)0) && ((strcasecmp(mark->from, CORE))))
    mark=mark->next;

  if (mark == (struct smail *)0) return -1;

  while((temp->next != (struct smail *)0) && (temp->next != mark))
    temp=temp->next;

  if(temp->next == (struct smail *)0)
    return -1;

  temp->next = mark->next;
  free((char *)mark);

  return 0;
}

int readmailnumber(pplayer, num)
     struct splayer *pplayer;
     int num;
{
  int tnum = num;
  struct smail *temp;
  temp = zmail;

  while(num > 0) {
    while((temp != (struct smail *)0) && ((strcasecmp(temp->name, pplayer->name))))
      temp=temp->next;
    if (temp == (struct smail *)0) return -1;
    num --;
    if (num>0) temp=temp->next;
  }
  sprintf(sendbuf, ">> Message %d:\r\n", tnum);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, ">> From %s on %s:\r\n",temp->from, temp->when);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, ">> %s\r\n\r\n", temp->mess);
  sendtoplayer(pplayer, sendbuf);
  return 0;
}
     

int erasemailnumber(pplayer, mesgnum)
     struct splayer *pplayer;
     int mesgnum;
{
  int tnum = mesgnum;
  struct smail *mark, *temp;
  temp = zmail;
  mark = zmail;

  while (mesgnum > 0) {
    while((mark !=(struct smail *)0) && ((strcasecmp(mark->name, pplayer->name))))
      mark=mark->next;

    if (mark == (struct smail *)0) return -1;
    mesgnum --;
    if (mesgnum>0) mark=mark->next;
  }

  while((temp->next != (struct smail *)0) && (temp->next != mark))
    temp=temp->next;

  if(temp->next == (struct smail *)0)
    return -1;

  sprintf(sendbuf, ">> %s:  Message %d from %s (%s) erased.\r\n",CORE,tnum,mark->from,mark->when);
  sendtoplayer(pplayer, sendbuf);

  temp->next = mark->next;
  free((char *)mark);

  return 0;
}

int erasename(name)
     char *name;
{
  struct rnames *mark, *temp;
  temp = regname;
  mark = regname;

  while((mark !=(struct rnames *)0) && ((strcasecmp(mark->name, name))))
    mark=mark->next;

  if (mark == (struct rnames *)0) return -1;

  while((temp->next != (struct rnames *)0) && (temp->next != mark))
    temp=temp->next;

  if(temp->next == (struct rnames *)0)
    return -1;

  temp->next = mark->next;
  free(mark->desc);
  free(mark->arrmesg);
  free(mark->wandmesg);
  free(mark->joinmesg);
  free(mark->useraddr);
  free(mark->exitmesg);
  free((char *)mark);

  return 0;
}

int eraseverb(name)
     char *name;
{
  struct sverb *mark, *temp;
  temp = pverb;
  mark = pverb;

  while((mark !=(struct sverb *)0) && ((strcasecmp(mark->verbname, name))))
    mark=mark->next;

  if (mark == (struct sverb *)0) return -1;

  while((temp->next != (struct sverb *)0) && (temp->next != mark))
    temp=temp->next;

  if(temp->next == (struct sverb *)0)
    return -1;

  temp->next = mark->next;
  free(mark->verb);
  free((char *)mark);

  return 0;
}

int removelockout(name)
     char *name;
{
  struct hostlist *mark, *temp;
  temp = rlist;
  mark = rlist;

 
  while((mark !=(struct hostlist *)0) && ((!strcasestr(mark->name, name))))
    mark=mark->next;

  if (mark == (struct hostlist *)0) return -1;

  while((temp->next != (struct hostlist *)0) && (temp->next != mark))
    temp=temp->next;
  
  if(mark == rlist) {
    rlist = mark->next;
    free((char *)mark);
    return 0;
  }

  if(temp->next == (struct hostlist *)0)
    return -1;

  temp->next = mark->next;
  free((char *)mark);

  return 0;
}

int removefriend(name, friend)
     char *name;
     char *friend;
{
  struct sfriend *mark, *temp;
  temp = pfriend;
  mark = pfriend;
 
  while((mark !=(struct sfriend *)0) && ((strcasecmp(mark->name, name)) || (strcasecmp(mark->friend, friend))))
    mark=mark->next;

  if (mark == (struct sfriend *)0) return -1;

  while((temp->next != (struct sfriend *)0) && (temp->next != mark))
    temp=temp->next;
  
  if(mark == pfriend) {
    pfriend = mark->next;
    free((char *)mark);
    return 0;
  }

  if(temp->next == (struct sfriend *)0)
    return -1;

  temp->next = mark->next;
  free((char *)mark);

  return 0;
}

int removebanned(name)
     char *name;
{
  struct banlist *mark, *temp;
  temp = blist;
  mark = blist;

  while((mark !=(struct banlist *)0) && ((!strcasestr(mark->name, name))))
    mark=mark->next;

  if (mark == (struct banlist *)0) return -1;

  if(mark == blist) {
    blist = mark->next;
    free((char *)mark);
    return 0;
  }

  while((temp->next != (struct banlist *)0) && (temp->next != mark))
    temp=temp->next;

  if(temp->next == (struct banlist *)0)
    return -1;

  temp->next = mark->next;
  free((char *)mark);

  return 0;
}

int removelewd(name)
     char *name;
{
  struct lewdlist *mark, *temp;
  temp = nlist;
  mark = nlist;

  while((mark !=(struct lewdlist *)0) && ((!strcasestr(mark->name, name))))
    mark=mark->next;

  if (mark == (struct lewdlist *)0) return -1;

  if(mark == nlist) {
    nlist = mark->next;
    free((char *)mark);
    return 0;
  }

  while((temp->next != (struct lewdlist *)0) && (temp->next != mark))
    temp=temp->next;

  if(temp->next == (struct lewdlist *)0)
    return -1;

  temp->next = mark->next;
  free((char *)mark);

  return 0;
}

int listlockout(pplayer)
     struct splayer *pplayer;
{
  struct hostlist *tmp;
  sendtoplayer(pplayer, ">> Current locked out sites:\r\n");
  for (tmp = rlist; tmp; tmp = tmp->next) {
    sprintf(sendbuf, "   %s\r\n", tmp->name);
    sendtoplayer(pplayer, sendbuf);
  }
}

int listbanned(pplayer)
     struct splayer *pplayer;
{
  struct banlist *tmp;
  sendtoplayer(pplayer, ">> Current banned (to unregistered users) sites:\r\n");
  for (tmp = blist; tmp; tmp = tmp->next) {
    sprintf(sendbuf, "   %s\r\n", tmp->name);
    sendtoplayer(pplayer, sendbuf);
  }
}


int listlewd(pplayer)
     struct splayer *pplayer;
{
  struct lewdlist *tmp;
  sendtoplayer(pplayer, ">> Current names on the lewd list:\r\n");
  for (tmp = nlist; tmp; tmp = tmp->next) {
    sprintf(sendbuf, "   %s\r\n", tmp->name);
    sendtoplayer(pplayer, sendbuf);
  }
}




int eraseroom(name)
     char *name;
{
  struct sroom *mark, *temp;
  temp = proom;
  mark = proom;

  if(!strcasecmp(name, MAIN)) return -1;

  while((mark !=(struct sroom *)0) && ((strcmp(mark->name, name))))
    mark=mark->next;

  if (mark == (struct sroom *)0) return -1;

  while((temp->next != (struct sroom *)0) && (temp->next != mark))
    temp=temp->next;

  if(temp->next == (struct sroom *)0)
    return -1;

  temp->next = mark->next;
  free(mark->desc);
  free((char *)mark);

  return 0;
}

int eraseobject(name)
     char *name;
{
  struct sobject *mark, *temp;
  temp = pobject;
  mark = pobject;

  while((mark !=(struct sobject *)0) && ((strcasecmp(mark->name, name))))
    mark=mark->next;

  if (mark == (struct sobject *)0) return -1;

  while((temp->next != (struct sobject *)0) && (temp->next != mark))
    temp=temp->next;

  if(temp->next == (struct sobject *)0)
    return -1;

  temp->next = mark->next;
  free(mark->desc);
  free(mark->inmesg);
  free(mark->outmesg);
  free((char *)mark);

  return 0;
}

int purgeobject(pplayer, name)
     struct splayer *pplayer;
     char *name;
{
  struct sobject *temp;
  for (temp = pobject; temp; temp = temp->next) {
    if(!strcasecmp(temp->owner, name)) {
      sprintf(sendbuf, ">> Wiped object: %s\r\n", temp->name);
      eraseobject(temp->name);
      while(islinkonobject(temp->name))
	purgelink(temp->name);
      sendtoplayer(pplayer,sendbuf);
      emptyobject(pplayer, name);
      return 1;
    }
  }
}

int purgeverb(pplayer, name)
     struct splayer *pplayer;
     char *name;
{
  struct sverb *temp;
  for (temp = pverb; temp; temp = temp->next) {
    if(!strcasecmp(temp->owner, name)) {
      sprintf(sendbuf, ">> Wiped verb: %s\r\n", temp->verbname);
      sendtoplayer(pplayer,sendbuf);
      eraseverb(temp->verbname);
      return 1;
    }
  }
}


int purgefriend(pplayer, name)
     struct splayer *pplayer;
     char *name;
{
  struct sfriend *temp;
  for (temp = pfriend; temp; temp = temp->next) {
    if((!strcasecmp(temp->name, name)) || (!strcasecmp(temp->friend,name))) {
      sprintf(sendbuf,">> Wiped friend: %s -> %s\r\n",temp->name,temp->friend);
      sendtoplayer(pplayer,sendbuf);
      if((!strcasecmp(temp->name,name)))
	removefriend(name, temp->friend);
      else
	removefriend(temp->name, name);
      temp=pfriend;
    }
  }
}

int stripinv(pplayer, name)
     struct splayer *pplayer;
     char *name;
{
  struct sobject *temp;
  
  for(temp=pobject; temp; temp=temp->next) {
    if((strcasecmp(name, temp->cont)==0) && ((temp->c_type == 'p')))    {
      putobjinroom(temp->name, STORAGE);
      sprintf(sendbuf, ">> Object \"%s\" put into storage.\r\n",temp->name);
      sendtoplayer(pplayer,sendbuf);
    }
  }
}


int emptyobject(pplayer,obj)
     struct splayer *pplayer;
     char *obj;
{
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->cont) && (temp->c_type == 'o')) {
      purobjectinroom(temp->name, STORAGE);
      sprintf(sendbuf, ">> Object \"%s\" put into storage.\r\n",temp->name);
      sendtoplayer(pplayer,sendbuf);
    }
  for(temp=players;temp;temp=temp->next)
    if(!strcasecmp(temp->object, obj)) {
      temp->object[0]='\0';
    }
  return 0;
}



int deleteuser(pplayer, name)
     struct splayer *pplayer; 
     char *name;
{
  if(!strcasecmp(name, NEWCONN)) {
     sprintf(sendbuf, ">> %s is the NEWCONN.  Can not be deleted.\r\n");
     sendtoplayer(pplayer,sendbuf);
     return 0;
  }
  if(!strcasecmp(name, MAIN_OWNER)) {
     sprintf(sendbuf, ">> %s is the MAIN_OWNER.  Can not be deleted.\r\n");
     sendtoplayer(pplayer,sendbuf);
     return 0;
  }
  erasename(name);
  sprintf(sendbuf, ">> %s has been deleted.\r\n",name);
  sendtoplayer(pplayer,sendbuf);
  while(checkmail(name))
    erasemail(name);
  while(numobject(name))
    purgeobject(pplayer,name);
  while(numverb(name))
    purgeverb(pplayer,name);
  purgefriend(pplayer,name);
  stripinv(pplayer,name);
  while(numroom(name))
    purgeroom(pplayer,name);
  return 0;
}

int databasecheck(pplayer)
     struct splayer *pplayer;
{
  int fp;
  FILE *file;
  char string[BUFSIZE];
  int c;
  int rcount = 0;  /* record count */
  int mcount = 0;
  int vcount = 0;
  int ocount = 0;
  int acount = 0;
  int ccount = 0;
  int fcount = 0;
  int merr = 0;   /* error count */
  int verr = 0;
  int oerr = 0;
  int aerr = 0;
  int cerr = 0;
  int ferr = 0;
  struct rnames *rptr;  /* pointers */
  struct smail *mptr;
  struct sverb *vptr;
  struct sobject *optr;
  struct slink *aptr;
  struct sroom *cptr;
  struct sfriend *fptr;
  char tmpname[40];

  /* STEP 1:  run through the database file and check to see if there are any
     names longer than 25 character or 0 characters in length */

  sprintf(sendbuf, ">> %s:  database checksum running... please wait\r\n", CORE);
  sendall(sendbuf, "*", 0,0);

  savecore();
  sprintf(sendbuf, "[SYSLOG:  CORE saved]\r\n");
  sendall(sendbuf, "*", SYSLOG2, 0);


  sprintf(sendbuf, ">> %s:  checking registry...\r\n",CORE);
  sendtoplayer(pplayer,sendbuf);

  if((fp=open("hotel.registry",0)) == -1) return;
  
  if((file=fdopen(fp, "r")) == NULL) {
    sendtoplayer(pplayer, ">> ERROR OPENING REGISTRY.\r\n");
    return;
  }
  
  while(fgets(string, BUFSIZE, file) != NULL) {
    rcount ++;
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    if ((strlen(string) > 25) || (strlen(string) == 0)) {
      sprintf(sendbuf,">> %s:  registry corrupted!  record = %d\r\n", CORE, rcount);
      sendtoplayer(pplayer,sendbuf);
      return -1;
    }
    for(c = 1; c <= 11; c++) {
      if (fgets(string, BUFSIZE, file) == NULL) {
	sprintf(sendbuf,">> %s:  UNEXPECTED EOF IN REGISTRY!  record = %d (%d)\r\n", CORE, rcount, c);
	sendtoplayer(pplayer,sendbuf);
	return -1;
      }
    }
  }
  close(fp);
  fclose(file);
  
  sprintf(sendbuf, "[SYSLOG:  registry ok.  records read: %d]\r\n", rcount);
  sendall(sendbuf, "*", SYSLOG2, 0);
  
  /* STEP 2:  check the mail... if there is mail to a name not in the 
     database, erase it */

  for (mptr = zmail; mptr; mptr = mptr->next) {
    if ((!registered(mptr->name)) && (strcmp(mptr->name, " XX"))) {
      strcpy(tmpname, mptr->name);
      sprintf(sendbuf,">> %s:  Mail to %s invalid.  Erasing...\n",CORE,tmpname);
      sendtoplayer(pplayer,sendbuf);
      mcount++;
      strcpy(mptr->name, CORE);
    }
  }
  sprintf(sendbuf, "[SYSLOG:  Zmail checked with %d diagnostics.]\r\n", mcount);
  sendall(sendbuf, "*", SYSLOG2, 0);

  /* STEP 3:  check the verbs... if there is a verb owned by a name not in the 
     database, erase it */

  for (vptr = pverb; vptr; vptr = vptr->next) {
    if ((!registered(vptr->owner)) && (strcmp(vptr->verbname, "dummy"))) {
      strcpy(tmpname, vptr->owner);
      sprintf(sendbuf, ">> %s:  Verb owned by %s invalid.  Erasing...\n",CORE,tmpname);
      sendtoplayer(pplayer,sendbuf);
      vcount++;
      strcpy(vptr->owner, CORE);
    }
  }
  sprintf(sendbuf, "[SYSLOG:  Verbs checked with %d diagnostics.]\r\n", vcount);
  sendall(sendbuf, "*", SYSLOG2, 0);

  /* STEP 4:  check the rooms... if there is room on a name not in the 
     database, erase it */

  for (cptr = proom; cptr; cptr = cptr->next) {
    if (!registered(cptr->owner) && strcmp(cptr->name, MAIN)) {
      strcpy(tmpname, cptr->owner);
      sprintf(sendbuf, ">>%s:  Room belonging to %s invalid.  Erasing...\n",CORE,tmpname);
      sendtoplayer(pplayer,sendbuf);
      ccount++;
      strcpy(cptr->owner, CORE);
    }
  }
  sprintf(sendbuf, "[SYSLOG:  Rooms checked with %d diagnostics.]\r\n", ccount);
  sendall(sendbuf, "*", SYSLOG2, 0);

  /* STEP 5:  check the objs... if there is obj on a name not in the 
     database, erase it */

  for (optr = pobject; optr; optr = optr->next) {
    if (!registered(optr->owner) && strcmp(optr->name, " XX")) {
      strcpy(tmpname, optr->owner);
      sprintf(sendbuf, ">> %s: Object belonging to %s invalid.  Erasing...\n",CORE,tmpname);
      sendtoplayer(pplayer,sendbuf);
      ocount++;
      strcpy(optr->owner, CORE);
    }
  }
  sprintf(sendbuf, "[SYSLOG:  Objects checked with %d diagnostics.]\r\n", ocount);
  sendall(sendbuf, "*", SYSLOG2, 0);

  /* STEP 6:  check the links... if there is links on a name or obj not in the 
     database, erase it */

  for (aptr = plink; aptr; aptr = aptr->next) {
    if (!isobject(aptr->object) && (strcmp(aptr->name, " XX"))) {
      strcpy(tmpname, aptr->object);
      aptr=plink;
      sprintf(sendbuf,">> %s: link on object %s invalid.  Erasing...\n",CORE,tmpname);
      sendtoplayer(pplayer,sendbuf);
      acount++;
      while(islinkonobject(tmpname))	
	 purgelink(tmpname);
    }
  }
  sprintf(sendbuf, "[SYSLOG:  Actions checked with %d diagnostics.]\r\n", acount);
  sendall(sendbuf, "*", SYSLOG2, 0);

 /* STEP 7:  check friends lists... if there are any friends that are unregistered,
          then delete */

  for (fptr = pfriend; fptr; fptr = fptr->next) {
    if ((!registered(fptr->name)) && (strcmp(fptr->name, " XX"))) {
      strcpy(tmpname, fptr->name);
      sprintf(sendbuf,">> %s:  Friend %s invalid.  Erasing...\n",CORE,tmpname);
      sendtoplayer(pplayer,sendbuf);
      fcount++;
      strcpy(fptr->name, CORE);
    }
  }
  sprintf(sendbuf, "[SYSLOG:  Friends checked with %d diagnostics.]\r\n", fcount);
  sendall(sendbuf, "*", SYSLOG2, 0);
  
 /* All done */
  sprintf(sendbuf, ">> %s:  All done.\r\n", CORE);
  sendall(sendbuf, "*", 0,0);
  sprintf(sendbuf, "[SYSLOG:  DIAGNOSTICS COMPLETE.]\r\n",CORE);
  sendall(sendbuf, "*", SYSLOG2, 0);

  deleteuser(pplayer, CORE);

  return 0;
}

  

int wipeusers(pplayer, patt)
     struct splayer *pplayer;
     char *patt;
{
  struct rnames *temp;
  for (temp = regname; temp; temp=temp->next)
    if (strcasestr(temp->login, patt)) {
      deleteuser(pplayer, temp->name);
      sprintf(sendbuf, ">> WIPED:  %s (%s)\r\n", temp->name, temp->login);
      sendtoplayer(pplayer,sendbuf);
      temp = regname;
   }
   sendtoplayer(pplayer, ">> DONE\r\n"); 
}





int purgeroom(pplayer, name)
     struct splayer *pplayer;
     char *name;
{
  struct sroom *temp;
  for (temp = proom; temp; temp = temp->next) {
    if(!strcasecmp(temp->owner, name)) {
      sprintf(sendbuf, ">> Wiped room: %s\r\n", temp->name);
      sendtoplayer(pplayer,sendbuf);
      eraseroom(temp->name);
      return 1;
    }
  }
}


int eraselink(name)
     char *name;
{
  struct slink *mark, *temp;
  temp = plink;
  mark = plink;

  while((mark !=(struct slink *)0) && ((strcasecmp(mark->name, name))))
    mark=mark->next;

  if (mark == (struct slink *)0) return -1;

  while((temp->next != (struct slink *)0) && (temp->next != mark))
    temp=temp->next;

  if(temp->next == (struct slink *)0)
    return -1;

  temp->next = mark->next;
  free(mark->verb);
  free((char *)mark);

  return 0;
}


int numverb(name)
     char *name;
{
  struct sverb *temp;
  int num = 0;
  for(temp=pverb; temp; temp=temp->next)
   if (!strcasecmp(name, temp->owner))
      num++;
  return num;
}

int readmail(pplayer)
     struct splayer *pplayer;
{
  struct smail *temp;
  int num = 0;
  for (temp = zmail; temp; temp=temp->next) {
    if(!(strcasecmp(temp->name, pplayer->name))) {
      num++;
      sprintf(sendbuf, ">> %d) From %s on %s:\r\n", num,temp->from,temp->when);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> %s\r\n\r\n",temp->mess);
      sendtoplayerg(pplayer,pplayer,sendbuf);
    }
  }
  return 0;
}

int mailfrom(pplayer)
     struct splayer *pplayer;
{
  struct smail *temp;
  int num = 0;
  for (temp = zmail; temp; temp=temp->next) {
    if(!(strcasecmp(temp->name, pplayer->name))) {
      num++;
      sprintf(sendbuf, ">> %d) From %s on %s:\r\n",num, temp->from,temp->when);
      sendtoplayer(pplayer,sendbuf);
    }
  }
  return 0;
}

void zapmail()
{
     struct smail *temp, *next;

     temp = zmail;
     while (temp != NULL) {
	next = temp->next;
        free(temp->mess);
	free((char *) temp);
	temp = next;
     }
     zmail = NULL;
     return;
}

void zapverb()
{
     struct sverb *temp, *next;

     temp = pverb;
     while (temp != NULL) {
	next = temp->next;
        free(temp->verb);
	free((char *) temp);
	temp = next;
     }
     pverb = NULL;
     return;
}

void zaproom()
{
     struct sroom *temp, *next;

     temp = proom;
     while (temp != NULL) {
	next = temp->next;
        free(temp->desc);
	free((char *) temp);
	temp = next;
     }
     proom = NULL;
     return;
}

int mayuse(name, verb)
     char *name;
     char *verb;
{
  struct sverb *temp;
  for (temp=pverb;temp;temp=temp->next)
    if(!strcasecmp(verb, temp->verbname))
      if(!strcasecmp(name,temp->owner))
	return 1;
      else if (temp->perm == 'g')
	return 1;
      else if (isfriend(temp->owner, name))
	return 1;
  return 0;
}

int isowner(name, verb)
     char *name;
     char *verb;
{
  struct sverb *temp;
  for (temp=pverb;temp;temp=temp->next)
    if(!strcasecmp(verb, temp->verbname))
      if(!strcasecmp(name, temp->owner))
	return 1;
  return 0;
}

int isroomowner(room, name)
     char *name;
     char *room;
{
  struct sroom *temp;
  for (temp=proom;temp;temp=temp->next)
    if(!strcmp(room, temp->name))
      if(!strcasecmp(name, temp->owner))
	return 1;
  return 0;
}

int putobjinroom(obj, room)
     char *obj;
     char *room;
{
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->name)) {
      temp->c_type = 'r';
      strcpy(temp->cont, room);
      return 0;
    }
  return 0;
}

int putobjonowner(obj)
char *obj;
{
struct sobject *temp;
   for(temp=pobject;temp;temp=temp->next)
   if(!strcasecmp(obj, temp->name)) {
     temp->c_type = 'p';
    strcpy(temp->cont, temp->owner);
     return 0;
   }
   return 0;
 }

int putobjonuser(obj, name)
     char *obj;
     char *name;
{
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->name)) {
      temp->c_type = 'p';
      strcpy(temp->cont, name);
      return 0;
    }
  return 0;
}

int putobjinobj(obj, name)
     char *obj;
     char *name;
{
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->name)) {
      temp->c_type = 'o';
      strcpy(temp->cont, name);
      return 0;
    }
  return 0;
}

int lockobject(obj)
     char *obj;
{
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->name)) {
      temp->c_type = 'l';
      return 0;
    }
  return 0;
}

int islocked(obj)
     char *obj;
{
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->name)) {
      if (temp->c_type == 'l')
	return 1;
      else
	return 0;
    }
  return 0;
}

int inventory(pplayer,name)
     struct splayer *pplayer;
     char *name;
{
  struct sobject *temp;
  sprintf(sendbuf, ">> Objects carried by %s:\r\n", name);
  sendtoplayer(pplayer,sendbuf);
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(name, temp->cont) && (temp->c_type == 'p')) {
      sprintf(sendbuf, "%s (%s)\r\n", temp->name, temp->owner);
      sendtoplayer(pplayer,sendbuf);
    }
  return 0;
}

int lookobject(pplayer,obj)
     struct splayer *pplayer;
     char *obj;
{
  struct sobject *temp;
  struct slink *temp2;

  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->name)) {
      sprintf(sendbuf, ">> Name: %s - %s\r\n", temp->name, temp->desc);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Owned by: %s\r\n", temp->owner);
      sendtoplayer(pplayer,sendbuf);
      switch(temp->c_type) {
      case 'r':
        sprintf(sendbuf, ">> Location: [room] %s\r\n", temp->cont); break;
      case 'p':
        sprintf(sendbuf, ">> Location: [player] %s\r\n", temp->cont); break;
      case 'l':
        sprintf(sendbuf, ">> Location: [locked] %s\r\n", temp->cont); break;
      case 'o':
        sprintf(sendbuf, ">> Location: [object] %s\r\n", temp->cont); break;
      }
      sendtoplayer(pplayer,sendbuf);
      if(temp->cont_perm == 'e')
        sendtoplayer(pplayer, ">> Type: enclosed\r\n");
      else
        sendtoplayer(pplayer, ">> Type: container\r\n");
      usersinremoteobj(pplayer, temp->name);
      objectsinobj(pplayer, temp->name);
      sprintf(sendbuf, ">> Links:\r\n");
      sendtoplayer(pplayer,sendbuf);
    }
  for(temp2=plink;temp2;temp2=temp2->next)
    if(!strcasecmp(temp2->object, obj)) {
      sprintf(sendbuf, "   %s\r\n",temp2->name);
      sendtoplayer(pplayer,sendbuf);
    }
  return 0;
 }

int looklink(pplayer, link)
     struct splayer *pplayer;
     char *link;
{
  struct slink *temp;
  for(temp=plink;temp;temp=temp->next)
    if(!strcasecmp(temp->name, link)) {
      sprintf(sendbuf, ">> Action/Link: %s\r\n", temp->name);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Object:  %s\r\n", temp->object);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Verb:  %s\r\n", temp->verb);
      sendtoplayer(pplayer,sendbuf);
    }
  return 0;
}

int listobjects(pplayer,name)
     char *name;
     struct splayer *pplayer;
{
  struct sobject *temp;
  sprintf(sendbuf, ">> Objects currently owned by %s:\r\n",name);
  sendtoplayer(pplayer,sendbuf);
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(temp->owner,name)) {
      sprintf(sendbuf, "%s\r\n", temp->name);
      sendtoplayer(pplayer,sendbuf);
    }
  return 0;
}

int islinkonobject(obj)
     char *obj;
{
  struct slink *temp;
  for(temp=plink;temp;temp=temp->next)
    if(!strcasecmp(temp->object, obj))
      return 1;
  return 0;
}

int numobject(name)
     char *name;
{
  struct sobject *temp;
  int num = 0;
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(temp->owner, name))
      num++;
  return num;
}

int numobjects()
{
  int num = 0;
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next)
    num++;
  return num;
}

int purgelink(obj)
     char *obj;
{
  struct slink *temp;
  for(temp=plink;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->object)) {
      eraselink(temp->name);
      return 1;
    }
}

 
       
       
  

int unlockobject(obj)
     char *obj;
{
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->name)) {
      temp->c_type = 'r';
      return 0;
    }
  return 0;
}

int isobjectowner(object, name)
     char *name;
     char *object;
{
  struct sobject *temp;
  for (temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(object, temp->name))
      if(!strcasecmp(name, temp->owner))
	return 1;
  return 0;
}

int isobjectfriend(object, name)
     char *name;
     char *object;
{
  struct sobject *temp;
  for (temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(object, temp->name))
      if((!strcasecmp(name, temp->owner)) || (isfriend(temp->owner, name)))
	return 1;
  return 0;
}

int isactionowner(object, name)
     char *name;
     char *object;
{
  struct slink *temp;
  for (temp=plink;temp;temp=temp->next)
    if(!strcasecmp(object, temp->name))
      if(!strcasecmp(name, temp->owner))
	return 1;
  return 0;
}

int isobjinroom(object, room)
     char *object;
     char *room;
{
  struct sobject *temp;
  for (temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(object, temp->name))
      if(!strcasecmp(room, temp->cont) && ((temp->c_type == 'r') || (temp->c_type == 'l')))
	return 1;
  return 0;
}

int isobjonobj(obj, host)
     char *host;
     char *obj;
{
  struct sobject *temp;
  for (temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->name))
      if(!strcasecmp(host, temp->cont) && (temp->c_type == 'o'))
	return 1;
  return 0;
}     

int isobjcontainer(obj)
     char *obj;
{
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->name))
      if((temp->cont_perm == 'c'))
	return 1;
  return 0;
}

int isobjcontaining(obj)
     char *obj;
{
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->cont) && (temp->c_type == 'o'))
      return 1;
  return 0;
}


      
int togglecont_perm(obj)
   char *obj;
{
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(obj, temp->name))
      if((temp->cont_perm == 'c'))
	temp->cont_perm = 'e';
      else
	temp->cont_perm = 'c';
  return 1;
}

int isplayerinobj(obj)
     char *obj;
{
  struct splayer *temp;
  for(temp=players;temp;temp=temp->next)
    if(!strcasecmp(temp->object, obj))
      return 1;
  return 0;
}

int isobjonsamelevelp(pplayer, obj)
     struct splayer *pplayer;
     char *obj;
{
  struct sobject *temp;
  for(temp=pobject; temp; temp=temp->next)
    if(!strcasecmp(temp->name, obj))
      if(!strcasecmp(temp->cont, pplayer->object) && (temp->c_type == 'o'))
	return 1;
  return 0;
}

int isobjremovable(obj, pplayer)
     char *obj;
     struct splayer *pplayer;
{
  struct sobject *temp1;
  for(temp1=pobject; temp1; temp1=temp1->next)
    if(!strcasecmp(obj, temp1->name)) {
      if(isobjonsamelevelp(pplayer, temp1->cont) && ((temp1->c_type == 'o')))
	return 1;
      else if(isobjinroom(temp1->cont, pplayer->channel) && ((temp1->c_type == 'o')))
	return 1;
      else if(isobjonuser(temp1->cont, pplayer->name) && ((temp1->c_type == 'o')))
        return 1;
    }
  return 0;
}


int isobjonsamelevelo(obj1, obj2)
     char *obj1;
     char *obj2;
{
  struct sobject *temp1;
  struct sobject *temp2;

  for(temp1=pobject; temp1; temp1=temp1->next)
    if(!strcasecmp(temp1->name, obj1)) {
      for(temp2=pobject; temp2;temp2=temp2->next)
	if(!strcasecmp(temp2->name, obj2))
	  if((temp1->c_type == temp2->c_type))
	    if(!strcasecmp(temp1->cont, temp2->cont))
	      return 1;
    }
  return 0;
}

int isobjonuser(object, name)
     char *object;
     char *name;
{
  struct sobject *temp;
  for (temp=pobject;temp;temp=temp->next)
    if(!strcasecmp(object, temp->name))
      if(!strcasecmp(name, temp->cont) && (temp->c_type == 'p'))
	return 1;
  return 0;
}

int sendmail(from, rplayer, mesg)
     char *from;
     char *rplayer;
     char *mesg;
{
  char *tmptime;
  time_t now = time(0);
  struct smail *temp;
  temp = zmail;
  while(temp->next != (struct smail *)0) temp=temp->next;
  temp->next = (struct smail *)malloc(sizeof(struct smail));
  if(temp->next == (struct smail *)0) return -1;

  tmptime = ctime(&now);
  tmptime[19] = '\0';
  temp=temp->next;
  temp->next = (struct smail *)0;
  strcpy(temp->name, rplayer);
  strcpy(temp->from, from);
  strcpy(temp->when, tmptime);
  temp->mess = allocmem(strlen(mesg));
  strcpy(temp->mess, mesg);
  notifymail(rplayer); 
  return 0;
}

int sendglobalmail(from,mesg)
     char *from;
     char *mesg;
{
  struct rnames *temp;
  for (temp=regname; temp; temp=temp->next)
    sendmail(CORE, temp->name, mesg);
  if (savemail() == -1) return -1;
  sprintf(sendbuf, "[SYSLOG:  Global mail sent by %s]\r\n", from);
  sendall(sendbuf, "*", SYSLOG2, 0);

  return 0;
}

 

void zapname()
{
     struct rnames *temp, *next;

     temp = regname;
     while (temp != NULL) {
	next = temp->next;
        free(temp->arrmesg);
	free(temp->wandmesg);
	free(temp->useraddr);
	free(temp->joinmesg);
	free(temp->exitmesg);
	free(temp->desc);
	free((char *) temp);
	temp = next;
     }
     regname = NULL;
     return;
}

void zapfriend()
{
     struct sfriend *temp, *next;
     temp = pfriend;
     while (temp != NULL) {
	next = temp->next;
	free((char *) temp);
	temp = next;
     }
     pfriend = NULL;
     return;
}

int listaddr(pplayer)
     struct splayer *pplayer;
{
  int num = 0;
  struct rnames *temp;

  sprintf(sendbuf, ">> %s:  Current haven directory of published addresses:\r\n",CORE);
  sendtoplayer(pplayer,sendbuf);
  for(temp=regname; temp; temp=temp->next) {
    if(temp->useraddr[0] != '\0') {
      num++;
      sprintf(sendbuf, ">> %s:  %s\r\n",temp->name,temp->useraddr);
      sendtoplayer(pplayer,sendbuf);
    }
  }
  sprintf(sendbuf, ">> %s: %d entries found.\r\n",CORE, num);
  sendtoplayer(pplayer,sendbuf);
  return 1;
}

int listregistry(pplayer, patt)
     struct splayer *pplayer;
     char *patt;
{
  int lines = 0;
  int stopat;
  int num = 0;
  struct rnames *temp;
  
  if(pplayer->moretype == tilde)
    stopat = pplayer->moreline + 20;
  else {
    stopat = 20;
    pplayer->moreline = 0;
  }

  for (temp=regname; temp; temp=temp->next) {
    if(strcasestr(temp->name, patt)) {
      num++;
      if(temp->useraddr[0] == '\0') {
	sprintf(sendbuf, ">> name: %s\r\n",temp->name);
      } else {
	sprintf(sendbuf, ">> name: %s (%s)\r\n",temp->name,temp->useraddr);
      }
      if (lines <= stopat) {
        if (lines >= pplayer->moreline)
	  sendtoplayer(pplayer,sendbuf);
	lines++;
      } else {
        break;
      }
    }
  }
  if(!temp) {
    sprintf(sendbuf, ">> %s:  %d names found.\r\n",CORE,num);
    sendtoplayer(pplayer,sendbuf);
    pplayer->moretype = none;
    pplayer->moreline = 0;
  } else {
    pplayer->moretype = tilde;
    pplayer->moreline = lines;
    strncpy(pplayer->morearg, patt, 28);
    sendtoplayer(pplayer, "--- MORE --- Press return to continue:\r\n");
  }
  return 1;
}

int listsite(pplayer, patt)
     struct splayer *pplayer;
     char *patt;
{
  int lines = 0;
  int stopat;
  int num = 0;
  struct rnames *temp;

  if(pplayer->moretype == backquote)
    stopat = pplayer->moreline + 20;
  else {
    stopat = 20;
    pplayer->moreline = 0;
  }

  for (temp=regname; temp; temp=temp->next) {
    if(strcasestr(temp->useraddr, patt)) {
      num++;
      if(temp->useraddr[0] == '\0') {
        sprintf(sendbuf, ">> name: %s\r\n",temp->name);
      } else {
        sprintf(sendbuf, ">> name: %s (%s)\r\n",temp->name,temp->useraddr);
      }
      if (lines <= stopat) {
        if (lines >= pplayer->moreline)
          sendtoplayer(pplayer,sendbuf);
        lines++;
      } else {
        break;
      }
    }
  }
  if(!temp) {
    sprintf(sendbuf, ">> %s:  %d names found.\r\n",CORE,num);
    sendtoplayer(pplayer,sendbuf);
    pplayer->moretype = none;
    pplayer->moreline = 0;
  } else {
    pplayer->moretype = backquote;
    pplayer->moreline = lines;
    strncpy(pplayer->morearg, patt, 28);
    sendtoplayer(pplayer, "--- MORE --- Press return to continue:\r\n");
  }
  return 1;
}


int domore(pplayer)
     struct splayer *pplayer;
{
  if (pplayer->moretype == longverblist)
    listverbs(pplayer);
  else if (pplayer->moretype == finglist)
    finger(pplayer);
  else if (pplayer->moretype == verblist)
    fingerverb(pplayer);
  else if (pplayer->moretype == login1) 
    finishlogin1(pplayer);
  else if (pplayer->moretype == backquote)
    listsite(pplayer, pplayer->morearg);
  else if (pplayer->moretype == tilde)
    listregistry(pplayer, pplayer->morearg);
  else if (pplayer->moretype == tidle)                     
    whoson(pplayer, atoi(pplayer->morearg), NULL, TIDLE);
  else if (pplayer->moretype == who) {
    if(*pplayer->morearg == '\000')
      whoson(pplayer, 0, pplayer->morearg, ALL);
    else
      whoson(pplayer, 0, pplayer->morearg, CHANNEL);
  } else if (pplayer->moretype == who2) {
    if(*pplayer->morearg == '\000')
      whoson2(pplayer, 0, pplayer->morearg, ALL);
    else
      whoson2(pplayer, 0, pplayer->morearg, CHANNEL);
  }
}


int listrooms(name,pplayer)
     char *name;
     struct splayer *pplayer;
{
  int num = 0;
  struct sroom *temp;
  sprintf(sendbuf, ">> %s:  Rooms owned by %s:\r\n",CORE,name);
  sendtoplayer(pplayer,sendbuf);
  for(temp=proom;temp;temp=temp->next)
    if(!strcasecmp(temp->owner,name)) {
      num++;
      sprintf(sendbuf, "%s\r\n", temp->name);
      sendtoplayer(pplayer,sendbuf);
    }
  sprintf(sendbuf, ">> %d rooms found.\r\n",num);
  sendtoplayer(pplayer,sendbuf);
  return num;
}

int listmyfriends(name,pplayer)
     char *name;
     struct splayer *pplayer;
{
  int num = 0;
  struct sfriend *temp;
  sprintf(sendbuf, ">> %s:  Friends you have defined:\r\n",CORE);
  sendtoplayer(pplayer,sendbuf);
  for(temp=pfriend;temp;temp=temp->next)
    if(!strcasecmp(temp->name,name)) {
      num++;
      sprintf(sendbuf, "%s\r\n", temp->friend);
      printfriendinfo(pplayer, temp->friend);
    }
  sprintf(sendbuf, ">> %d friends found.\r\n",num);
  sendtoplayer(pplayer,sendbuf);
  return num;
}

int printfriendinfo(who, friend)
     struct splayer *who;
     char *friend;
{
  struct splayer *pplayer;
  struct rnames *temp;

  for(pplayer=players->next;pplayer;pplayer=pplayer->next) {
    if(!(strcasecmp(pplayer->name, friend))) {
      if (isplayer(who,HILITE)) sprintf(sendbuf, "[1m%s - logged in on line %d, idle %s[0m\r\n", friend, pplayer->s,idlet(pplayer->idle));
      if (!(isplayer(who,HILITE))) sprintf(sendbuf, "%s - logged in on line %d, idle %s\r\n", friend, pplayer->s,idlet(pplayer->idle));
      sendtoplayer(who ,sendbuf);
      return 0;
    }
  }
  for(temp=regname; temp; temp=temp->next) {
    if(!(strcasecmp(temp->name, friend))) {
      sprintf(sendbuf, "%s - last logged in %s\r\n", friend, temp->login);
      sendtoplayer(who, sendbuf);
      return 0;
    }
  }
  sprintf(sendbuf, "%s - not logged in.\r\n", friend);
  return 0;
}


int listfriendsofme(name,pplayer)
     char *name;
     struct splayer *pplayer;
{
  int num = 0;
  struct sfriend *temp;
  sprintf(sendbuf, ">> %s:  Users who have defined you as a friend:\r\n",CORE);
  sendtoplayer(pplayer,sendbuf);
  for(temp=pfriend;temp;temp=temp->next)
    if(!strcasecmp(temp->friend,name)) {
      num++;
      sprintf(sendbuf, "%s\r\n", temp->name);
      sendtoplayer(pplayer,sendbuf);
    }
  sprintf(sendbuf, ">> %d users found.\r\n",num);
  sendtoplayer(pplayer,sendbuf);
  return num;
}

int whosverbs(name,pplayer)
     char *name;
     struct splayer *pplayer;
{
  int num = 0;
  struct sverb *temp;
  sprintf(sendbuf, ">> %s:  Verbs owned by %s:\r\n",CORE,name);
  sendtoplayer(pplayer,sendbuf);
  for(temp=pverb;temp;temp=temp->next)
    if(!strcasecmp(temp->owner,name)) {
      num++;
      if(temp->perm == 'g') {
        sprintf(sendbuf, "@%s (global)\r\n", temp->verbname);
      } else {
        sprintf(sendbuf, "@%s (private)\r\n", temp->verbname);
      }
      sendtoplayer(pplayer,sendbuf);
    }
  sprintf(sendbuf, ">> %d verbs found.\r\n",num);
  sendtoplayer(pplayer,sendbuf);
  return num;
}



int listverbs(pplayer)
     struct splayer *pplayer;
{
  int lines = 0;
  int stopat;
  int num = 0;
  struct sverb *temp;
  

  if(pplayer->moretype == longverblist)
    stopat = pplayer->moreline + 20;
  else {
    stopat = 20;
    pplayer->moreline = 0;
  }

  for (temp=pverb; temp; temp=temp->next) {
    num++;
    if(temp->perm == '\0') {
      sprintf(sendbuf, ">> @%s (%s)\r\n",temp->verbname,temp->owner);
    } else if(temp->perm == 'g') {
      sprintf(sendbuf, ">> @%s (%s) - global\r\n",temp->verbname,temp->owner);
    } else {
      sprintf(sendbuf, ">> @%s (%s) - private\r\n",temp->verbname,temp->owner);
    }
    if(strcmp(temp->verbname, "dummy") && !strcasecmp(pplayer->name, temp->owner))
      if (lines <= stopat) {
	if (lines >= pplayer->moreline)
	  sendtoplayer(pplayer,sendbuf);
	lines++;
      } else {
	break;
      }
    else
      num--;

  }

  if(!temp) {
    sprintf(sendbuf, ">> %s:  %d verbs found.\r\n",CORE,num);
    sendtoplayer(pplayer,sendbuf);
    pplayer->moretype = none;
    pplayer->moreline = 0;
  } else {
    pplayer->moretype = longverblist;
    pplayer->moreline = lines;
    sendtoplayer(pplayer, "--- MORE --- Press return to continue:\r\n");
  }
  return 1;
}

int registered(name)
     char *name;
{
  struct rnames *temp;
  
  for (temp = regname; temp; temp=temp->next) {
    if(!strcmpi(name, temp->name))
      return 1;
  }
  return 0;
}

int checkregistry(pplayer)
     struct splayer *pplayer;
{
  struct rnames *temp;
  
  for (temp = regname; temp; temp=temp->next) {
    if(!strcmpi(pplayer->name, temp->name)) {
      if(!(isplayer2(pplayer, REGISTERED)))
	togplayer2(pplayer, REGISTERED);
      return 1;
    } 
  }
  if(isplayer2(pplayer, REGISTERED))
      togplayer2(pplayer, REGISTERED);
  return 0;
}


int isverb(name)
     char *name;
{
  struct sverb *temp;
  for (temp = pverb; temp; temp=temp->next) {
    if(!strcasecmp(name, temp->verbname))
      return 1;
  }
  return 0;
}

int isfriend(name, friend)
     char *name;
     char *friend;
{
  struct sfriend *temp;
  for (temp = pfriend; temp; temp=temp->next) {
    if((!strcasecmp(name, temp->name)) && (!strcasecmp(friend, temp->friend)))
      return 1;
  }
  return 0;
}

int isroom(name)
     char *name;
{
  struct sroom *temp;
  
  for (temp = proom; temp; temp=temp->next) {
    if(!strcmp(name, temp->name))
      return 1;
  }
  return 0;
}

int isobject(name)
     char *name;
{
  struct sobject *temp;
  
  for (temp = pobject; temp; temp=temp->next) {
    if(!strcasecmp(name, temp->name))
      return 1;
  }
  return 0;
}

int isaction(name)
     char *name;
{
  struct slink *temp;
  
  for (temp = plink; temp; temp=temp->next) {
    if(!strcasecmp(name, temp->name))
      return 1;
  }
  return 0;
}

int checkpasswd(name, passwd, tmp)
     char *name;
     char *passwd;
     struct splayer *tmp;
{
     struct rnames *temp;

     for(temp=regname; temp; temp=temp->next)
	if(!strcmpi(name, temp->name))
	      if(!strcmpi(passwd, temp->passwd)) {
		free(tmp->desc);
		free(tmp->useraddr);
		free(tmp->arrmesg);
		free(tmp->joinmesg);
		free(tmp->wandmesg);
		free(tmp->exitmesg);
		tmp->desc = allocmem(strlen(temp->desc));
		tmp->useraddr = allocmem(strlen(temp->useraddr));
		tmp->arrmesg = allocmem(strlen(temp->arrmesg));
		tmp->wandmesg = allocmem(strlen(temp->wandmesg));
		tmp->joinmesg = allocmem(strlen(temp->joinmesg));
		tmp->exitmesg = allocmem(strlen(temp->exitmesg));
		strcpy(tmp->desc, temp->desc);
		strcpy(tmp->useraddr, temp->useraddr);
		setuseraddr(tmp);
		strcpy(tmp->arrmesg, temp->arrmesg);
		strcpy(tmp->joinmesg, temp->joinmesg);
		strcpy(tmp->wandmesg, temp->wandmesg);
		strcpy(tmp->exitmesg, temp->exitmesg);
		strcpy(tmp->channel, temp->channel);
		tmp->gender = temp->gender;
		if((temp->flag[0] != '-') && (notplayer(tmp,ECHO)))
		  togplayer(tmp,ECHO);
		if((temp->flag[1] != '-') && (notplayer(tmp,TECHNO)))
		  togplayer(tmp,TECHNO);
		if(temp->flag[2] != '-')
		  tmp->wrap = 80;
		if((temp->flag[3] != '-') && (notplayer(tmp,HILITE)))
		  togplayer(tmp,HILITE);
		if((temp->flag[4] != '-') && (notplayer(tmp,BEEP)))
		  togplayer(tmp,BEEP);
		if((temp->flag[5] != '-') && (notplayer(tmp,NOMESG)))
		  togplayer(tmp,NOMESG);
		if((temp->flag[6] != '-') && (isplayer(tmp,TRAD)))
		  togplayer(tmp,TRAD);
		if((temp->flag[7] != '-') && (!isplayer2(tmp,TIME)))
		  togplayer2(tmp,TIME);
		if((temp->flag[8] != '-')) {
		  sprintf(sendbuf, "%c\0", temp->flag[8]); 
		  tmp->col = atoi(sendbuf)+30;
		}
		return 1;
	      }
              else
		return 0;
     return 0;
}

int makeplayer(pplayer, flag)
     struct splayer *pplayer;
     long flag;
{
  if(!isplayer(pplayer, flag))
    togplayer(pplayer, flag);
  return 0;
}



int unmakeplayer(pplayer, flag)
     struct splayer *pplayer;
     long flag;
{
  if(isplayer(pplayer, flag))
    togplayer(pplayer, flag);
  return 0;
}

int dochanop(pplayer)
     struct splayer *pplayer;
{
  if(isroom(pplayer->channel)) {
    if(isroomowner(pplayer->channel, pplayer->name)) {
      if(notplayer(pplayer, CHANOP)) togplayer(pplayer, CHANOP);	
    } else {
      if(isplayer(pplayer, CHANOP)) togplayer(pplayer, CHANOP); 
    }
  } else {
    if((onchannel(pplayer->channel) == 1) && strcmp(pplayer->channel, MAIN)) {
      if(notplayer(pplayer, CHANOP)) togplayer(pplayer, CHANOP);
    } else {
      if(isplayer(pplayer, CHANOP)) togplayer(pplayer, CHANOP);
    }
  }
}


char *strupr(item)
     char item[40];
{     
  int x;
  for (x=0; x<strlen(item); x++)
    item[x] = toupper(item[x]);
  return item;
}

int strcmpi(one, two)
     char *one;
     char *two;
{
    return (strcasecmp(one, two));
}

int showpasswds(pplayer)
     struct splayer *pplayer;
{
  struct rnames *temp;
  for (temp=regname; temp; temp=temp->next) {
    sprintf(sendbuf, "name: |%s|    passwd: |%s|\r\n",temp->name,temp->passwd);
    sendtoplayer(pplayer,sendbuf);
  }
  return 0;
}

int showcoreentry(pplayer, name)
     struct splayer *pplayer;
     char *name;
{
  struct rnames *temp;
  for (temp=regname; temp; temp=temp->next) {
    if(!(strcasecmp(temp->name, name))) {
      sprintf(sendbuf, ">> %s listing on: %s\r\n",CORE,temp->name);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Name:  %s\r\n",temp->name);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Password:  %s\r\n",temp->passwd);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Description:  %s - %s\r\n",temp->name, temp->desc);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Gender:  %c\r\n",temp->gender);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> (a) Arrival mesg:  %s\r\n",temp->arrmesg);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> (w) Exit channel mesg:  %s\r\n",temp->wandmesg);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> (j) Join channel mesg:  %s\r\n",temp->joinmesg);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> (e) Exit mesg:  %s\r\n",temp->exitmesg);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> (m) E-mail addr: %s\r\n",temp->useraddr);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Channel:  %s\r\n",temp->channel);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Last Login:  %s\r\n",temp->login);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Mail Messages:  %d\r\n",nummail(temp->name));
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Verbs Owned:  %d\r\n",numverb(temp->name));
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Rooms Owned:  %d\r\n",numroom(temp->name));
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Objects Owned:  %d\r\n",numobject(temp->name));
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> User Flags:  %s\r\n",temp->flag);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> e = echo, T = Technocolor, W = ScreenWrap, H = .p Hilite, b = beep\r\n");
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> C = Custom message suppress, X = Timestamps, S = Quoted says, color\r\n");
      sendtoplayer(pplayer,sendbuf);
    }
  }
return 0;
}

int showverb(pplayer, name)
     struct splayer *pplayer;
     char *name;
{
  struct sverb *temp;
  for (temp=pverb; temp; temp=temp->next) {
    if(!(strcasecmp(temp->verbname, name))) {
      sprintf(sendbuf, ">> %s listing on: @%s\r\n",CORE,temp->verbname);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Name:  @%s\r\n",temp->verbname);
      sendtoplayer(pplayer,sendbuf);
      if(temp->perm == 'g') {
        sprintf(sendbuf, ">> Permission:  %s\r\n","global");
      } else {
        sprintf(sendbuf, ">> Permission:  %s\r\n","private");
      }
      if (temp->perm != '\000') sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Owned by:  %s\r\n",temp->owner);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Verb:  %s\r\n",temp->verb);
      sendtoplayer(pplayer,sendbuf);
    }
  }
return 0;
}

int seeroom(pplayer, room)
     struct splayer *pplayer;
     char *room;
{
  struct sroom *temp;
  for(temp = proom; temp; temp=temp->next) {
    if(!strcmp(room, temp->name)) {
      sprintf(sendbuf, ">> Room name: %s  %s\r\n",temp->name, (temp->sanct) ? "[SANCT]" : "");
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Owner: %s\r\n",temp->owner);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Description: %s\r\n",temp->desc);
      sendtoplayer(pplayer,sendbuf);
      usersinchannel(pplayer, temp->name);
      channelobjects(pplayer, temp->name);
      sendtoplayer(pplayer, "POINTERS:\r\n");
      sprintf(sendbuf, ">> North: %s\r\n",temp->north);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> South: %s\r\n",temp->south);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> East: %s\r\n",temp->east);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> West: %s\r\n",temp->west);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Up: %s\r\n",temp->up);
      sendtoplayer(pplayer,sendbuf);
      sprintf(sendbuf, ">> Down: %s\r\n",temp->down);
      sendtoplayer(pplayer,sendbuf);
    }
  }
  return 0;
}


int doroom(pplayer)
     struct splayer *pplayer;
{
  struct sroom *temp;
 
  if(isplayer(pplayer, NOMESG)) return 0;

  for (temp=proom; temp; temp=temp->next) {
    if(!(strcmp(temp->name, pplayer->channel))) {
      sprintf(sendbuf, "*> (%sowned by %s) %s\r\n",(temp->sanct) ? " [SANCT] " : "", temp->owner,temp->desc);
      sendtoplayer(pplayer,sendbuf);
    }
  }
  channelobjects(pplayer, pplayer->channel);
  channelusers(pplayer);
  showexits(pplayer);
  return 0;
}


int doobject(pplayer)
     struct splayer *pplayer;
{
  struct sobject *temp;
 
  if(isplayer(pplayer, NOMESG)) return 0;

  for (temp=pobject; temp; temp=temp->next) {
    if(!(strcasecmp(temp->name, pplayer->object))) {
      sprintf(sendbuf, "*> %s (owned by %s) %s\r\n",temp->name,temp->owner,temp->desc);
      sendtoplayer(pplayer,sendbuf);
    }
  }
  objectsinobj(pplayer, pplayer->object);
  usersinobj(pplayer);
  return 0;
}


int checkhour()
{
  char *mtime;
  char *htime;
  char *xtime;
  time_t now = time(0);
  
  mtime = ctime(&now) + 14;
  htime = ctime(&now) +11;
  htime[2] = '\0';

  mtime[2] = '\0';

    xtime = ctime(&now) + 11;
    xtime[5] = '\0';

  if (((!(strcmp(mtime, "15"))) || (!(strcmp(mtime, "45")))) && ((strcmp(lastcheckhour, htime)))) {
    sprintf(sendbuf, ">> %s%s%s\r\n",TIME1A,xtime,TIME1B);
    sendall(sendbuf, "*", 0, MESS);
    sprintf(sendbuf, "[SYSLOG:  %s updated- %s]\r\n", CORE,xtime);
    sendall(sendbuf, "*", SYSLOG2, 0);
    savecore();
    saveverb();
    savefriend();
    savemail();  
    strcpy(lastcheckhour, htime);
    connectlasthr = connectthishr;
    connectthishr = 0;
    numhours++;
    /* hourly update of database */
    /*strcpy(voting, "\0");*/
 }
  if (((!(strcmp(mtime, "00"))) || (!(strcmp(mtime, "30")))) && ((strcmp(lastcheckhour, htime)))) {
    sprintf(sendbuf, ">> %s%s%s\r\n",TIME1A,xtime,TIME1B);
    sendall(sendbuf, "*", 0, MESS);
    sprintf(sendbuf, "[SYSLOG:  %s updated- %s]\r\n", CORE,xtime);
    sendall(sendbuf, "*", SYSLOG2, 0);
    savecore();
    savemess();
    savemess2();
    savemess3();
    savemess4();
    saveobject();
    saveaction();
    saveroom();
    savefriend();
    savemail();
    strcpy(lastcheckhour, htime);
    connectlasthr = connectthishr;
    connectthishr = 0;
    numhours++;
    /* hourly update of database */
    /*strcpy(voting, "\0");*/
 }
  return 0;
}

int changepasswd(name, passwd, desc, chan, flag, pplayer)
     char *name;
     char *passwd;
     char *desc;
     char *chan;
     char *flag;
     struct splayer *pplayer;
{
  int count;
  struct rnames *temp;
  for (temp=regname; temp; temp=temp->next) {
    if(!(strcasecmp(name,temp->name))) {
      count = strlen(passwd) -1;
      while (isspace(passwd[count])) {
	passwd[count] = '\0';
	count--;
      }
      strncpy(temp->passwd, passwd, 40);
      free(temp->desc);
      free(temp->arrmesg);
      free(temp->wandmesg);
      free(temp->joinmesg);
      free(temp->exitmesg);
      free(temp->useraddr);
      temp->desc = allocmem(strlen(desc));
      strcpy(temp->desc, desc);
      temp->arrmesg = allocmem(strlen(pplayer->arrmesg));
      temp->wandmesg = allocmem(strlen(pplayer->wandmesg));
      temp->joinmesg = allocmem(strlen(pplayer->joinmesg));
      temp->exitmesg = allocmem(strlen(pplayer->exitmesg));
      temp->useraddr = allocmem(strlen(pplayer->useraddr));
      strcpy(temp->arrmesg, pplayer->arrmesg);
      strcpy(temp->wandmesg, pplayer->wandmesg);
      strcpy(temp->joinmesg, pplayer->joinmesg);
      strcpy(temp->useraddr, pplayer->useraddr);
      strcpy(temp->exitmesg, pplayer->exitmesg);
      temp->gender = pplayer->gender;
      if((issanct(pplayer, chan))) 
         strncpy(temp->channel, MAIN, 14);
      else
         strncpy(temp->channel, chan, 14);
      strncpy(temp->flag, flag, 15);
    }
  }
  checkregistry(pplayer);
  if (1 == -1)
    return -1;
    return 0;
}

int makeverbglobal(verb)
     char *verb;
{
  struct sverb *temp;
  for(temp=pverb; temp; temp=temp->next)
    if (!strcasecmp(verb, temp->verbname))
      temp->perm = 'g';
  return 1;
}


int makeverbprivate(verb)
     char *verb;
{
  struct sverb *temp;
  for(temp=pverb; temp; temp=temp->next)
    if (!strcasecmp(verb, temp->verbname))
      temp->perm = 'p';
  return 1;
}


int changeverb(pplayer, name, text)
     char *name;
     char *text;
     struct splayer *pplayer;
{
  int count;
  struct sverb *temp;
  for (temp=pverb; temp; temp=temp->next) {
    if(!(strcasecmp(name,temp->verbname))) {
      if(!(strcasecmp(pplayer->name, temp->owner))) {
	count = strlen(text) -1;
	while (isspace(text[count])) {
	  text[count] = '\0';
	  count--;
	}
        free(temp->verb);
        temp->verb=allocmem(strlen(text));
	strcpy(temp->verb, text);
      } else {
	sprintf(sendbuf, ">> %s:  You do not own verb %s.  Ask %s if you wish to change this verb.\r\n",CORE, temp->verbname, temp->owner);
	sendtoplayer(pplayer,sendbuf);
	return -1;
      }
    }
  }
  return 0;
}

int changeroom(pplayer, name, text)
     char *name;
     char *text;
     struct splayer *pplayer;
{
  int count;
  struct sroom *temp;
  for (temp=proom; temp; temp=temp->next) {
    if(!(strcmp(name,temp->name))) {
      if(!(strcasecmp(pplayer->name, temp->owner))) {
	count = strlen(text) -1;
	while (isspace(text[count])) {
	  text[count] = '\0';
	  count--;
	}
        free(temp->desc);
        temp->desc = allocmem(strlen(text));
	strcpy(temp->desc, text);
      } else {
	sprintf(sendbuf, ">> %s:  You do not own room %s.  Ask %s if you wish to change the description.\r\n",CORE, temp->name, temp->owner);
	sendtoplayer(pplayer,sendbuf);
	return -1;
      }
    }
  }
  return 0;
}

int changeobject(pplayer, name, text)
     char *name;
     char *text;
     struct splayer *pplayer;
{
  int count;
  struct sobject *temp;
  for (temp=pobject; temp; temp=temp->next) {
    if(!(strcasecmp(name,temp->name))) {
      if(!(strcasecmp(pplayer->name, temp->owner))) {
	count = strlen(text) -1;
	while (isspace(text[count])) {
	  text[count] = '\0';
	  count--;
	}
        free(temp->desc);
        temp->desc = allocmem(strlen(text));
	strcpy(temp->desc, text);
      } else {
	sprintf(sendbuf, ">> %s:  You do not own object %s.  Ask %s if you wish to change the description.\r\n",CORE,temp->name, temp->owner);
	sendtoplayer(pplayer,sendbuf);
	return -1;
      }
    }
  }
  return 0;
}

int changeaction(pplayer, name, text)
     char *name;
     char *text;
     struct splayer *pplayer;
{
  int count;
  struct slink *temp;
  for (temp=plink; temp; temp=temp->next) {
    if(!(strcasecmp(name,temp->name))) {
      if(!(strcasecmp(pplayer->name, temp->owner))) {
	count = strlen(text) -1;
	while (isspace(text[count])) {
	  text[count] = '\0';
	  count--;
	}
        free(temp->verb);
        temp->verb = allocmem(strlen(text));
	strcpy(temp->verb, text);
      } else {
	sprintf(sendbuf, ">> %s:  You do not own action %s.  Ask %s if you wish to change the verb.\r\n", CORE,temp->name, temp->owner);
	sendtoplayer(pplayer,sendbuf);
	return -1;
      }
    }
  }
  return 0;
}

int setroom(pplayer, text)
     struct splayer *pplayer;
     char *text;
{
  if(!registered(pplayer->name)) {
    sprintf(sendbuf, ">> %s:  You must be registered in order to use this function.\r\n",CORE);
    sendtoplayer(pplayer,sendbuf);
  } else if(pplayer->channel == MAIN) {
    sprintf(sendbuf, ">> %s:  You can not use this function on the main channel.\r\n",CORE);
    sendtoplayer(pplayer,sendbuf);
  } else if(text[0] == '\0') {
    if(isroom(pplayer->channel)) {
      if(isroomowner(pplayer->channel, pplayer->name) || (pplayer->seclevel == SUPREME)) {
	eraseroom(pplayer->channel);
        sprintf(sendbuf, "[SYSLOG:  Room %s deleted by %s]\r\n", pplayer->channel, pplayer->name);
        sendall(sendbuf, "*", SYSLOG, 0);

	if (1 == -1) {
	  sprintf(sendbuf, ">> %s:  Room deletion failed.\r\n",CORE);
	  sendtoplayer(pplayer,sendbuf);
	} else {
	  sprintf(sendbuf, ">> %s:  Channel %s deleted as a room.\r\n",CORE,pplayer->channel);
	  sendtoplayer(pplayer, sendbuf);
	}
      } else {
	sprintf(sendbuf, ">> %s:  You do not own this room.\r\n",CORE);
	sendtoplayer(pplayer, sendbuf);
      }
    } else {
      sprintf(sendbuf, ">> %s:  This channel does not have room status.\r\n",CORE);
      sendtoplayer(pplayer,sendbuf);
    }
  } else {
    if (isroom(pplayer->channel)) {
      if(changeroom(pplayer, pplayer->channel, text) == -1) return -1;
    } else {
      if(isoverquota(pplayer->name) && (pplayer->seclevel != SUPREME)) {
	sprintf(sendbuf, ">> %s:  You are at or over quota.  Please delete one of your objects, rooms, or verbs before you build any more.\r\n",CORE);
	sendtoplayer(pplayer,sendbuf);
	return -1;
      } else 
        addroom(pplayer, pplayer->channel, text);
    }
    sprintf(sendbuf, "[SYSLOG:  Room %s created/altered by %s]\r\n", pplayer->channel, pplayer->name);
    sendall(sendbuf, "*", SYSLOG, 0);

    if (1 == -1) {
      sprintf(sendbuf, ">> %s:  Room addition/modification failed.\r\n",CORE);
      sendtoplayer(pplayer,sendbuf);
    } else {
      sprintf(sendbuf, ">> %s:  Room added/modified.\r\n",CORE);
      sendtoplayer(pplayer,sendbuf);
    }
  }
}


int regdefaultname(name)
     char *name;
{
  int count;
  struct rnames *temp;
  temp = regname;
  while(temp->next != (struct rnames *)0) temp=temp->next;
  temp->next = (struct rnames *)malloc(sizeof(struct rnames));
  if(temp->next == (struct rnames *)0) return -1;

  temp=temp->next;
  temp->next = (struct rnames *)0;
  strncpy(temp->name, name, 40);
  strcpy(temp->passwd, "temp69");
  temp->desc = allocmem(2);
  strcpy(temp->desc, "\0");
  temp->arrmesg = allocmem(2);
  temp->wandmesg = allocmem(2);
  temp->joinmesg = allocmem(2);
  temp->exitmesg = allocmem(2);
  temp->useraddr = allocmem(2);
  strcpy(temp->arrmesg, "\0");
  strcpy(temp->wandmesg, "\0");
  strcpy(temp->joinmesg, "\0");
  strcpy(temp->useraddr, "\0");
  strcpy(temp->exitmesg, "\0");
  temp->gender = 'n';
  strcpy(temp->login, "OpReserved");
  strncpy(temp->channel, MAIN, 14);
  strcpy(temp->flag, "---------");
  return 0;
}


int regnewname(name, passwd, desc, chan, flag,pplayer)
     char *name;
     char *passwd;
     char *desc;
     char *chan;
     char *flag;
     struct splayer *pplayer;
{
  int count;
  struct rnames *temp;
  temp = regname;
  while(temp->next != (struct rnames *)0) temp=temp->next;
  temp->next = (struct rnames *)malloc(sizeof(struct rnames));
  if(temp->next == (struct rnames *)0) return -1;

  count = strlen(passwd)-1;
  while(isspace(passwd[count])) {
    passwd[count] = '\0';
    count --;
  }
  temp=temp->next;
  temp->next = (struct rnames *)0;
  strncpy(temp->name, name, 40);
  strncpy(temp->passwd, passwd, 40);
  temp->passwd[39] = '\0';
  temp->desc = allocmem(strlen(desc));
  strcpy(temp->desc, desc);
  temp->arrmesg = allocmem(strlen(pplayer->arrmesg));
  temp->wandmesg = allocmem(strlen(pplayer->wandmesg));
  temp->joinmesg = allocmem(strlen(pplayer->joinmesg));
  temp->exitmesg = allocmem(strlen(pplayer->exitmesg));
  temp->useraddr = allocmem(strlen(pplayer->useraddr));
  strcpy(temp->arrmesg, pplayer->arrmesg);
  strcpy(temp->wandmesg, pplayer->wandmesg);
  strcpy(temp->joinmesg, pplayer->joinmesg);
  strcpy(temp->useraddr, pplayer->useraddr);
  strcpy(temp->exitmesg, pplayer->exitmesg);
  temp->gender = pplayer->gender;
  strcpy(temp->login, "???");
  if((issanct(pplayer, chan))) 
     strncpy(temp->channel, MAIN, 14);
  else
     strncpy(temp->channel, chan, 14);
  strcpy(temp->flag, flag);
  checkregistry(pplayer);
  return 0;
}


int addverb(pplayer, name, text)
     char *name;
     char *text;
     struct splayer *pplayer;
{
  int count;
  struct sverb *temp;
  temp = pverb;
  while(temp->next != (struct sverb *)0) temp=temp->next;
  temp->next = (struct sverb *)malloc(sizeof(struct sverb));
  if(temp->next == (struct sverb *)0) return -1;

  count = strlen(text)-1;
  while(isspace(text[count])) {
    text[count] = '\0';
    count --;
  }
  temp=temp->next;
  temp->next = (struct sverb *)0;
  strncpy(temp->verbname, name, 40);
  temp->verbname[39] = '\0';
  temp->verb = allocmem(strlen(text));
  strcpy(temp->verb, text);
  temp->perm = 'p';
  strncpy(temp->owner, pplayer->name, 40);
  return 0;
}


int addfriend(name, friend)
     char *name;
     char *friend;
{
  int count;
  struct sfriend *temp;
  temp = pfriend;

  count = strlen(friend)-1;
  while(isspace(friend[count])) {
    friend[count] = '\0';
    count --;
  }

  if (temp != (struct sfriend *)0) {
    while(temp->next != (struct sfriend *)0)
      temp=temp->next;
    temp->next = (struct sfriend *)malloc(sizeof(struct sfriend));
    if(temp->next == (struct sfriend *)0) return -1;

    temp=temp->next;
    temp->next = (struct sfriend *)0;
    strncpy(temp->name, name, 40);
    strncpy(temp->friend, friend, 40);
    temp->name[39] = '\0';
    temp->friend[39] = '\0';
    return 0;
  } else {
    return -1;
  }
}

int addlockout(text)
     char *text;
{
  int count;
  struct hostlist *temp;
  temp = rlist;

  count = strlen(text)-1;
  while(isspace(text[count])) {
    text[count] = '\0';
    count --;
  }

  if (temp != (struct hostlist *)0) {
    while(temp->next != (struct hostlist *)0)
      temp=temp->next;
    temp->next = (struct hostlist *)malloc(sizeof(struct hostlist));
    if(temp->next == (struct hostlist *)0) return -1;

    temp=temp->next;
    temp->next = (struct hostlist *)0;
    strncpy(temp->name, text, 40);
    temp->name[39] = '\0';
    return 0;
  } else {
    temp = (struct hostlist *)malloc(sizeof(struct hostlist));
    strncpy(temp->name, text, 40);
    temp->name[39] = '\0';
    temp->next = (struct hostlist *)0;
    rlist = temp;
  }
}


int addbanned(text)
     char *text;
{
  int count;
  struct banlist *temp;
  temp = blist;

  count = strlen(text)-1;
  while(isspace(text[count])) {
    text[count] = '\0';
    count --;
  }

  if (temp != (struct banlist *)0) {
    while(temp->next != (struct banlist *)0)
      temp=temp->next;
    temp->next = (struct banlist *)malloc(sizeof(struct banlist));
    if(temp->next == (struct banlist *)0) return -1;

    temp=temp->next;
    temp->next = (struct banlist *)0;
    strncpy(temp->name, text, 40);
    temp->name[39] = '\0';
    return 0;
  } else {
    temp = (struct banlist *)malloc(sizeof(struct banlist));
    strncpy(temp->name, text, 40);
    temp->name[39] = '\0';
    temp->next = (struct banlist *)0;
    blist = temp;
  }
}

int addlewd(text)
     char *text;
{
  int count;
  struct lewdlist *temp;
  temp = nlist;

  count = strlen(text)-1;
  while(isspace(text[count])) {
    text[count] = '\0';
    count --;
  }

  if (temp != (struct lewdlist *)0) {
    while(temp->next != (struct lewdlist *)0)
      temp=temp->next;
    temp->next = (struct lewdlist *)malloc(sizeof(struct lewdlist));
    if(temp->next == (struct lewdlist *)0) return -1;

    temp=temp->next;
    temp->next = (struct lewdlist *)0;
    strncpy(temp->name, text, 40);
    temp->name[39] = '\0';
    return 0;
  } else {
    temp = (struct lewdlist *)malloc(sizeof(struct lewdlist));
    strncpy(temp->name, text, 40);
    temp->name[39] = '\0';
    temp->next = (struct lewdlist *)0;
    nlist = temp;
  }
}



int addroom(pplayer, name, text)
     char *name;
     char *text;
     struct splayer *pplayer;
{
  int count;
  struct sroom *temp;
  temp = proom;
  while(temp->next != (struct sroom *)0) temp=temp->next;
  temp->next = (struct sroom *)malloc(sizeof(struct sroom));
  if(temp->next == (struct sroom *)0) return -1;

  count = strlen(text)-1;
  while(isspace(text[count])) {
    text[count] = '\0';
    count --;
  }
  temp=temp->next;
  temp->next = (struct sroom *)0;
  strncpy(temp->name, name, 40);
  temp->desc = allocmem(strlen(text));
  temp->sanct = 0;
  strcpy(temp->desc, text);
  strncpy(temp->owner, pplayer->name, 40);
  strcpy(temp->north, "\0");
  strcpy(temp->south, "\0");
  strcpy(temp->east, "\0");
  strcpy(temp->west, "\0");
  strcpy(temp->up, "\0");
  strcpy(temp->down, "\0");
 
  return 0;
}


int makeobject(pplayer, name, text)
     char *name;
     char *text;
     struct splayer *pplayer;
{
  int count;
  struct sobject *temp;
  temp = pobject;
  while(temp->next != (struct sobject *)0) temp=temp->next;
  temp->next = (struct sobject *)malloc(sizeof(struct sobject));
  if(temp->next == (struct sobject *)0) return -1;

  count = strlen(text)-1;
  while(isspace(text[count])) {
    text[count] = '\0';
    count --;
  }
  temp=temp->next;
  temp->next = (struct sobject *)0;
  strncpy(temp->name, name, 40);
  temp->name[39] = '\0';
  temp->desc = allocmem(strlen(text));
  strcpy(temp->desc, text);
  strncpy(temp->owner, pplayer->name, 40);
  temp->c_type = 'p';
  temp->cont_perm = 'e';
  strncpy(temp->cont, pplayer->name, 40);
  temp->inmesg = allocmem(1);
  temp->inmesg[0] = '\0';
  temp->outmesg = allocmem(1);
  temp->outmesg[0] = '\0';
  return 0;
}

int makelink(pplayer, name, text)
     char *name;
     char *text;
     struct splayer *pplayer;
{
  int count;
  struct slink *temp;
  temp = plink;
  while(temp->next != (struct slink *)0) temp=temp->next;
  temp->next = (struct slink *)malloc(sizeof(struct slink));
  if(temp->next == (struct slink *)0) return -1;

  count = strlen(text)-1;
  while(isspace(text[count])) {
    text[count] = '\0';
    count --;
  }
  temp=temp->next;
  temp->next = (struct slink *)0;
  strncpy(temp->name, name, 40);
  temp->name[39] = '\0';
  strncpy(temp->object, text, 40);
  strncpy(temp->owner, pplayer->name, 40);
  temp->verb = allocmem(1);
  strcpy(temp->verb, "\0");
  return 0;
}

int saveremwho()
{
  int fp;
  FILE *file;
  struct splayer *buf;
  int num = 0;

  if((file = fopen("hotel.who" , "w")) == NULL) return -1;

  sprintf(sendbuf, "------- %s: Current Logins -------\r\n\r\n", NAME);
  fputs(sendbuf, file);

  sprintf(sendbuf, "%-6s%-21s%-9s%-11s%-28s\r\n","Line","Name","Idle  ","Channel","On From");
  fputs(sendbuf, file);

  buf = players;
  while(buf->next != (struct splayer *)0) {
    buf = buf->next;
    sprintf(sendbuf, "%4d  %-20s %-8s %-10s %-28s \r\n",buf->s,buf->name,idlet(buf->idle),buf->channel,buf->onfrom);
    fputs(sendbuf, file);
    num++;
  }
  sprintf(sendbuf, "     %d connection(s).\r\n",num);
  fputs(sendbuf, file);

  fclose(file);

  return 0;
}


int savecore()
{
  int fp;
  FILE *file;
  struct rnames *temp;
  
   if((file = fopen("hotel.registry" , "w")) == NULL) return -1;
 
  for (temp = regname; temp; temp=temp->next) {
    if(strcmp(temp->name, NEWCONN)) {
      sprintf(sendbuf, "%s\n", temp->name);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->passwd);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->desc);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->arrmesg);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->wandmesg);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->joinmesg);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->useraddr);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->exitmesg);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%c\n", temp->gender);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->login);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->channel);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->flag);
      fputs(sendbuf, file);
    }
   }
  sprintf(sendbuf, "%s\n",NEWCONN);
  fputs(sendbuf, file);
  sprintf(sendbuf, "%s\n",LEVEL_0);
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);

  sprintf(sendbuf, "\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "n\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "---\n");
  fputs(sendbuf, file);

  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "---------\n");
  fputs(sendbuf, file);
  
  fclose(file);
  
  return 0;
}

int savemail()
{
  int fp;
  FILE *file;
  struct smail *temp;
  
   if((file = fopen("hotel.mail" , "w")) == NULL) return -1;
 
  for (temp = zmail; temp; temp=temp->next) {
    if(strcmp(temp->name, " XX")) {
      sprintf(sendbuf, "%s\n", temp->name);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->from);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->when);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->mess);
      fputs(sendbuf, file);
    }
  }
  sprintf(sendbuf, " XX\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, " XX\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  fclose(file);
  
  return 0;
}

int saveverb()
{
  int fp;
  FILE *file;
  struct sverb *temp;
  
   if((file = fopen("hotel.verbs" , "w")) == NULL) return -1;
 
  for (temp = pverb; temp; temp=temp->next) {
    if(strcmp(temp->verbname, "dummy")) {
      sprintf(sendbuf, "%s\n", temp->verbname);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->owner);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->verb);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%c\n", temp->perm);
      fputs(sendbuf, file);
    }
  }
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, " XX\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  fclose(file);
  
  return 0;
}

int savefriend()
{
  int fp;
  FILE *file;
  struct sfriend *temp;
  
  if((file = fopen("hotel.friend" , "w")) == NULL) return -1;
 
  for (temp = pfriend; temp; temp=temp->next) {
    if(strcmp(temp->name, " XX")) {
      sprintf(sendbuf, "%s\n", temp->name);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->friend);
      fputs(sendbuf, file);
    }
  }
  sprintf(sendbuf, " XX\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, " XX\n");
  fputs(sendbuf, file);
  fclose(file);
  
  return 0;
}

int savelockout()
{
  int fp;
  FILE *file;
  struct hostlist *temp;
  
  if((file = fopen(".lockout" , "w")) == NULL) {
    return -1;
  }
 
  for (temp = rlist; temp; temp=temp->next) {
    sprintf(sendbuf, "%s\n", temp->name);
    fputs(sendbuf, file);
  }
  fclose(file);
  return 0;
}

int savebanned()
{
  int fp;
  FILE *file;
  struct banlist *temp;
  
  if((file = fopen(".ban" , "w")) == NULL) return -1;
 
  for (temp = blist; temp; temp=temp->next) {
    sprintf(sendbuf, "%s\n", temp->name);
    fputs(sendbuf, file);
  }
  fclose(file);
  return 0;
}

int savelewd()
{
  int fp;
  FILE *file;
  struct lewdlist *temp;
  
  if((file = fopen(".lewd" , "w")) == NULL) return -1;
 
  for (temp = nlist; temp; temp=temp->next) {
    sprintf(sendbuf, "%s\n", temp->name);
    fputs(sendbuf, file);
  }
  fclose(file);
  return 0;
}

int saveroom()
{
  int fp;
  FILE *file;
  struct sroom *temp;
  
  if((file = fopen("hotel.rooms" , "w")) == NULL) return -1;
 
  for (temp = proom; temp; temp=temp->next) {
    if(strcmp(temp->name, MAIN)) {
      sprintf(sendbuf, "%s%s\n", (temp->sanct) ? "*" : "", temp->name);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->owner);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->desc);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->north);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->south);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->east);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->west);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->up);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->down);
      fputs(sendbuf, file);
    }
  }
  sprintf(sendbuf, "%s\n",MAIN);
  fputs(sendbuf, file);
  sprintf(sendbuf, "%s\n",MAIN_OWNER);
  fputs(sendbuf, file);
  sprintf(sendbuf, "%s\n", MAIN_DESC);
  fputs(sendbuf, file);
  sprintf(sendbuf, "%s\n",MAIN_N);
  fputs(sendbuf, file);
  sprintf(sendbuf, "%s\n",MAIN_S);
  fputs(sendbuf, file);
  sprintf(sendbuf, "%s\n",MAIN_E);
  fputs(sendbuf, file);
  sprintf(sendbuf, "%s\n",MAIN_W);
  fputs(sendbuf, file);
  sprintf(sendbuf, "%s\n",MAIN_U);
  fputs(sendbuf, file);
  sprintf(sendbuf, "%s\n",MAIN_D);
  fputs(sendbuf, file);
  fclose(file);
  return 0;
}

int saveobject()
{
  int fp;
  FILE *file;
  struct sobject *temp;
  
   if((file = fopen("hotel.objects" , "w")) == NULL) return -1;
 
  for (temp = pobject; temp; temp=temp->next) {
    if(strcmp(temp->name, " XX")) {
      sprintf(sendbuf, "%s\n", temp->name);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->owner);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->desc);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%c\n", temp->c_type);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->cont);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%c\n", temp->cont_perm);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->inmesg);
      fputs(sendbuf,file);
      sprintf(sendbuf, "%s\n", temp->outmesg);
      fputs(sendbuf, file);
    }
  }
  sprintf(sendbuf, " XX\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, " XX\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  fclose(file);
  return 0;
}

int saveaction()
{
  int fp;
  FILE *file;
  struct slink *temp;
  
   if((file = fopen("hotel.actions" , "w")) == NULL) return -1;
 
  for (temp = plink; temp; temp=temp->next) {
    if(strcmp(temp->name, " XX")) {
      sprintf(sendbuf, "%s\n", temp->name);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->owner);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->verb);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%s\n", temp->object);
      fputs(sendbuf, file);
    }
  }
  sprintf(sendbuf, " XX\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, " XX\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  sprintf(sendbuf, "dummy\n");
  fputs(sendbuf, file);
  fclose(file);
  return 0;
}

int savemess()
{
  int fp;
  FILE *file;
  int count = 1;
  
   if((file = fopen("hotel.mess" , "w")) == NULL) return -1;
 
  while(bboard[count][0] != '\0') {
      sprintf(sendbuf, "%s\n", bboard[count]);
      fputs(sendbuf, file);
      count ++;
  }
  fclose(file);
  return 0;
}

int savescore()
{
  int fp;
  FILE *file;
  int count = 1;
  
   if((file = fopen("hotel.equus.scores" , "w")) == NULL) return -1;
 
  while(hiname[count][0] != '\0') {
      sprintf(sendbuf, "%s\n", hiname[count]);
      fputs(sendbuf, file);
      sprintf(sendbuf, "%d\n",hiscore[count]);
      fputs(sendbuf, file);
      count ++;
  }
  fclose(file);
  return 0;
}

int listmess(pplayer, nummesg)
     struct splayer *pplayer;
{
  int count = 1;
  if (nummesg == -1) {
    while (bboard[count][0] != '\0') {
      sprintf(sendbuf, "%d: %s\r\n", count, bboard[count]);
      sendtoplayer(pplayer,sendbuf);
      count ++;
    }
  } else {
    if(nummesg > 100) {
      sendtoplayer(pplayer, ">> Illegal message number.\r\n");
    } else if ((bboard[nummesg][0] == '\0') && (nummesg > 90)) {
    } else if ((bboard[nummesg][0] == '\0') && (nummesg < 90)) {
      sendtoplayer(pplayer, ">> Illegal message number.\r\n");
    } else if (bboard[nummesg][0] == '\0') {
      sendtoplayer(pplayer, ">> Illegal message number.\r\n");
    } else {
      sprintf(sendbuf, "%d: %s\r\n", nummesg, bboard[nummesg]);
      sendtoplayer(pplayer,sendbuf);
    }
  }
return 0;
}

int listscore(pplayer, num)
     int num;
     struct splayer *pplayer;
{
  int count = 1;
  while ((hiname[count][0] != '\0') && (count != num)) {
    sprintf(sendbuf, "%3d     %-21s   %-4d\r\n", count, hiname[count], hiscore[count]);
    sendtoplayer(pplayer,sendbuf);
    count ++;
  }
return 0;
}

int wipemess(pplayer, num)
     struct splayer *pplayer;
     int num;
{
  int count;
  for (count = num+1; count < 101; count++) {
    strcpy(bboard[count-1], bboard[count]);
  }
  bboard[100][0] = '\0';
  sprintf(sendbuf, ">> %s:  Message %d erased from board.\r\n",CORE,num);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "[SYSLOG:  Bulletin Board post number %d erased by %s]\r\n", num, pplayer->name);
  sendall(sendbuf, "*", SYSLOG2, 0);
}

int postmess(pplayer, mess)       /* Altered */
     struct splayer *pplayer;     /* Altered */
     char *mess;
{
  int count = 1;
  int temp = 2;
 
  sprintf(sendbuf, "From %s: %s", pplayer->name, mess);
  for(count=1; count<=100; count++) {
    if(!strcmp(bboard[count], sendbuf)) {
       sprintf(sendbuf, ">> %s: Hehehe, Nice try Spammer!\r\n", CORE);
       sendtoplayer(pplayer,sendbuf);
       sprintf(sendbuf, "[SYSLOG:  %s tried to spam the Bulletin Board.]\r\n", pplayer->name);
       sendall(sendbuf, "*", SYSLOG2, 0);
       return 0;
    }
  }
 
  if (bboard[100][0] != '\0') {   /* This is 30 now */
    while(temp != 101) {
      strcpy(bboard[temp-1],bboard[temp]);
      temp++;
    }
    bboard[100][0] = '\0';   /* This is 30 now */
  }
 
  count = 1;
  while(bboard[count][0] != '\0') count++;
 
  strcpy(bboard[count], sendbuf);
  bboard[count+1][0] = '\0';
 
  sprintf(sendbuf, "[SYSLOG:  Bulletin Board post by %s]\r\n", pplayer->name);
  sendall(sendbuf, "*", SYSLOG2, 0);
  savemess();
  return 0;
}

/* New Boards */
 int listmess2(pplayer, nummesg)
     struct splayer *pplayer;
{
  int count = 1;
  if (nummesg == -1) {
    while (bboard2[count][0] != '\0') {
      sprintf(sendbuf, "%d: %s\r\n", count, bboard2[count]);
      sendtoplayer(pplayer,sendbuf);
      count ++;
    }
  } else {
    if(nummesg > 20) {
      sendtoplayer(pplayer, ">> Illegal message number.\r\n");
    } else if (bboard2[nummesg][0] == '\0') {
      sendtoplayer(pplayer, ">> Illegal message number.\r\n");
    } else {
      sprintf(sendbuf, "%d: %s\r\n", nummesg, bboard2[nummesg]);
      sendtoplayer(pplayer,sendbuf);
    }
  }
return 0;
}

 int listmess3(pplayer, nummesg)
     struct splayer *pplayer;
{
  int count = 1;
  if (nummesg == -1) {
    while (bboard3[count][0] != '\0') {
      sprintf(sendbuf, "%d: %s\r\n", count, bboard3[count]);
      sendtoplayer(pplayer,sendbuf);
      count ++;
    }
  } else {
    if(nummesg > 20) {
      sendtoplayer(pplayer, ">> Illegal message number.\r\n");
    } else if (bboard3[nummesg][0] == '\0') {
      sendtoplayer(pplayer, ">> Illegal message number.\r\n");
    } else {
      sprintf(sendbuf, "%d: %s\r\n", nummesg, bboard3[nummesg]);
      sendtoplayer(pplayer,sendbuf);
    }
  }
return 0;
}
  
int listmess4(pplayer, nummesg)
     struct splayer *pplayer;
{
  int count = 1;
  if (nummesg == -1) {
    while (bboard4[count][0] != '\0') {
      sprintf(sendbuf, "%d: %s\r\n", count, bboard4[count]);
      sendtoplayer(pplayer,sendbuf);
      count ++;
    }
  } else {
    if(nummesg > 20) {
      sendtoplayer(pplayer, ">> Illegal message number.\r\n");
    } else if (bboard4[nummesg][0] == '\0') {
      sendtoplayer(pplayer, ">> Illegal message number.\r\n");
    } else {
      sprintf(sendbuf, "%d: %s\r\n", nummesg, bboard4[nummesg]);
      sendtoplayer(pplayer,sendbuf);
    }
  }
return 0;
}
 

int postmess2(pplayer, mess)       /* Altered */
     struct splayer *pplayer;     /* Altered */
     char *mess;
{
  int count = 1;
  int temp = 2;
 
  sprintf(sendbuf, "From %s: %s", pplayer->name, mess);
  if (bboard2[20][0] != '\0') {   /* This is 30 now */
    while(temp != 21) {
      strcpy(bboard2[temp-1],bboard2[temp]);
      temp++;
    }
    bboard2[20][0] = '\0';   /* This is 30 now */
  }
 
  count = 1;
  while(bboard2[count][0] != '\0') count++;
 
  strcpy(bboard2[count], sendbuf);
  bboard2[count+1][0] = '\0';
  sendwizardsmesg(pplayer, "[I just posted to the Op board!]");
  savemess2();
  return 0;
}
 
int postmess3(pplayer, mess)       /* Altered */
     struct splayer *pplayer;     /* Altered */
     char *mess;
{
  int count = 1;
  int temp = 2;
 
  sprintf(sendbuf, "From %s: %s", pplayer->name, mess);
  if (bboard3[20][0] != '\0') {   /* This is 30 now */
    while(temp != 21) {
      strcpy(bboard3[temp-1],bboard3[temp]);
      temp++;
    }
    bboard3[20][0] = '\0';   /* This is 30 now */
  }
 
  count = 1;
  while(bboard3[count][0] != '\0') count++;
 
  strcpy(bboard3[count], sendbuf);
  bboard3[count+1][0] = '\0';
 
  savemess3();
  return 0;
}

int postmess4(pplayer, mess)       /* Altered */
     struct splayer *pplayer;     /* Altered */
     char *mess;
{
  int count = 1;
  int temp = 2;

  sprintf(sendbuf, "From %s: %s", pplayer->name, mess);
  if (bboard4[20][0] != '\0') {   /* This is 30 now */
    while(temp != 21) {
      strcpy(bboard3[temp-1],bboard3[temp]);
      temp++;
    }
    bboard4[20][0] = '\0';   /* This is 30 now */
  }

  count = 1;
  while(bboard4[count][0] != '\0') count++;
 
  strcpy(bboard4[count], sendbuf);
  bboard4[count+1][0] = '\0';
 
  savemess4();
  return 0;
} 
int savemess2()
{
  int fp;
  FILE *file;
  int count = 1;
 
   if((file = fopen("hotel.opmess" , "w")) == NULL) return -1;
 
  while(bboard2[count][0] != '\0') {
      sprintf(sendbuf, "%s\n", bboard2[count]);
      fputs(sendbuf, file);
      count ++;
  }
  fclose(file);
  return 0;
}
 
int savemess3()
{
  int fp;
  FILE *file;
  int count = 1;
 
   if((file = fopen("hotel.privmess" , "w")) == NULL) return -1;
 
  while(bboard3[count][0] != '\0') {
      sprintf(sendbuf, "%s\n", bboard3[count]);
      fputs(sendbuf, file);
      count ++;
  }
  fclose(file);
  return 0;
}

int savemess4()
{
  int fp;
  FILE *file;
  int count = 1;

   if((file = fopen("hotel.privmess2" , "w")) == NULL) return -1;

  while(bboard4[count][0] != '\0') {
      sprintf(sendbuf, "%s\n", bboard4[count]);
      fputs(sendbuf, file);
      count ++;
  }
  fclose(file);
  return 0;
}
 
  
void syncmess2()
{
     int fp;
     FILE *file;
     char string[BUFSIZE];
     char descrip[200];
     int count = 0;

     while(count != 24) {
       bboard2[count][0]= '\0';
       count++;
     }
     count = 0;

     if((fp=open("hotel.opmess",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
        return;
     }
 
     while(fgets(string, BUFSIZE, file) != NULL) {
       count ++;
       if (string[strlen(string)-1] == '\n')
         string[strlen(string)-1] = '\000';
       if (count < 21)
         strncpy(bboard2[count], string, BUFSIZE);
     }
     bboard2[count+1][0] = '\0';
     close(fp);
     fclose(file);
}

void syncmess3()
{
     int fp;
     FILE *file;
     char string[BUFSIZE];
     char descrip[200];
     int count = 0;

     while(count != 24) {
       bboard3[count][0]= '\0';
       count++;
     }
     count = 0;

     if((fp=open("hotel.privmess",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
        return;
     }
 
     while(fgets(string, BUFSIZE, file) != NULL) {
       count ++;
       if (string[strlen(string)-1] == '\n')
         string[strlen(string)-1] = '\000';
       if (count < 21)
         strncpy(bboard3[count], string, BUFSIZE);
     }
     bboard3[count+1][0] = '\0';
     close(fp);
     fclose(file);
}
 
void syncmess4()
{
     int fp;
     FILE *file;
     char string[BUFSIZE];
     char descrip[200];
     int count = 0;

     while(count != 24) {
       bboard4[count][0]= '\0';
       count++;
     }
     count = 0;

     if((fp=open("hotel.privmess2",0)) == -1) return;

     if((file=fdopen(fp, "r")) == NULL) {
        return;
     }
 
     while(fgets(string, BUFSIZE, file) != NULL) {
       count ++;
       if (string[strlen(string)-1] == '\n')
         string[strlen(string)-1] = '\000';
       if (count < 21)
         strncpy(bboard4[count], string, BUFSIZE);
     }
     bboard4[count+1][0] = '\0';
     close(fp);
     fclose(file);
}   
/* New Boards End */  

int notifymail(name)
     char *name;
{
  struct splayer *temp;
  for (temp=players; temp; temp=temp->next)
    if (!(strcasecmp(name, temp->name))) {
      sprintf(sendbuf, ">> A mystical hand reaches out from the sky and hands you a letter.\r\n  .z to read.  .E to erase.\r\n");
      sendtoplayer(temp, sendbuf);
    }
}

int notifyfriendexit(name, s)
     char *name;
     int s;
{
  struct splayer *temp;
  struct sfriend *blah;

  for (blah=pfriend; blah; blah=blah->next)
    if(!(strcasecmp(name, blah->friend)))
      for (temp=players; temp; temp=temp->next)
	if (!(strcasecmp(blah->name, temp->name))) {
	  sprintf(sendbuf,">> (%d) %s has disconnected from the system.\r\n",s,name);
	  sendtoplayer(temp, sendbuf);
	}
}

int notifyfriend(name, s)
     char *name;
     int s;
{
  struct splayer *temp;
  struct sfriend *blah;

  for (blah=pfriend; blah; blah=blah->next)
    if(!(strcasecmp(name, blah->friend)))
      for (temp=players; temp; temp=temp->next)
	if (!(strcasecmp(blah->name, temp->name))) {
          sprintf(sendbuf,">> (%d) %s has connected to the system.\r\n",s,name);
	  sendtoplayer(temp, sendbuf);
	}
}

int notifyrobbedplayer(object)
     char *object;
{
  struct splayer *temp;
  struct sobject *obj;

  for (obj=pobject;obj;obj=obj->next)
    if(!(strcasecmp(obj->name, object))) {
      
      for (temp=players; temp; temp=temp->next)
	if (!(strcasecmp(obj->cont, temp->name))) {
	  sprintf(sendbuf, ">> The %s you were carrying disappears in a puff of smoke!\r\n", object);
	  sendtoplayer(temp, sendbuf);
	}
    }
}

int notifygivenplayer(object, name)
     char *object;
     char *name;
{
  struct splayer *temp;
  struct sobject *obj;

  for (obj=pobject;obj;obj=obj->next)
    if(!(strcasecmp(obj->name, object))) {
      for (temp=players; temp; temp=temp->next)
	if (!(strcasecmp(obj->cont, temp->name))) {
          if(!isloggedin(name, temp->name)) { 
	    sprintf(sendbuf, ">> A mystical hand reaches out of the sky and hands you %s, \r\n>> or is it an Illusion.  Ask %s if its real or not\r\n", object,name);
	    sendtoplayer(temp, sendbuf);
          } else {
            sprintf(sendbuf, "Zpackage: %s has sent you an object named \"%s\". Do nothing to keep, type \".$X%s\" to return to owner",name,object,object);
            sendmail(CORE, temp, sendbuf);
          }
	}
    }
}


  int notifyreturn(object, name)
     char *object;
     char *name;
  {
  struct splayer *temp;
  struct sobject *obj;
 
  for (obj=pobject;obj;obj=obj->next)
    if(!(strcasecmp(obj->name, object))) {
      for (temp=players; temp; temp=temp->next)
        if (!(strcasecmp(obj->cont, temp->name))) {
          sprintf(sendbuf, ">> Zpackage: %s has been returned.\r\n", object);
          sendtoplayer(temp, sendbuf);
        }
    }
  }
 
int notifymove(obj)
     char *obj;
{
  struct sobject *temp;
  for(temp=pobject;temp;temp=temp->next) {
    if(!strcasecmp(temp->name,obj)) {
      if((temp->c_type == 'p'))
	notifyrobbedplayer(obj);
      else
	notifyrobbedchannel(obj);
    }
  }
}

int notifyrobbedchannel(object)
     char *object;
{
  struct sobject *obj;

  for (obj=pobject;obj;obj=obj->next)
    if(!(strcasecmp(obj->name, object))) {
      sprintf(sendbuf, ">> The %s disappears in a puff of smoke!\r\n",object);
      sendall(sendbuf, obj->cont, 0, NOMESG);
    }
}

int clearboard()  /* HotelGAME */
{
  int count1,count2;
  

  for (count1 = 1; count1 <= 5; count1++)
    for (count2 = 1; count2 <= 5; count2++)
      equus[count1][count2] = 0;
  strcpy(player1name, "nobody");
  strcpy(player2name, "nobody");
  player2num = 0;
  player1num = 0;
  win = 0;
  turn = 1;
}

int reqplayer(pplayer,num)
     struct splayer *pplayer;
     int num;
{
  struct splayer *tmpplayer;
  long timenoc;
  struct timeval tmptime;
  struct timezone tmpzone;
  int okay = 1;

  gettimeofday(&tmptime, &tmpzone);
   if (num ==1) {
    tmpplayer = lookup(player1num);
    if(tmpplayer == (struct splayer *)0)
      okay = 1;
    else {
      timenoc = tmptime.tv_sec - tmpplayer->idle;
      if (!strcasecmp(tmpplayer->name, player1name) && (timenoc <120) && (!strcmp(tmpplayer->channel, GAME))) okay = 0;
    }
  } else {
    tmpplayer = lookup(player2num);
    if(tmpplayer == (struct splayer *)0)
      okay = 1;
    else {
      timenoc = tmptime.tv_sec - tmpplayer->idle;
      if (!strcasecmp(tmpplayer->name, player2name) && (timenoc <120) && (!strcmp(tmpplayer->channel, GAME))) okay = 0;
    }
  }

  if(win!=0) okay = 1;

  if(okay==1) {
    if (num == 1) {
      strcpy(player1name, pplayer->name);
      player1num = pplayer->s;
      sprintf(sendbuf, ">> %s:  (%d) %s is now player 1.\r\n",GAME, player1num, player1name);
      sendall(sendbuf, pplayer->channel, 0, 0);
    } else {
      strcpy(player2name, pplayer->name);
      player2num = pplayer->s;
      sprintf(sendbuf, ">> %s:  (%d) %s is now player 2.\r\n",GAME, player2num, player2name);
      sendall(sendbuf, pplayer->channel, 0, 0);
    }
  } else {
   
    sprintf(sendbuf, ">> %s:  Player in use.\r\n",GAME);
    sendtoplayer(pplayer,sendbuf);
  }
  return 0;
}

int isinchannel(pplayer)
     struct splayer *pplayer;
{
  if(strcmp(pplayer->channel, GAME)) return 0; else return 1;
}

int isingame(pplayer)
     struct splayer *pplayer;
{
  if(!strcmp(pplayer->name,player1name) && (pplayer->s==player1num))
    return 1;
  else if(!strcmp(pplayer->name,player2name) && (pplayer->s==player2num))
    return 2;
  else
    return 0;
}
  
int isturn(pplayer)
     struct splayer *pplayer;
{
  if (turn == isingame(pplayer)) return 1; else return 0;
}


int seeboard(pplayer)
     struct splayer *pplayer;
{ 
  char p[3];
  p[0] = 'o';
  p[1] = ' ';
  p[2] = 'X'; 
  sprintf(sendbuf, "    1  2  3  4  5\r\n");
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "   ----------------                > EQUUS <   by subZero\r\n");
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, " A |%c%c|%c%c|%c%c|%c%c|%c%c|\r\n",p[equus[1][1]+1],p[equus[1][1]+1],p[equus[1][2]+1],p[equus[1][2]+1],p[equus[1][3]+1],p[equus[1][3]+1],p[equus[1][4]+1],p[equus[1][4]+1],p[equus[1][5]+1],p[equus[1][5]+1]);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "   |%c%c|%c%c|%c%c|%c%c|%c%c|     (X) Player 1: (%d) %s\r\n",p[equus[1][1]+1],p[equus[1][1]+1],p[equus[1][2]+1],p[equus[1][2]+1],p[equus[1][3]+1],p[equus[1][3]+1],p[equus[1][4]+1],p[equus[1][4]+1],p[equus[1][5]+1],p[equus[1][5]+1],player1num,player1name);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "   |--------------|     (o) Player 2: (%d) %s\r\n",player2num,player2name);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, " B |%c%c|%c%c|%c%c|%c%c|%c%c|\r\n",p[equus[2][1]+1],p[equus[2][1]+1],p[equus[2][2]+1],p[equus[2][2]+1],p[equus[2][3]+1],p[equus[2][3]+1],p[equus[2][4]+1],p[equus[2][4]+1],p[equus[2][5]+1],p[equus[2][5]+1]);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "   |%c%c|%c%c|%c%c|%c%c|%c%c|      COMMANDS:\r\n",p[equus[2][1]+1],p[equus[2][1]+1],p[equus[2][2]+1],p[equus[2][2]+1],p[equus[2][3]+1],p[equus[2][3]+1],p[equus[2][4]+1],p[equus[2][4]+1],p[equus[2][5]+1],p[equus[2][5]+1]);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "   |--------------|         .V[1-5] - rotate column down\r\n");
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, " C |%c%c|%c%c|%c%c|%c%c|%c%c|         .^[1-5] - rotate column up\r\n",p[equus[3][1]+1],p[equus[3][1]+1],p[equus[3][2]+1],p[equus[3][2]+1],p[equus[3][3]+1],p[equus[3][3]+1],p[equus[3][4]+1],p[equus[3][4]+1],p[equus[3][5]+1],p[equus[3][5]+1]);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "   |%c%c|%c%c|%c%c|%c%c|%c%c|         .>[A-E] - rotate row right\r\n",p[equus[3][1]+1],p[equus[3][1]+1],p[equus[3][2]+1],p[equus[3][2]+1],p[equus[3][3]+1],p[equus[3][3]+1],p[equus[3][4]+1],p[equus[3][4]+1],p[equus[3][5]+1],p[equus[3][5]+1]);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "   |--------------|         .<[A-E] - rotate row left\r\n");
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, " D |%c%c|%c%c|%c%c|%c%c|%c%c|         .%%[A-E][1-5] - place piece\r\n",p[equus[4][1]+1],p[equus[4][1]+1],p[equus[4][2]+1],p[equus[4][2]+1],p[equus[4][3]+1],p[equus[4][3]+1],p[equus[4][4]+1],p[equus[4][4]+1],p[equus[4][5]+1],p[equus[4][5]+1]);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "   |%c%c|%c%c|%c%c|%c%c|%c%c|         .0 - clear board\r\n",p[equus[4][1]+1],p[equus[4][1]+1],p[equus[4][2]+1],p[equus[4][2]+1],p[equus[4][3]+1],p[equus[4][3]+1],p[equus[4][4]+1],p[equus[4][4]+1],p[equus[4][5]+1],p[equus[4][5]+1]);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "   |--------------|         .1 - declare yourself player 1\r\n");
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, " E |%c%c|%c%c|%c%c|%c%c|%c%c|         .2 - declare yourself player 2\r\n",p[equus[5][1]+1],p[equus[5][1]+1],p[equus[5][2]+1],p[equus[5][2]+1],p[equus[5][3]+1],p[equus[5][3]+1],p[equus[5][4]+1],p[equus[5][4]+1],p[equus[5][5]+1],p[equus[5][5]+1]);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "   |%c%c|%c%c|%c%c|%c%c|%c%c|         ./ - see board\r\n",p[equus[5][1]+1],p[equus[5][1]+1],p[equus[5][2]+1],p[equus[5][2]+1],p[equus[5][3]+1],p[equus[5][3]+1],p[equus[5][4]+1],p[equus[5][4]+1],p[equus[5][5]+1],p[equus[5][5]+1]);
  sendtoplayer(pplayer,sendbuf);
  sprintf(sendbuf, "   ----------------         .= - see hi scores\r\n");
  sendtoplayer(pplayer,sendbuf);
  if (iswin()) {
    if (win == 1) {
      sprintf(sendbuf, ">> %s: Player 1: (%d) %s has won.\r\n",GAME,player1num,winnername);
      sendtoplayer(pplayer,sendbuf);
    } else {
      sprintf(sendbuf, ">> %s: Player 2: (%d) %s has won.\r\n",GAME,player2num,winnername);
      sendtoplayer(pplayer,sendbuf);
    }
  } else {
   if (turn == 1) {
      sprintf(sendbuf, ">> Turn: Player 1: (%d) %s\r\n",player1num,player1name);
      sendtoplayer(pplayer,sendbuf);
    } else {
      sprintf(sendbuf, ">> Turn: Player 2: (%d) %s\r\n",player2num,player2name);
      sendtoplayer(pplayer,sendbuf);
    }
 }
}

int showboard()
{ 
  char p[3];
  p[0] = 'o';
  p[1] = ' ';
  p[2] = 'X'; 
  sprintf(sendbuf, "    1  2  3  4  5\r\n");
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, "   ----------------                > EQUUS <   by subZero\r\n");
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, " A |%c%c|%c%c|%c%c|%c%c|%c%c|\r\n",p[equus[1][1]+1],p[equus[1][1]+1],p[equus[1][2]+1],p[equus[1][2]+1],p[equus[1][3]+1],p[equus[1][3]+1],p[equus[1][4]+1],p[equus[1][4]+1],p[equus[1][5]+1],p[equus[1][5]+1]);
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, "   |%c%c|%c%c|%c%c|%c%c|%c%c|     (X) Player 1: (%d) %s\r\n",p[equus[1][1]+1],p[equus[1][1]+1],p[equus[1][2]+1],p[equus[1][2]+1],p[equus[1][3]+1],p[equus[1][3]+1],p[equus[1][4]+1],p[equus[1][4]+1],p[equus[1][5]+1],p[equus[1][5]+1],player1num,player1name);
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, "   |--------------|     (o) Player 2: (%d) %s\r\n",player2num,player2name);
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, " B |%c%c|%c%c|%c%c|%c%c|%c%c|\r\n",p[equus[2][1]+1],p[equus[2][1]+1],p[equus[2][2]+1],p[equus[2][2]+1],p[equus[2][3]+1],p[equus[2][3]+1],p[equus[2][4]+1],p[equus[2][4]+1],p[equus[2][5]+1],p[equus[2][5]+1]);
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, "   |%c%c|%c%c|%c%c|%c%c|%c%c|      COMMANDS:\r\n",p[equus[2][1]+1],p[equus[2][1]+1],p[equus[2][2]+1],p[equus[2][2]+1],p[equus[2][3]+1],p[equus[2][3]+1],p[equus[2][4]+1],p[equus[2][4]+1],p[equus[2][5]+1],p[equus[2][5]+1]);
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, "   |--------------|         .V[1-5] - rotate column down\r\n");
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, " C |%c%c|%c%c|%c%c|%c%c|%c%c|         .^[1-5] - rotate column up\r\n",p[equus[3][1]+1],p[equus[3][1]+1],p[equus[3][2]+1],p[equus[3][2]+1],p[equus[3][3]+1],p[equus[3][3]+1],p[equus[3][4]+1],p[equus[3][4]+1],p[equus[3][5]+1],p[equus[3][5]+1]);
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, "   |%c%c|%c%c|%c%c|%c%c|%c%c|         .>[A-E] - rotate row right\r\n",p[equus[3][1]+1],p[equus[3][1]+1],p[equus[3][2]+1],p[equus[3][2]+1],p[equus[3][3]+1],p[equus[3][3]+1],p[equus[3][4]+1],p[equus[3][4]+1],p[equus[3][5]+1],p[equus[3][5]+1]);
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, "   |--------------|         .<[A-E] - rotate row left\r\n");
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, " D |%c%c|%c%c|%c%c|%c%c|%c%c|         .%%[A-E][1-5] - place piece\r\n",p[equus[4][1]+1],p[equus[4][1]+1],p[equus[4][2]+1],p[equus[4][2]+1],p[equus[4][3]+1],p[equus[4][3]+1],p[equus[4][4]+1],p[equus[4][4]+1],p[equus[4][5]+1],p[equus[4][5]+1]);
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, "   |%c%c|%c%c|%c%c|%c%c|%c%c|         .0 - clear board\r\n",p[equus[4][1]+1],p[equus[4][1]+1],p[equus[4][2]+1],p[equus[4][2]+1],p[equus[4][3]+1],p[equus[4][3]+1],p[equus[4][4]+1],p[equus[4][4]+1],p[equus[4][5]+1],p[equus[4][5]+1]);
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, "   |--------------|         .1 - declare yourself player 1\r\n");
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, " E |%c%c|%c%c|%c%c|%c%c|%c%c|         .2 - declare yourself player 2\r\n",p[equus[5][1]+1],p[equus[5][1]+1],p[equus[5][2]+1],p[equus[5][2]+1],p[equus[5][3]+1],p[equus[5][3]+1],p[equus[5][4]+1],p[equus[5][4]+1],p[equus[5][5]+1],p[equus[5][5]+1]);
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, "   |%c%c|%c%c|%c%c|%c%c|%c%c|         ./ - see board\r\n",p[equus[5][1]+1],p[equus[5][1]+1],p[equus[5][2]+1],p[equus[5][2]+1],p[equus[5][3]+1],p[equus[5][3]+1],p[equus[5][4]+1],p[equus[5][4]+1],p[equus[5][5]+1],p[equus[5][5]+1]);
  sendall(sendbuf, GAME,0,0);
  sprintf(sendbuf, "   ----------------         .= - see hi scores\r\n");
  sendall(sendbuf, GAME,0,0);
  if (iswin()) {
    if (win == 1) {
      sprintf(sendbuf, ">> %s: Player 1: (%d) %s has won.\r\n",GAME,player1num,winnername);
      sendall(sendbuf, GAME,0,0);
    } else {
      sprintf(sendbuf, ">> %s: Player 2: (%d) %s has won.\r\n",GAME,player2num,winnername);
      sendall(sendbuf, GAME,0,0);
    }
  } else {
   if (turn == 1) {
      sprintf(sendbuf, ">> Turn: Player 1: (%d) %s\r\n",player1num,player1name);
      sendall(sendbuf, GAME,0,0);
    } else {
      sprintf(sendbuf, ">> Turn: Player 2: (%d) %s\r\n",player2num,player2name);
      sendall(sendbuf, GAME,0,0);
    }
 }
}

int rotdown(num)
     int num;
{
  int temp;
  temp = equus[5][num];
  equus[5][num] = equus[4][num];
  equus[4][num] = equus[3][num];
  equus[3][num] = equus[2][num];
  equus[2][num] = equus[1][num];
  equus[1][num] = temp;
}

int rotup(num)
     int num;
{
  int temp;
  temp = equus[1][num];
  equus[1][num] = equus[2][num];
  equus[2][num] = equus[3][num];
  equus[3][num] = equus[4][num];
  equus[4][num] = equus[5][num];
  equus[5][num] = temp;
}

int rotleft(num)
     int num;
{
  int temp;
  temp = equus[num][1];
  equus[num][1] = equus[num][2];
  equus[num][2] = equus[num][3];
  equus[num][3] = equus[num][4];
  equus[num][4] = equus[num][5];
  equus[num][5] = temp;
}

int rotright(num)
     int num;
{
  int temp;
  temp = equus[num][5];
  equus[num][5] = equus[num][4];
  equus[num][4] = equus[num][3];
  equus[num][3] = equus[num][2];
  equus[num][2] = equus[num][1];
  equus[num][1] = temp;
}

int putpiece(pplayer,num1,num2)
     struct splayer *pplayer;
     int num1,num2;
{
  char p[6];
  p[1] = 'A'; p[2] = 'B'; p[3] = 'C'; p[4] = 'D'; p[5] = 'E'; 
  if (equus[num1][num2] == 0) {
     if (isingame(pplayer) == 1)
      equus[num1][num2] = 1;
    else 
      equus[num1][num2] = -1;
  } else {    
    sprintf(sendbuf, ">> %s:  That space is not open!\r\n", GAME);
    sendtoplayer(pplayer,sendbuf);
    return -1;
  }
  return 0;
}

int iswin()
{
  return win;
}

int addwin(line)
     int line;
{
  int c1;
  int x, y, z;
  char name[40];
  if(line == 1) strcpy(name,player1name); else strcpy(name, player2name);
  z = 0;
  for(x=1; x<=100; x++)
    if(!strcasecmp(name,hiname[x])) {
      hiscore[x]++;
      z = 1;
    }
  if (z==0) {
    if(hiscore[100] > 1) return;
    else {
      strcpy(hiname[100], name);
      hiscore[100] = 1;
    }
  }

  x = 0;
  while (x== 0) {
    x = 1;
    for (y=1; y<=99; y++)
      if (hiscore[y] < hiscore[y+1]) {
	hiscore[0] = hiscore[y];
	strcpy(hiname[0], hiname[y]);
	hiscore[y] = hiscore[y+1];
	strcpy(hiname[y], hiname[y+1]);
	hiscore[y+1] = hiscore[0];
	strcpy(hiname[y+1], hiname[0]);
	x = 0;
      }
  }

  sprintf(sendbuf, ">> %s is now ranked at #%d.\r\n",name,placenum(name));
  sendall(sendbuf, GAME, 0, 0);

  savescore();
}


int pushpage(pplayer, text)
     struct splayer *pplayer;
     char *text;
{
  int count;
  for (count = RECALL_SIZE - 1; count > 0; count --)
    strcpy(pplayer->pagebuffer[count], pplayer->pagebuffer[count-1]);
  strcpy(pplayer->pagebuffer[0], text);
}

int recallpages(pplayer)
     struct splayer *pplayer;
{
  int count;
  for (count = RECALL_SIZE - 1; count >= 0; count--)
    if(pplayer->pagebuffer[count][0] != '\0') {
      sprintf(sendbuf, ">> RECALL:  %s\r\n", pplayer->pagebuffer[count]);
      sendtoplayer(pplayer,sendbuf);
    }
}

int placenum(name)
     char *name;
{
  int x,y;
  for(x=0;x<100;x++)
    if(!strcasecmp(name, hiname[x]))
      y=x;
  return y;
}


int checkwin(num)
     int num;
{
  int s, tot;
  int count;
  if (num == 1)
    s = 1;
  else
    s = -1;
  tot = s*5;

  for(count=1;count<=5;count++)
    if((equus[1][count]+equus[2][count]+equus[3][count]+equus[4][count]+equus[5][count]) == tot) {
      win = num;
      if (num == 1) strcpy(winnername, player1name); else strcpy(winnername, player2name);
      return win;
    }

  for(count=1;count<=5;count++)
    if((equus[count][1]+equus[count][2]+equus[count][3]+equus[count][4]+equus[count][5]) == tot) {
      win = num;
      if (num == 1) strcpy(winnername, player1name); else strcpy(winnername, player2name);
      return win;
    }
  if((equus[1][1]+equus[2][2]+equus[3][3]+equus[4][4]+equus[5][5]) == tot) {
    win = num;
    if (num == 1) strcpy(winnername, player1name); else strcpy(winnername, player2name);
    return win;
  }
  if((equus[1][5]+equus[2][4]+equus[3][3]+equus[4][2]+equus[5][1]) == tot) {
    win = num;
    if (num == 1) strcpy(winnername, player1name); else strcpy(winnername, player2name);
    return win;
  }
  return 0;
}

int strcasestr(str1, patt)
     char *str1;
     char *patt;
{
  int sz;
  int count;

  sz = strlen(str1) - strlen(patt);
  if(sz<0) return 0;
 
  for(count = 0;count<=sz;count++) {
    if(!strncasecmp(str1,patt,strlen(patt))) return 1;
    str1++;
  }
  return 0;
}
  
int fpeerr()
{
  fpe = 1;
  return 0;
}


double docalc(pplayer,buf)
     struct splayer *pplayer;
     char *buf;
{
  double num1 = 0.0;
  double num2 = 0.0;
  double ans  = 0.0;
  char *endnum;
  char *funcptr;

  fpe = 0;
 
  signal(SIGFPE, (void *)fpeerr);
  if (!isdigit(*buf) && (*buf != '-') && (*buf != '.') && (*buf != 'x')) {
    funcptr = buf;
    while((!isdigit(*buf)) && (*buf != '.') && (*buf != '-') && (*buf != '\0') && (*buf !='x'))
      buf++;    /* cycle through function name to the number */

    if(*buf == 'x')
      num1 = pplayer->lastans;
    else
      num1 = atof(buf);
  
    if((fpe==1)) {
      sendtoplayer(pplayer, ">> 100 - Aborted calculation.\r\n");
      return -1;
    }
    
    switch(*funcptr) {
    case 'l':  /* log base 10 */
      ans = log10(num1);
      break;

    case 'n': /* nat log */
      ans = log(num1);
      break;

    case 'c': /* cosine */
      ans = cos(num1);
      break;
     
    case 't': /* tan */
      ans = tan(num1);
      break;

    case 's': 
      if(*(buf+1) == 'i')
	ans = sin(num1);
      else
	ans = sqrt(num1);
      break;

    default:
      sendtoplayer(pplayer, ">> invalid function.\r\n");
      break;
    }
   
    if (fpe) return -1;

  } else {  /* its a binary operation */
 
    if (*buf == 'x') {
      num1 = pplayer->lastans;
      endnum = (buf + 1);
    } else
      num1 = strtod(buf, &endnum);

    if((endnum == buf) || fpe) {
      sendtoplayer(pplayer, ">> Aborted calculation.\r\n");
      return -1;    
    }

    buf = endnum;

    while ((*buf != '+') && (*buf != '-') && (*buf != '*') && (*buf != '/') && (*buf != '%') && (*buf != '^') && (*buf != '\0'))
      buf++;


    funcptr = buf;
    buf++;
    
    while((*buf != '-') && (*buf != '.') && !isdigit(*buf) && (*buf != 'x') && (*buf != '\0'))
      buf++;

    if (*buf == 'x')
      num2 = pplayer->lastans;
    else
      num2 = strtod(buf, &endnum);

    if(fpe) {
      sendtoplayer(pplayer, ">> Aborted calculation.\r\n");
      return -1;
    }
    
    switch(*funcptr) {
    case '+':
      ans = num1 + num2;
      break;

    case '-':
      ans = num1 - num2;
      break;

    case '*':
      ans = num1 * num2;
      break;

    case '/':
      ans = num1 / num2;
      break;
    
    case '%':
      ans = (int) num1 % (int) num2;
      break;

    case '^':
      ans = pow(num1, num2);
      break;

    }

    if(fpe) {
      sendtoplayer(pplayer, ">> floating point exception.\r\n");
      return -1;
    }

  }

  sprintf(sendbuf, "--> %f\r\n", ans);
  sendtoplayer(pplayer,sendbuf);

  pplayer->lastans = ans;
}

      
 
int changeroomowner(room, name)
     char *room;
     char *name;
{
  struct sroom *temp;
  
  for(temp = proom; temp; temp=temp->next) {
    if(!strcmp(temp->name, room)) {
      strcpy(temp->owner, name);
      return 1;
    }
  }
}

int changeverbowner(verb, name)
     char *verb;
     char *name;
{
  struct sverb *temp;
  
  for(temp = pverb; temp; temp=temp->next) {
    if(!strcasecmp(temp->verbname, verb)) {
      strcpy(temp->owner, name);
      return 1;
    }
  }
}

int changeobjowner(obj, name)
     char *obj;
     char *name;
{
  struct sobject *temp;
  
  for(temp = pobject; temp; temp=temp->next) {
    if(!strcasecmp(temp->name, obj)) {
      strcpy(temp->owner, name);
      changeactionowner(obj, name);
      return 1;
    }
  }
}

int changeactionowner(obj, name)
     char *obj;
     char *name;
{
  struct slink *temp;
  
  for(temp = plink; temp; temp=temp->next) {
    if(!strcasecmp(temp->object, obj)) {
      strcpy(temp->owner, name);
    }
  }
}

tossplayers(maxline)
   int maxline;
{
   struct splayer *tmp;

   for (tmp = players->next; tmp; tmp=tmp->next) {
     if(tmp->ln > maxline) {
         removeplayer(tmp);
         tmp = players->next;
      }
    }
}

int usurpplayer(name, ln) /* used for tossing players who are already logged in */
     char *name;
     int ln;
{
  struct splayer *pplayer;

  for(pplayer = players->next; pplayer; pplayer=pplayer->next) {
    if((!strcasecmp(name, pplayer->name)) && pplayer->ln != ln) {
      sprintf(sendbuf, ">> (%d) %s has been usurped by line %d.\r\n", pplayer->s, pplayer->name, ln);
      sendall(sendbuf, "*", 0, MESS|NEWBIE);
      removeplayer(pplayer);
      pplayer = players->next;
    }
  }
}

int makelower(buf)
     char *buf;
{
  while(*buf != '\000') {
    if(isupper(*buf)) {
      *buf = tolower(*buf);
    }
    buf++;
  }
}

int issanct(pplayer, room)
     struct splayer *pplayer;
     char *room;
{
  struct sroom *temp;

  if(pplayer->seclevel == SUPREME) return 0;
  for(temp = proom; temp; temp=temp->next) {
    if(!strcmp(temp->name, room)) {
      if((temp->sanct) && (strcasecmp(temp->owner, pplayer->name)) && (!isfriend(temp->owner, pplayer->name)))
	return 1;
      else
	return 0;
    }
  }
  return 0;
}

    
int togsanct(pplayer)
     struct splayer *pplayer;
{
  struct sroom *temp;

  for(temp = proom; temp; temp=temp->next) {
    if(!strcmp(temp->name, pplayer->channel)) {
      temp->sanct = 1 - temp->sanct;
      sprintf(sendbuf, ">> %s:  %s is now %s.\r\n", CORE, temp->name, (temp->sanct) ? "a sanctuary" : "no longer a sanctuary");
      sendtoplayer(pplayer, sendbuf);
      return 0;
    }
  }
  sendtoplayer(pplayer, ">> room error.\r\n");
  return 0;
}

int authuser(pplayer)
  struct splayer *pplayer;
{
  struct splayer *tmp;

  for(tmp = players->next; tmp; tmp=tmp->next) {
     if(((long)tmp == (long)pplayer) && (pplayer->s == tmp->s))
     return 1;
  }
  return 0;
}

int unsetuseraddr(pplayer, site) 
  struct splayer *pplayer;
  char *site;
{
  char buf[BUFSIZE];
  char *p;

  strcpy(buf, pplayer->useraddr);
  p = buf;

  while(*p != '\0') {
    if(*p == ' ')
      *p = '\0';
    else
      p++;
  }

  free(pplayer->useraddr);
  pplayer->useraddr = allocmem(strlen(buf));
  strcpy(pplayer->useraddr, buf);

  return 0;
}

int setuseraddr(pplayer) 
  struct splayer *pplayer;
{
  char buf[BUFSIZE];
  char *p;

  unsetuseraddr(pplayer);

  sprintf(buf, "%s (%s)", pplayer->useraddr, pplayer->realonfrom);

  free(pplayer->useraddr);
  pplayer->useraddr = allocmem(strlen(buf));
  strcpy(pplayer->useraddr, buf);

  return 0;
}


finishlogin1(tmp)
     struct splayer *tmp;
{
  tmp->moretype = none;
  welcomeplayer2(tmp);
  sprintf(sendbuf, ">> Welcome to %s.  Channel now: %s\r\n",NAME,MAIN);
  sendtoplayer(tmp,sendbuf);
  togplayer(tmp,NEWBIE);
  sprintf(sendbuf, ">> %s %s from %s has connected on line %d\r\n"
	  ,ARRIVAL,tmp->name,tmp->onfrom,tmp->s);
  sendall(sendbuf, "*", 0, MESS|NEWBIE);
  strcpy(tmp->channel, MAIN);
  doroom(tmp);
  /* wizardson(tmp); */ 
}
